// ApercuView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "ApercuView.h"

#include "Options.h"
#include "Decomp.h"
#include "IOFichier.h"

#include "Fichier.h"
#include "MuzipArc.h"
#include "MuzipDoc.h"
#include "MuzipView.h"

#include <GUnicode.h>


class CApercuTexte : public CApercu
{
public:  // Hritage
	
	CApercuTexte(CApercuView* pView, LPCTSTR pszFichier, bool fRTF)
		: CApercu(pView, pszFichier), m_fRTF(fRTF)
	{
		m_pView->m_rtf.ShowWindow(SW_SHOW);
	}
	
	UINT GetToolBarID() const { return IDR_APERCUTXT; }
	
	void MAJ();
	void GetInfoText(CString& s);
	void OnSetFont();
	
	bool m_fRTF;
	
	
protected:  // Interne
	
	static DWORD CALLBACK prcMAJTexte(CApercuView* pView, BYTE* pbBuffer, long len, long* plen);
};


class CApercuBitmap : public CApercu
{
public:  // Hritage
	
	CApercuBitmap(CApercuView* pView, LPCTSTR pszFichier)
		: CApercu(pView, pszFichier)
	{
		m_hBmp = (HBITMAP)::LoadImage(oApp.m_hInstance, m_pszFichier, IMAGE_BITMAP,
			0,0, LR_LOADFROMFILE);
		if (m_hBmp)  m_pView->m_bmp.SetBitmap(m_hBmp);
		m_pView->m_bmp.ShowWindow(SW_SHOW);
	}
	~CApercuBitmap()
	{
		if (m_hBmp) {
			if (IsWindow(m_pView->m_bmp))  m_pView->m_bmp.SetBitmap(NULL);
			DeleteObject(m_hBmp);
		}
	}
	
	void GetInfoText(CString& s);
	
	
public:  // Donnes
	
	HBITMAP m_hBmp;
};


class CApercuPerso : public CApercu
{
public:  // Hritage
	
	CApercuPerso(CApercuView* pView, LPCTSTR pszFichier)
		: CApercu(pView, pszFichier), m_hBmp(NULL) {}
	
	~CApercuPerso()
	{
		if (m_hBmp) {
			if (IsWindow(m_pView->m_bmp))  m_pView->m_bmp.SetBitmap(NULL);
			DeleteObject(m_hBmp);
		}
	}
	
	void Init();
	
	
protected:  // Donnes
	
	HBITMAP m_hBmp;
};


class CApercuIcoCur : public CApercuPerso
{
public:  // Hritage
	
	CApercuIcoCur(CApercuView* pView, LPCTSTR pszFichier, bool fCurseur);
	
	bool m_fCurseur;
};


class CApercuPolice : public CApercu
{
public:  // Hritage
	
	CApercuPolice(CApercuView* pView, LPCTSTR pszFichier);
	~CApercuPolice()
		{
			RemoveFontResource(m_pszFichier);
		}
	
	UINT GetToolBarID() const { return IDR_APERCUPOLICE; }
	
	void MAJ();
	void GetInfoText(CString& s);
	void OnSetFont() {}
	void OnSetPoliceFont();
	
	
protected:  // Donnes
	
	CFont m_fnt;
	
	static WORD  Swap(WORD&  w);
	static DWORD Swap(DWORD& dw);
};



IMPLEMENT_DYNCREATE(CApercuView, CFormView)
BEGIN_MESSAGE_MAP(CApercuView, CFormView)
	//{{AFX_MSG_MAP(CApercuView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDCLBL_MAJ, OnMAJ)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Indicateurs sur la barre d'tat
static const UINT s_StatusBar[] =
{
	ID_APERCUINDIC_FICHIER,
	ID_APERCUINDIC_INFO,
};


// Constructeur
CApercuView::CApercuView() : CFormView(IDD)
{
	m_pApercu  = NULL;
	m_fRetour  = true;
	m_fDOS     = false;
	m_pFichier = NULL;
	m_idTlb    = 0;
	
	//{{AFX_DATA_INIT(CApercuView)
	//}}AFX_DATA_INIT
}

// Destructeur
CApercuView::~CApercuView()
{
	m_fr.Close();
	delete m_pApercu;
}


// Contrles
void CApercuView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CApercuView)
	DDX_Control(pDX, IDCLBL_MAJ, m_lblMAJ);
	DDX_Control(pDX, IDCRTF,     m_rtf);
	DDX_Control(pDX, IDCBMP,     m_bmp);
	//}}AFX_DATA_MAP
}


// Processus de cration
BOOL CApercuView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	if (!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
		return FALSE;
	
	SetScrollSizes(MM_TEXT, CSize(0,0));
	return TRUE;
}

// Cration
int CApercuView::OnCreate(CREATESTRUCT* pcs)
{
	if (CFormView::OnCreate(pcs)==-1)  return -1;
	
	SetScrollSizes(MM_TEXT, CSize(0,0));
	
	if (!m_tlb.Create(this, WS_CHILD | CBRS_TOOLTIPS | CBRS_ALIGN_TOP | CBRS_SIZE_FIXED))
		return -1;
	
	if (!m_stb.CreateEx(this, SBT_TOOLTIPS, WS_CHILD) ||
	    !m_stb.SetIndicators(s_StatusBar,
	    sizeof(s_StatusBar)/sizeof(UINT)))  return -1;
	
	// Passer la vue au document
	GetDocument()->m_papr = this;
	
	return 0;
}

// Destruction
void CApercuView::OnDestroy()
{
	CFormView::OnDestroy();
	
	GetDocument()->m_papr = NULL;
}


// Redimensionnement
void CApercuView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);
	Redimensionner();
}
void CApercuView::Redimensionner()
{
	if (::IsWindow(m_rtf)) {
		// Redimensionner les contrles:
		
		CRect rc;
		GetClientRect(rc);
		const int cy = rc.bottom;
		
		// Label de mise  jour
		m_lblMAJ.MoveWindow(rc);
		
		// Barre d'outils
		rc.top    = 0;
		if (m_idTlb) {
			rc.bottom = m_tlb.CalcFixedLayout(TRUE, TRUE).cy;
			m_tlb.MoveWindow(rc);
			m_tlb.RecalcLayout();
		}else
			rc.bottom = 0;
		
		// Barre d'tat
		rc.top    = rc.bottom;
		rc.bottom = rc.top + m_stb.CalcFixedLayout(FALSE, TRUE).cy;
		m_stb.MoveWindow(rc);
		
		// Contrles divers
		rc.top    = rc.bottom+2;
		rc.bottom = cy;
		m_rtf.MoveWindow(rc);
		m_bmp.SetWindowPos(NULL, rc.left,rc.top, 0,0, SWP_NOZORDER | SWP_NOSIZE);
	}
}


// Mettre  jour l'aperu
void CApercuView::OnMAJ()
{
	GetDocument()->m_plst->OnApercu();
}

// Initialiser l'apercu
void CApercuView::SetApercu(CFichier* pFichier)
{
	m_lblMAJ.ShowWindow(SW_HIDE);
	
	if (pFichier==m_pFichier)  return;
	
	m_fr.Close();
	delete m_pApercu;
	m_pApercu  = NULL;
	m_pFichier = pFichier;
	
	SetRedraw(FALSE);
	
	// Masquer tout
	m_tlb.ShowWindow(SW_HIDE);
	m_stb.ShowWindow(SW_HIDE);
	m_rtf.ShowWindow(SW_HIDE);
	m_bmp.ShowWindow(SW_HIDE);
	
	if (pFichier) {
		
		// Mettre  jour la barre d'tat
		m_stb.SetPaneText(m_stb.CommandToIndex(ID_APERCUINDIC_FICHIER),
			pFichier->m_pszNom);
		
		TCHAR pszTemp[MAX_PATH];
		if (e_opt.GetDossierTemp(pszTemp)) {
			// Dcompresser le fichier
			DECOMP::e_pfr = &pFichier->m_pArc->m_fr;
			LPTSTR pszDest;
			
			if (pFichier->ArchiveExtraireSuite(pszTemp, &pszDest)) {
				
				if (PathMatchSpec(pszDest, _T("*.bmp"))) {
					// Image bitmap
					m_pApercu = new CApercuBitmap(this, pszDest);
					
				}else if (PathMatchSpec(pszDest, _T("*.ico"))) {
					// Icne
					m_pApercu = new CApercuIcoCur(this, pszDest, false);
					
				}else if (PathMatchSpec(pszDest, _T("*.cur"))) {
					// Curseur
					m_pApercu = new CApercuIcoCur(this, pszDest, true);
					
				}else if (PathMatchSpec(pszDest, _T("*.rtf"))) {
					// Texte RTF
					
					if (m_fr.Open(pszDest))
						m_pApercu = new CApercuTexte(this, pszDest, true);
					
				}else if (PathMatchSpec(pszDest, _T("*.ttf"))) {
					// Police TrueType
					m_pApercu = new CApercuPolice(this, pszDest);
					
				}else if (e_opt.m_fApercuDefautTexte ||
				          PathMatchSpec(pszDest, _T("*.txt"))) {
					// Par dfaut: texte
					
					if (m_fr.Open(pszDest))
						m_pApercu = new CApercuTexte(this, pszDest, false);
				}
				delete [] pszDest;
				
				if (m_pApercu) {
					
					// Afficher la barre d'tat et masquer le label
					m_stb   .ShowWindow(SW_SHOW);
					m_lblMAJ.ShowWindow(SW_HIDE);
					
					// Afficher la barre d'outils
					m_idTlb = m_pApercu->GetToolBarID();
					m_tlb.ShowWindow((m_idTlb) ? SW_SHOW : SW_HIDE);
					m_tlb.LoadToolBar(m_idTlb);
					m_pApercu->MAJ();
					
					// Remplir la zone d'informations dans la barre d'tat
					CString s;
					m_pApercu->GetInfoText(s);
					const int nIndex = m_stb.CommandToIndex(ID_APERCUINDIC_INFO);
					m_stb.SetPaneStyle(nIndex, (s.IsEmpty())
						? SBT_NOBORDERS : SBPS_STRETCH);
					m_stb.SetPaneText(nIndex, s);
					
					
					// Remettre tout  jour
					oApp.OnIdle(0);
				}
			}
			oApp.s_fMsg = true;
		}
	}
	Redimensionner();
	
	SetRedraw();
	RedrawWindow();
}

// Il est possible d'afficher l'aperu,
// mais on ne le fait pas pour l'instant
void CApercuView::PeutApercu()
{
	SetRedraw(FALSE);
	
	// Masquer tout sauf le label "Cliquez ici pour afficher l'aperu"
	m_tlb   .ShowWindow(SW_HIDE);
	m_stb   .ShowWindow(SW_HIDE);
	m_rtf   .ShowWindow(SW_HIDE);
	m_bmp   .ShowWindow(SW_HIDE);
	m_lblMAJ.ShowWindow(SW_SHOW);
	
	SetRedraw();
	RedrawWindow();
}



//*** CApercuTexte

// Mettre  jour
void CApercuTexte::MAJ()
{
	m_pView->m_fr.Seek(0, FILE_BEGIN);
	
	EDITSTREAM es;
	es.dwCookie    = (DWORD)m_pView;
	es.pfnCallback = (EDITSTREAMCALLBACK)prcMAJTexte;
	
	CRichEditCtrl &rtf = m_pView->m_rtf;
	rtf.SetWindowText(NULL);
	rtf.SetTargetDevice(NULL, !m_pView->GetDocument()->m_papr->m_fRetour);
	rtf.SetFont(&CApp::s_fntVoir);
	rtf.StreamIn((m_fRTF) ? SF_RTF : SF_TEXT, es);
	rtf.RedrawWindow();
}

// Rcuprer les informations
void CApercuTexte::GetInfoText(CString& s)
{
	s.Format(IDS_APERCU_TEXTE, m_pView->m_rtf.GetLineCount());
}

// Dfinition de la police
void CApercuTexte::OnSetFont()
{
	if (!m_fRTF)  CApercu::OnSetFont();
}

// Lecture de fichier RTF
DWORD CALLBACK CApercuTexte::prcMAJTexte(CApercuView* pView, BYTE* pbBuffer, long len, long* plen)
{
	*plen = pView->m_fr.ReadLen(pbBuffer, len);
	if (!*plen && !pView->m_fr.IsEOF())  return 1;
	
	// Convertir de OEM en ASCII si ncessaire
	if (pView->m_fDOS)  OemToCharBuffA((LPSTR)pbBuffer, (LPSTR)pbBuffer, *plen);
	
	return 0;
}



//*** Visualiseurs

// Destructeur
CApercu::~CApercu()
{
	FichierSupprimer(m_pszFichier, false);
}

// ID de barre d'outils
UINT CApercu::GetToolBarID() const
{
	return IDR_APERCU;
}

// Dfinir la police
void CApercu::SetFont(CFont* pFont)
{
	CRichEditCtrl &rtf = m_pView->m_rtf;
	
	// Dfinir la police
	rtf.SetFont(pFont, FALSE);
	
	// Redessiner le contrle RTF en le redimensionnant deux fois
	// (une fois pour redessiner, une autre fois
	// pour rendre au contrle sa taille d'origine)
	// Cela est ncessaire car le contrle doit refaire la justification
	CRect rc;
	rtf.GetWindowRect(rc);
	m_pView->ScreenToClient(rc);
	rc.right--;
	rtf.MoveWindow(rc, FALSE);
	rc.right++;
	rtf.MoveWindow(rc, TRUE);
}

// Dfinition de la police
void CApercu::OnSetFont()
{
	SetFont(&oApp.s_fntVoir);
}

// Bitmap
void CApercuBitmap::GetInfoText(CString& s)
{
	BITMAP bm;
	if (!::GetObject(m_hBmp, sizeof(bm), &bm))  return;
	
	s.Format(IDS_APERCU_BITMAP,
		bm.bmWidth,bm.bmHeight, bm.bmBitsPixel,
		(bm.bmBitsPixel<=24) ? 1L<<bm.bmBitsPixel : 1L<<24);
}

//*** CApercuPerso et classes drives

// Initialisation
void CApercuPerso::Init()
{
	if (m_hBmp)  m_pView->m_bmp.SetBitmap(m_hBmp);
	m_pView->m_bmp.ShowWindow(SW_SHOW);
}

// Icnes
CApercuIcoCur::CApercuIcoCur(CApercuView* pView, LPCTSTR pszFichier, bool fCurseur)
	: CApercuPerso(pView, pszFichier), m_fCurseur(fCurseur)
{
	// Compter et charger les icnes grandes et petites
	const UINT nbIcone = ExtractIconEx(m_pszFichier, -1, NULL, NULL, 0);
	HICON *const phiG = new HICON[nbIcone];
	HICON *const phiP = (fCurseur) ? NULL : new HICON[nbIcone];
	ExtractIconEx(m_pszFichier, 0, phiG,phiP, nbIcone);
	
	const HDC hDC = CreateCompatibleDC(NULL);
	if (hDC) {
		const int cEspace = 10;
		
		const int cxG = GetSystemMetrics(SM_CXICON);
		const int cyG = GetSystemMetrics(SM_CYICON);
		const int cxP = GetSystemMetrics(SM_CXSMICON);
		const int cyP = GetSystemMetrics(SM_CYSMICON);
		
		const int cx = ((fCurseur) ? cxG+cEspace : cxG+cEspace+cxP+cEspace)*nbIcone - cEspace;
		const int cy = cyG;
		
		// Crer la bitmap et dessiner dedans les icnes des deux tailles
		// Pour les curseurs on ne dessine que les grandes
		m_hBmp = CreateBitmap(cx,cy, 1,GetDeviceCaps(hDC, BITSPIXEL), NULL);
		if (m_hBmp) {
			const HBITMAP holdBmp = (HBITMAP)SelectObject(hDC, m_hBmp);
			FillRect(hDC, CRect(0,0,cx,cy), (HBRUSH)GetStockObject(WHITE_BRUSH));
			
			int x = 0;
			for (UINT iIcone=0; iIcone<nbIcone; iIcone++) {
				DrawIconEx(hDC, x,0, phiG[iIcone], cxG,cyG, 0, NULL, DI_NORMAL);
				x += cxG + cEspace;
				DestroyIcon(phiG[iIcone]);
				if (!fCurseur) {
					DrawIconEx(hDC, x,0, phiP[iIcone], cxP,cyP, 0, NULL, DI_NORMAL);
					x += cxP + cEspace;
					DestroyIcon(phiP[iIcone]);
				}
			}
			SelectObject(hDC, holdBmp);
		}
		DeleteDC(hDC);
	}
	
	delete [] phiG;
	delete [] phiP;
	
	Init();
}



//*** CApercuPolice


// Transformation de MSB en LSB
// (les fichiers TTF sont en ordre Motorola)
WORD CApercuPolice::Swap(WORD& w)
{
	return w = (WORD)(((w & 0x00FF)<<8) | (w>>8));
}
DWORD CApercuPolice::Swap(DWORD& dw)
{
	return dw =
		((dw & 0x000000FF)<<24) |
		((dw & 0x0000FF00)<< 8) |
		((dw & 0x00FF0000)>> 8) |
		( dw              >>24);
}


// Constructeur
CApercuPolice::CApercuPolice(CApercuView* pView, LPCTSTR pszFichier) : CApercu(pView, pszFichier)
{
	// Installer la police
	if (AddFontResource(m_pszFichier)<1)  return;
	SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0,0);
	
	LOGFONT lf;
	ZeroMemory(&lf, sizeof(lf));
	
	CFileRead fr;
	if (!fr.Open(m_pszFichier, FILE_SHARE_READ | FILE_SHARE_WRITE))  return;
	
#pragma pack(push,1)
	
	struct FONT_HEADER
	{
		DWORD ver;
		WORD  nbTable;
		WORD  searchRange;
		WORD  entrySelector;
		WORD  rangeShift;
	};
	
	struct FONT_TABLE
	{
		DWORD tag;
		DWORD dwCheckSum;
		DWORD off;
		DWORD len;
	};
	
	struct FONT_NAME
	{
		WORD wFormat;
		WORD nbRec;
		WORD off;
	};
	
	struct FONT_NAMEREC
	{
		WORD idPlatform;
		WORD idPlatformSpecific;
		WORD idLanguage;
		WORD idName;
		WORD len;
		WORD off;
	};
	
	
#pragma pack(pop)
	
	bool fOK = false;
	WORD  i;
	DWORD offStorage;
	FONT_HEADER hdr;
	FONT_TABLE  tab;
	FONT_NAME   name;
	
	if (!fr.Read(&hdr, sizeof(hdr)))  goto Fin;
	Swap(hdr.nbTable);
	
	// Chercher la table 'name'
	for (i=0;; i++) {
		if (i==hdr.nbTable)  goto Fin;
		
		if (!fr.Read(&tab, sizeof(tab)))  goto Fin;
		if (tab.tag=='eman')  break;
	}
	
	// Table 'name' trouve, maintenant il faut numrer les chanes
	if (!fr.Seek(Swap(tab.off), FILE_BEGIN) ||
	    !fr.Read(&name, sizeof(name)))  goto Fin;
	Swap(name.nbRec);
	offStorage = fr.Tell() + Swap(name.off)-sizeof(name);
	
	// numrer les chanes disponibles
	// On prend la premire venue qui contient le nom complet de la police
	for (i=0;; i++) {
		if (i==name.nbRec)  goto Fin;
		
		FONT_NAMEREC rec;
		if (!fr.Read(&rec, sizeof(rec)))  goto Fin;
		if (rec.idName!=0x0400)  continue;
#ifdef UNICODE
		if (!(rec.idPlatform==0x0300 && rec.idPlatformSpecific==0x0100))  continue;
#else
		if   (rec.idPlatform==0x0300 && rec.idPlatformSpecific==0x0100)   continue;
#endif
		
		Swap(rec.len);
		BYTE *const pb = new BYTE[rec.len+sizeof(TCHAR)];
		if (!fr.Seek(offStorage+Swap(rec.off), FILE_BEGIN) ||
				!fr.Read(pb, rec.len)) {
			delete [] pb;
			goto Fin;
		}
		
		// OK, on a le nom de la police
#ifdef UNICODE
		((LPWSTR)pb)[rec.len/2] = 0;
		for (LPWSTR wsz=(LPWSTR)pb; *wsz; wsz++)  Swap(*wsz);
#else
		((LPSTR)pb)[rec.len] = 0;
#endif
		lstrcpyn(lf.lfFaceName, (LPTSTR)pb, nbArray(lf.lfFaceName));
		delete [] pb;
		
		fOK = true;
		break;
	}
	
Fin:
	fr.Close();
	
	// Utiliser le nom de la police pour la charger
	// et pour composer le texte
	if (*lf.lfFaceName) {
		lf.lfCharSet = DEFAULT_CHARSET;
		
		// Initialiser le contrle RTF, mode passage  la ligne automatique
		CRichEditCtrl &rtf = m_pView->m_rtf;
		m_fnt.CreateFontIndirect(&lf);
		rtf.SetFont(&m_fnt);
		CDC *const pdc = rtf.GetDC();
		TEXTMETRIC tm;
		pdc->GetTextMetrics(&tm);
		rtf.ReleaseDC(pdc);
		lf.lfHeight = -tm.tmHeight;
		m_fnt.DeleteObject();
		m_fnt.CreateFontIndirect(&lf);
		rtf.SetFont(&m_fnt);
		rtf.ShowWindow(SW_SHOW);
		rtf.SetTargetDevice(NULL, 0);
	}
}

// Mettre  jour le texte
void CApercuPolice::MAJ()
{
	LOGFONT lf;
	m_fnt.GetLogFont(&lf);
	
	// Nom de la police
	CString s;
	s.Format(_T("%s\n\n"), lf.lfFaceName);
	
	// Jeu de caractres
	if (e_opt.m_fApercuPoliceTout) {
		for (int c=32; c<256; c++) {
			if (!(c % 32) && c>32)  s += '\n';
			s += (TCHAR)c;
		}
		s += _T("\n\n");
	}
	
	// Texte supplmentaire
	s += e_opt.m_sApercuPolicePlus;
	m_pView->m_rtf.SetWindowText(s);
}

// Rcuprer les informations
void CApercuPolice::GetInfoText(CString& s)
{
	LOGFONT lf;
	m_fnt.GetLogFont(&lf);
	s = lf.lfFaceName;
}


// Demander les attributs de la police d'affichage
void CApercuPolice::OnSetPoliceFont()
{
	CRichEditCtrl &rtf = m_pView->m_rtf;
	
	// Rcuprer police et couleur du texte
	CHARFORMAT cf;
	rtf.GetDefaultCharFormat(cf);
	LOGFONT lfOrig;
	m_fnt.GetLogFont(&lfOrig);
	
	CFontDialog dlgFont(&lfOrig, CF_EFFECTS | CF_BOTH | CF_FORCEFONTEXIST);
	dlgFont.m_cf.rgbColors = (cf.dwEffects & CFE_AUTOCOLOR)
		? GetSysColor(COLOR_WINDOWTEXT) : cf.crTextColor;
	if (dlgFont.DoModal()==IDOK) {
		
		// Recrer la police
		LOGFONT lf;
		dlgFont.GetCurrentFont(&lf);
		lstrcpy(lf.lfFaceName, lfOrig.lfFaceName);
		m_fnt.DeleteObject();
		m_fnt.CreateFontIndirect(&lf);
		
		// Affecter la police et la couleur
		SetFont(&m_fnt);
		rtf.GetDefaultCharFormat(cf);
		cf.dwMask     |= CFM_COLOR;
		cf.crTextColor = dlgFont.GetColor();
		if (cf.crTextColor==GetSysColor(COLOR_WINDOWTEXT))
			cf.dwEffects |=  CFE_AUTOCOLOR;
		else
			cf.dwEffects &= ~CFE_AUTOCOLOR;
		rtf.SetDefaultCharFormat(cf);
		rtf.SendMessage(EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cf);
	}
}
