// ArboView.h


#ifndef _ARBOVIEW_H_
#define _ARBOVIEW_H_
#if _MSC_VER>1000
#pragma once
#endif


#include "MuzipDrop.h"
class CMuzipDoc;


class CArboView : public CTreeView
{
	DECLARE_DYNCREATE(CArboView)
	
public:  // Fonctions
	
	CMuzipDoc* GetDocument() { return (CMuzipDoc*)m_pDocument; }
	CTreeCtrl *m_ptrv;
	
	void ArchiveNouveauDossier(CDossier* pDossier);
	
	static int s_iRepClosed;
	static int s_iRepOpen;
	
	
protected:  // Donnes
	
	CMuzipDropTarget m_mdt;          // Cible du glisser-dplacer
	bool             m_fRenommage;   // TRUE si un item est en cours de renommage
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CArboView)
	public:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint pt)
		{ return m_mdt.OnDragEnter(pDataObject, dwKeyState, pt); }
	DROPEFFECT OnDragOver (COleDataObject* pDataObject, DWORD      dwKeyState, CPoint pt);
	BOOL       OnDrop     (COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint pt);
	void       OnDragLeave();
	
	//{{AFX_MSG(CArboView)
	afx_msg int  OnCreate(CREATESTRUCT* pcs);
	afx_msg void OnDestroy();
	afx_msg void OnRClick        (NMHDR*        pNMHDR, LRESULT* pResult);
	afx_msg void OnGetDispInfo   (NMTVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnKeyDown       (NMTVKEYDOWN*  pNMKD,  LRESULT* pResult);
	afx_msg void OnSelChanged    (NMTREEVIEW*   pNMTRV, LRESULT* pResult);
	afx_msg void OnItemExpanding (NMTREEVIEW*   pNMTRV, LRESULT* pResult);
	afx_msg void OnBeginDrag     (NMTREEVIEW*   pNMTRV, LRESULT* pResult);
	afx_msg void OnBeginLabelEdit(NMTVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnEndLabelEdit  (NMTVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnArchiveMoins();
	afx_msg void OnArchiveExtraire();
	afx_msg void OnArchiveRenommer();
	afx_msg void OnArchiveProprietes();
	afx_msg void OnArchiveTester();
	afx_msg void OnArchiveNouveauDossier();
	afx_msg void OnUpdateFautSel              (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveRenommer      (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveNouveauDossier(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
