// Dossier.h


#ifndef _DOSSIER_H_
#define _DOSSIER_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
class  CMuzipArc;
struct EXTRACTION;
struct RECHOPTIONS;

class  CFileRead;
class  CFileWrite;
class  CDlgLister;

struct FICHIEREXT;
typedef CListePtr1<FICHIEREXT*> CLstFichierExt;


class CDossier
{
public:  // Fonctions
	
	CDossier(CDossier* pParent, LPCTSTR pszNom);
	
	// Destructeur
	~CDossier()
		{
			delete [] m_pszNom;
			delete [] m_pszPath;
		}
	
	UINT GetNbFichier() const;
	UINT GetNbDossier() const;
	
	void ListerFichier(CLstFichier& lstFichier) const;
	void MAJPath();
	void SetFichierNonTrouve();
	
	bool DossierExtraire(LPCTSTR pszRep, const EXTRACTION* pext=NULL);
	
	void Supprimer();
	void SupprimerEtParentSiVide();
	bool SupprimerSiVide();
	void SupprimerFichierNonTrouve();
	bool Renommer(LPTSTR pszNom);
	
	void Rechercher();
	void RechercherSuivant(int nItem=-1) const;
	
	bool Lister(int nProf=0) const;
	void trvLister() const;
	void trvLister(HTREEITEM hti) const;
	
	bool FichierCopier(CFileRead& fr, CFileWrite& fw);
	bool ZipPutCentral(CFileWrite& fw);
	
	
public:  // Donnes
	
	CMuzipArc  *m_pArc;
	
	CDossier   *m_pParent;      // Dossier parent
	LPTSTR      m_pszNom;       // Nom du dossier sans chemin d'accs
	LPTSTR      m_pszPath;      // Chemin d'accs complet
	CLstDossier m_lstDossier;   // Liste des sous-dossiers
	CLstFichier m_lstFichier;   // Liste des fichiers
	
	// Arborescence
	        bool      m_fOuvert;// TRUE si le dossier est ouvert
	mutable HTREEITEM m_hti;    // ID de l'item
	
	static CDlgLister *s_pdlgLister;
	
	
private:  // Interne
	
	void DossierExtraireSuite(CLstFichierExt& lstFichierExt, CLstStr1& lstRep, LPCTSTR pszRep);
	void RechercherSuite();
	bool RenommerSuite();
	
	static RECHOPTIONS s_rch;
	static DWORD       s_mskAttrO;   // Ncessaires
	static DWORD       s_mskAttrN;   //  exclure
};


#endif
