// Exceptions.h
//
// Gestion des exceptions


#ifndef _EXCEPTIONS_H_
#define _EXCEPTIONS_H_


class CFileBuf;
class CFileRead;
class CFileWrite;


class CMuzipException : public CException
{
public:  // Fonctions
	
	CMuzipException() {}                                   // Pas d'erreur
	CMuzipException(UINT nID);                             // Message uniquement
	CMuzipException(                LPCTSTR pszFichier);   // Ouverture
	CMuzipException(UINT nID,       LPCTSTR pszFichier);   // Au choix
	CMuzipException(CFileRead&  fr);                       // Lecture
	CMuzipException(CFileWrite& fw);                       // criture
	
	BOOL GetErrorMessage(LPTSTR pszError, UINT nMaxError, UINT* pnHelpContext=NULL);
	int  ReportError(UINT nType=MB_OK, UINT nMessageID=0);
	
	
protected:  // Interne
	
	void Init(UINT nID, LPCTSTR pszFichier);
	
	
	CString m_s;      // Message  afficher
	UINT    m_nID;    // ID du message, zro si aucun
	
	union   // Fichier ayant provoqu l'erreur
	{
		void       *m_p;
		CFileRead  *m_pfr;
		CFileWrite *m_pfw;
	};
};


#endif
