// Fichier.cpp


#include "StdAfx.h"
#include "Interract.h"   // Ici car utilise new
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#include "Muzip.h"
#include "Fichier.h"

#include "MuzipArc.h"
#include "Interf.h"
#include "PlusItem.h"

#include "Decomp.h"

#include "IOFichier.h"

#include "dlgConfirm.h"
#include "dlgExtraire.h"

#include <GUnicode.h>


UINT       CFichier::s_nbFichier;
UINT       CFichier::s_nFichier;
char       CFichier::s_aszNom[MAX_PATH];
CFileWrite CFichier::s_fw;


// Constructeur
CFichier::CFichier() : m_pszNom(NULL), m_fIgnorer(false)
{
}

// Destructeur
CFichier::~CFichier()
{
	delete [] m_pszNom;
}


// Lister le fichier
void CFichier::lstLister(CListCtrl& lst, int nItem, CInterract* pInterract)
{
	// Rcuprer l'index de l'icne et le type du fichier
	SHFILEINFO shfi;
	SHGetFileInfo(m_pszNom, 0, &shfi, sizeof(shfi),
		SHGFI_USEFILEATTRIBUTES |
		SHGFI_SYSICONINDEX | SHGFI_SMALLICON |
		SHGFI_TYPENAME);
	
	const bool fCallback = !pInterract;
	if (!pInterract)  pInterract = &e_oInterract;
	LVITEM &lvi = pInterract->lvi;
	LPTSTR  psz = pInterract->psz;
	LPTSTR  pszCallback = (fCallback) ? LPSTR_TEXTCALLBACK : psz;
	
	// Ajouter l'item
	lvi.iItem     = nItem;
	lvi.mask      = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	lvi.iSubItem  = 0;
	if (!fCallback)  lstrcpy(psz, m_pszNom);
	lvi.pszText   = pszCallback;
	lvi.iImage    = shfi.iIcon;
	lvi.lParam    = (LPARAM)this;
	lvi.stateMask = LVIS_CUT;
	lvi.state     = (IsCrypte()) ? LVIS_CUT : 0;
	lvi.iItem     = lst.InsertItem(&lvi);
	
	// Sous-items
	lvi.mask      = LVIF_TEXT | LVIF_IMAGE;
	
	// Type
	lvi.iSubItem++;
	lvi.pszText = lstrcpy(psz, shfi.szTypeName);
	lst.SetItem(&lvi);
	
	// Taille
	lvi.iSubItem++;
	StrFormatByteSize(m_dwTailleN, psz, nbArray(pInterract->psz));
	lst.SetItem(&lvi);
	
	// Compress
	lvi.iSubItem++;
	lvi.pszText = StrFormatByteSize(m_dwTailleC, psz, nbArray(pInterract->psz));
	lst.SetItem(&lvi);
	
	// %
	lvi.iSubItem++;
	wsprintf(psz, _T("%hd %%"), m_nPC);
	lvi.pszText = psz;
	lst.SetItem(&lvi);
	
	// Modifi
	lvi.iSubItem++;
	SYSTEMTIME st = m_dtM;
	*psz = 0;
	const int len = GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &st, NULL, psz, nbArray(pInterract->psz));
	if (e_opt.m_fAffichageModifHeure) {
		// Rajouter l'heure  la date
		if (len)  psz[len-1] = ' ';
		GetTimeFormat(LOCALE_USER_DEFAULT, 0, &st, NULL, &psz[len], nbArray(pInterract->psz)-len);
	}
	lvi.pszText = psz;
	lst.SetItem(&lvi);
	
	// Attributs
	lvi.iSubItem++;
	if (!fCallback)  lstrcpy(psz, m_pszAttr);
	lvi.pszText   = pszCallback;
	lst.SetItem(&lvi);
	
	// Chemin
	lvi.iSubItem++;
	if (!fCallback)  lstrcpy(psz, m_pDossier->m_pszPath);
	lvi.pszText   = pszCallback;
	lst.SetItem(&lvi);
}


// Si le fichier est l'archive elle-mme,
// afficher un message d'erreur et retourner TRUE
bool CFichier::CompresseArchive()
{
	TCHAR pszFichier[MAX_PATH];
	if (!GetFullPathName(m_pszNomES, nbArray(pszFichier),pszFichier, NULL))
		*pszFichier = 0;
	if (!lstrcmpi(pszFichier, m_pArc->m_sPath)) {
		AfxMessageBox(ERR_COMPARCHIVE);
		return true;
	}
	return false;
}

// Initialiser le fichier
void CFichier::NewFichier(LPCTSTR pszFichier, const WIN32_FIND_DATA& wfd)
{
	m_pszNomES  = newDup(pszFichier);
	m_pszNom    = newDup(wfd.cFileName);
	m_dtM       = wfd.ftLastWriteTime;
	m_dwTailleC =
	m_dwTailleN = wfd.nFileSizeLow;
	m_dwAttr    = wfd.dwFileAttributes;
	MAJ();
}

// Dfinir la date de modification du fichier,
// entre au format Unix
void CFichier::SetUnixDateM(DWORD dtM)
{
	FILETIME ft;
	SYSTEMTIME st;
	DosDateTimeToFileTime((WORD)(dtM>>16), (WORD)dtM, &ft);
	FileTimeToSystemTime(&ft, &st);
	m_dtM = st;
}


// Supprimer le fichier de son dossier
void CFichier::Supprimer(bool fSupprimerParentSiVide)
{
	CDossier *const pDossier = m_pDossier;
	
	pDossier->m_lstFichier.DeleteAt(
		pDossier->m_lstFichier.Find(this));
	
	if (fSupprimerParentSiVide)  pDossier->SupprimerSiVide();
}

// Renommer le fichier
bool CFichier::Renommer(LPTSTR pszNom)
{
	// S'assurer que le nom est correct
	VERIF(NomCorriger(pszNom));
	
	// Vrifier qu'il n'y a pas de doublons avec les fichiers
	// appartenant au mme dossier que le fichier
	CLstFichier &lstFichier = m_pDossier->m_lstFichier;
	POS pos = lstFichier.GetPosDeb();
	while (pos) {
		CFichier *const pFichier = lstFichier.GetSuiv(pos);
		if (!lstrcmpi(pszNom, pFichier->m_pszNom)) {
			if (pFichier==this)  return true;
			// Doublon
			AfxFormatString2(e_sMsg, ERR_RENOMDOUBLONF, pszNom,pFichier->m_pszNom);
			AfxMessageBox(e_sMsg);
			return false;
		}
	}
	
	// Renommer le fichier
	delete [] m_pszNom;
	m_pszNom = newDup(pszNom);
	
	// Reconstruire l'archive
	bool fOK = false;
	if (!m_pArc->m_pi->IsModified() &&
	    (m_pArc->GetCap() & capRapideRenommer)) {
		// Dplacement rapide permis: l'effectuer pour chaque fichier
		if (m_pArc->WriteOpen()) {
			fOK = OnRenommer();
			m_pArc->WriteClose();
		}
	}
	if (!fOK)  m_pArc->FautReconstruire(ToBool(e_opt.m_fCompRmMove));
	return true;
}


// Mettre  jour les donnes calcules du fichier:
// pourcentage de compression, attributs
void CFichier::MAJ()
{
	// Pourcentage de compression
	m_nPC = 100;
	if (m_dwTailleN)  m_nPC -= m_dwTailleC*100/m_dwTailleN;
	
	// Attributs
	int i = 0;
	if (m_dwAttr & FILE_ATTRIBUTE_READONLY)  m_pszAttr[i++] = 'R';
	if (m_dwAttr & FILE_ATTRIBUTE_HIDDEN)    m_pszAttr[i++] = 'H';
	if (m_dwAttr & FILE_ATTRIBUTE_SYSTEM)    m_pszAttr[i++] = 'S';
	if (m_dwAttr & FILE_ATTRIBUTE_ARCHIVE)   m_pszAttr[i++] = 'A';
	m_pszAttr[i] = 0;
}


// Extraire le fichier
bool CFichier::ArchiveExtraireSuite(LPCTSTR pszRep, LPTSTR* ppszDest)
{
	*ppszDest = new TCHAR[MAX_PATH];
	PathCombine(*ppszDest, pszRep, m_pszNom);
	
	// Extraire le fichier
	if (Extraire(*ppszDest))  return true;
	
	delete [] *ppszDest;
	return false;
}

// Extraire le fichier
bool CFichier::Extraire(LPCTSTR pszDest)
{
	ASSERT(DECOMP::e_pfr);
	
	const bool fOK = ExtraireInterne(pszDest);
	if (!fOK && !oApp.s_ext.m_fGardeErreur)  DeleteFile(pszDest);
	
	return fOK;
}


// Excute un fichier et surveiller son excution
void CFichier::SurvExecuter(LPCTSTR pszFichier, LPCTSTR pszRep, LPCTSTR pszVerbe) const
{
	// Ouvrir le fichier
	SHELLEXECUTEINFO sei;
	sei.cbSize       = sizeof(sei);
	sei.fMask        = SEE_MASK_NOCLOSEPROCESS | SEE_MASK_FLAG_NO_UI;
	sei.lpVerb       = pszVerbe;
	sei.lpFile       = pszFichier;
	sei.lpParameters = NULL;
	sei.lpDirectory  = pszRep;
	sei.nShow        = SW_SHOWNORMAL;
	if (!ShellExecuteEx(&sei)) {
		// Le fichier n'a pas pu tre ouvert:
		// demander s'il faut essayer avec NotePad
		
		if (!CDlgConfirm::GetReponse(e_opt.m_fConfirmOuvrirNotepad, DEM_OUVRIRNOTEPAD))
			goto Supprimer;
		
		sei.lpFile       = _T("NotePad.exe");
		sei.lpParameters = pszFichier;
		if (!ShellExecuteEx(&sei))  goto Supprimer;
	}
	// Surveiller le fichier dcompress
	new CSurvDecomp(sei.hProcess, pszFichier, this, m_pArc);
	return;
	
Supprimer:
	// Erreur d'ouverture: supprimer le fichier
	FichierSupprimer(pszFichier, false);
}


// Remplir une classe CPlusItem avec les donnes permettant
// de recompresser le fichier  l'identique
void CFichier::ToPlusItem(CPlusItem& pi) const
{
	pi.SetDefautExt();
	
	pi.CO_nArbo           = arboNon;
	
	pi.OP_fSous           = FALSE;
	pi.OP_fCache          = FALSE;
	
	// pi.CO_nNiveau:  faire dans les classes drives de CFichier
}


// Copier l'entre d'un fichier  un autre
// Ici on ne fait que mettre  jour la progression
bool CFichier::FichierCopier(CFileRead&, CFileWrite&)
{
	oApp.SetProgress(STA_COPIEVIEUX, m_pszNom,
		s_nFichier++, s_nbFichier);
	
	return (oApp.UpdateProgressStatus()==prsOK);
}


// Dfinir les proprits
void CFichier::SetProp(DWORD dwAttr, CTempsDHS& dtModif)
{
	if (m_dwAttr==dwAttr && m_dtM==dtModif)  return;
	
	// Attributs et date de modification
	m_dwAttr = dwAttr;
	m_dtM    = dtModif;
	
	// Mettre  jour l'item
	MAJ();
	m_pArc->m_pi->UpdateFichier(this);
	
	// Reconstruire
	bool fOK = false;
	if (!m_pArc->m_pi->IsModified() && (m_pArc->GetCap() & capRapideModifProp)) {
		if (m_pArc->WriteOpen()) {
			fOK = OnModifProp();
			m_pArc->WriteClose();
		}
	}
	if (!fOK)  m_pArc->FautReconstruire(ToBool(e_opt.m_fCompRmProp));
}



// Copier des donnes en mettant  jour la barre de progression principale
bool CFichier::FichierCopier(CFileRead& fr, CFileWrite& fw, DWORD len, bool fAvance2)
{
	while (len) {
		
		// On prend CFileBuf::lenFileBuf+1
		// pour passer en mode direct (pas de buffer)
		const DWORD lenES = (CFileBuf::lenFileBuf+1>len)
			? len : CFileBuf::lenFileBuf+1;
		
		// crire
		VERIF(fw.WriteFrom(fr, lenES));
		
		// Mettre  jour
		if (!s_nbFichier)  oApp.AddStatusAvance(lenES);
		if (fAvance2)      oApp.AddStatusAvance2(lenES);
		len -= lenES;
		
		VERIF(oApp.UpdateProgressStatus()==prsOK);
	}
	
	return true;
}
