// Fichier.h


#ifndef _FICHIER_H_
#define _FICHIER_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "Decomp.h"

class CMuzipArc;
class CPlusItem;
class CRechDate;
class CInterract;

class CFileRead;
class CFileWrite;


class CFichier
{
	friend class CMuzipArc;
	
public:  // Fonctions
	
	CFichier();
	virtual ~CFichier();
	
	void lstLister(CListCtrl& lst, int nItem, CInterract* pInterract=NULL);
	
	bool CompresseArchive();
	
	void NewFichier(LPCTSTR pszFichier, const WIN32_FIND_DATA& wfd);
	void SetUnixDateM(DWORD dtM);
	
	void Supprimer(bool fSupprimerParentSiVide);
	bool Renommer(LPTSTR pszNom);
	
	void MAJ();
	
	bool ArchiveExtraireSuite(LPCTSTR pszRep, LPTSTR* ppszDest);
	bool Extraire(LPCTSTR pszDest);
	
	void SurvExecuter(LPCTSTR pszFichier, LPCTSTR pszRep, LPCTSTR pszVerbe=NULL) const;
	
	
public:  // Hritage
	
	virtual bool IsCrypte() const { return false; }
	virtual void ToPlusItem(CPlusItem& pi) const;
	
	virtual bool FichierCopier(CFileRead& fr, CFileWrite& fw);
	
	virtual void SetProp(DWORD dwAttr, CTempsDHS& dtModif);
	virtual bool OnRenommer () { return false; }
	virtual bool OnModifProp() { return false; }
	
	
public:  // Donnes
	
	CMuzipArc *m_pArc;        // Document parent
	CDossier  *m_pDossier;    // Dossier parent
	
	LPTSTR     m_pszNom;      // Nom du fichier sans chemin d'accs
	LPTSTR     m_pszNomES;    // Nom pour les E/S
	
	DWORD      m_dwTailleC;   // Taille du fichier compress
	DWORD      m_dwTailleN;   // Taille relle du fichier
	DWORD      m_dwAttr;      // Attributs du fichier
	int        m_nPC;         // Pourcentage de compression
	CTempsDHS  m_dtM;         // Date de modification
	TCHAR      m_pszAttr[5];  // Attributs du fichier en chane
	
	bool       m_fRech;       // TRUE si trouv par la recherche
	union{
	bool       m_fTrouve;     // TRUE si trouv par la recherche d'ajout
	bool       m_fFautComp;   // TRUE si doit tre compress
	};
	bool       m_fIgnorer;    // TRUE si le fichier a t ignor  la compression
	
	
public:  // Statique
	
	static UINT s_nbFichier;    // Nombre total de fichiers
	static UINT s_nFichier;     // Fichier en cours
	
	static char s_aszNom[MAX_PATH];   // Tampon pour E/S
	
	
protected:  // Interne
	
	virtual bool ExtraireInterne(LPCTSTR pszDest) = 0;
	
	bool FichierCopier(CFileRead& fr, CFileWrite& fw, DWORD len, bool fAvance2=false);
	
	
	static CFileWrite s_fw;       // Fichier en mode criture
};

#endif
