// FichierPlus.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "FichierPlus.h"

#include "Fichier.h"
#include "Dossier.h"
#include "PlusItem.h"
#include "MuzipArc.h"

#include "IOFichier.h"


// Constructeur
CFichierPlus::CFichierPlus(
	CFichier*  pFichier,
	CFichier*  pFichierOld,
	POS        posFichierOld,
	CDossier*  pDossier,
	CPlusItem* ppi)
	: m_pFichier(pFichier),
	m_pFichierOld(pFichierOld),
	m_posFichierOld(posFichierOld),
	m_ppi(ppi),
	m_pfpGauche(NULL), m_pfpDroite(NULL)
{
	m_pFichier->m_pDossier = pDossier;
}


// Traitement final
bool CFichierPlus::Finaliser()
{
	VERIF(!m_pFichier->m_fIgnorer);
	
	// Supprimer l'ancien fichier et ajouter le nouveau
	CLstFichier &lstFichier = m_pFichier->m_pDossier->m_lstFichier;
	if (m_posFichierOld)  lstFichier.DeleteAt(m_posFichierOld);
	lstFichier.AddFin(m_pFichier);
	
	const LPTSTR pszNomES = m_pFichier->m_pszNomES;
	
	// Options de compression:
	// - Supprimer le fichier
	if (m_ppi->CO_fActionDeplacer)
		FichierSupprimer(pszNomES, true);
	// - Enlever l'attribut archive
	else if (m_ppi->CO_fArchiveMoins && (m_pFichier->m_dwAttr & FILE_ATTRIBUTE_ARCHIVE))
		SetFileAttributes(pszNomES, m_pFichier->m_dwAttr & ~FILE_ATTRIBUTE_ARCHIVE);
	
	// La recherche est termine
	delete [] pszNomES;
	return TRUE;
}


// Remplir une liste de CFichierPlus avec un arbre
void CFichierPlus::RemplirListe(CLstFichierPlus& lstFichierPlus)
{
	if (!this)  return;
	
	lstFichierPlus.AddFin(this);
	m_pfpGauche->RemplirListe(lstFichierPlus);
	m_pfpDroite->RemplirListe(lstFichierPlus);
}
