// GZip/GZipFichier.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "GZipFichier.h"

#include "../Decomp.h"
using namespace DECOMP;

#include "../Z/UnZ.h"
#include "../Z/Cons.h"
#include "GZip.h"


// Extraire le fichier (spcifique  l'extraction de dossiers)
bool CGZipFichier::ExtraireInterne(LPCTSTR pszDest)
{
	return UNZ::ExtraireGZip(this, pszDest);
}


// Renommage
bool CGZipFichier::OnRenommer()
{
	// On ne fait rien du tout car le nom du fichier GZip
	// n'est pas enregistr dans l'archive
	return true;
}

// Modification des proprits
bool CGZipFichier::OnModifProp()
{
	// crire l'en-tte
	s_fw.Seek(0, FILE_BEGIN);
	PutHeader(s_fw);
	
	return true;
}


// crire l'en-tte
bool CGZipFichier::PutHeader(CFileWrite& fw)
{
	GZIPHEADER gzh;
	gzh.wID      = gzipID;
	gzh.nMethode = zmDeflate;
	gzh.nFlags   =
	gzh.nFlags2  = 0;
	gzh.dtM      = 0;
	gzh.nOS      = gzipOS;
	m_off        = sizeof(gzh);
	return fw.Write(&gzh, sizeof(gzh));
}
