// Interf.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "Interf.h"

#include "MuzipDoc.h"
#include "GZipDoc.h"
#include "MuzipArc.h"

#include "ArboView.h"
#include "MuzipView.h"
#include "ApercuView.h"

#include "Dossier.h"


//*** CInterf

// Fermer le document (en fait l'archive)
void CInterf::CloseDocument()
{
	m_pArc->Release(false);
}


//*** CInterfDoc

// Constructeur
CInterfDoc::CInterfDoc(CMuzipDoc* pDoc) : m_pDoc(pDoc)
{
}

// Flag de modification
void CInterfDoc::SetModifiedFlag(BOOL bModified)
{
	m_pDoc->SetModifiedFlag(bModified);
}
BOOL CInterfDoc::IsModified() const
{
	return m_pDoc->IsModified();
}

// Flag de fermeture demande
void CInterfDoc::SetFautFermer()
{
	ASSERT_KINDOF(CGZipDoc, m_pDoc);
	((CGZipDoc*)m_pDoc)->m_fFautFermer = true;
}

// Mise  jour et vidage des vues
void CInterfDoc::UpdateAll()
{
	m_pDoc->m_plst->OnUpdate(NULL,NULL,NULL);
	m_pDoc->m_ptrv->OnUpdate(NULL,NULL,NULL);
}
void CInterfDoc::DeleteAll()
{
	m_pDoc->m_ptrv->m_ptrv->DeleteAllItems();
	m_pDoc->m_plst->m_plst->DeleteAllItems();
}

// Mettre  jour juste un fichier
void CInterfDoc::UpdateFichier(CFichier* pFichier)
{
	if (!m_pDoc->m_plst)  return;
	
	CListCtrl &lst = *m_pDoc->m_plst->m_plst;
	
	// Rechercher l'item pour le supprimer
	// Conserver l'tat de l'item (slection, focus)
	// pour pouvoir le restaurer aprs
	LVFINDINFO lvfi;
	lvfi.flags  = LVFI_PARAM;
	lvfi.lParam = (LPARAM)pFichier;
	const int nItem = lst.FindItem(&lvfi);
	if (nItem<0)  return;
	const UINT nState = lst.GetItemState(nItem, LVIS_DROPHILITED | LVIS_FOCUSED | LVIS_SELECTED);
	lst.DeleteItem(nItem);
	
	// Le rajouter  la liste
	pFichier->lstLister(lst, nItem, &e_oInterract);
	lst.SetItemState(nItem, nState, LVIS_DROPHILITED | LVIS_FOCUSED | LVIS_SELECTED);
}

// Fermer le document en le sauvegardant si ncessaire
void CInterfDoc::CloseDocument()
{
	m_pDoc->DoFileSave();
	m_pDoc->OnCloseDocument();
}


// Poursuivre la recherche dans un dossier
void CInterfDoc::RechercherSuivant(const CDossier* pDossier, int nItem)
{
	if (!m_pDoc->m_plst || !m_pDoc->m_ptrv)  return;
	
	CListCtrl &lst = *m_pDoc->m_plst->m_plst;
	CTreeCtrl &trv = *m_pDoc->m_ptrv->m_ptrv;
	LVITEM lvi;
	
	// Poursuivre la recherche
	POS pos;
	
	LVFINDINFO lvfi;
	lvfi.flags = LVFI_PARAM;
	
	const int nbItem = lst.GetItemCount();
	if (nItem>=0) {
		// Poursuivre la recherche dans la liste
		lvi.mask = LVIF_PARAM;
		while (++nItem<nbItem) {
			lvi.iItem = nItem;
			lst.GetItem(&lvi);
			if (((CFichier*)lvi.lParam)->m_fRech) {
				// Slectionner le fichier
				
SelectionnerFichier:
				// Tout dslectionner d'abord
				lvi.iItem     = nbItem;
				lvi.mask      = LVIF_STATE;
				lvi.stateMask = LVIS_SELECTED;
				lvi.state     = 0;
				while (--lvi.iItem>=0)  lst.SetItem(&lvi);
				
				// Slectionner l'item
				lvi.iItem     = nItem;
				lvi.stateMask =
				lvi.state     = LVIS_SELECTED | LVIS_FOCUSED;
				lst.SetItem(&lvi);
				lst.SetSelectionMark(lvi.iItem);
				lst.SetFocus();
				return;
			}
		}
	}else{
		pos = pDossier->m_lstFichier.GetPosDeb();
		while (pos) {
			const CFichier *const pFichier = pDossier->m_lstFichier.GetSuiv(pos);
			if (pFichier->m_fRech) {
				
				if (nItem<0) {
					// Slectionner le dossier une seule fois
					
					// Lister les dossiers  ouvrir
					CListe1<const CDossier*> lstDossierTemp;
					const CDossier *pDossierCur = pDossier;
					for (;;) {
						pDossierCur = pDossierCur->m_pParent;
						if (!pDossierCur)  break;
						lstDossierTemp.AddFin(pDossierCur);
					}
					
					// Ouvrir les dossiers dans le bon ordre
					POS pos = lstDossierTemp.GetPosDeb();
					while (pos)
						trv.Expand(lstDossierTemp.GetSuiv(pos)->m_hti, TVE_EXPAND);
					
					// Slectionner le dossier
					trv.EnsureVisible(pDossier->m_hti);
					trv.SelectItem   (pDossier->m_hti);
				}
				
				// Rechercher le fichier,
				// et le garder s'il a une meilleure position
				lvfi.lParam = (LPARAM)pFichier;
				const int nTemp = lst.FindItem(&lvfi);
				if (nItem<0 || nTemp<nItem)  nItem = nTemp;
			}
		}
		
		if (nItem>=0)  goto SelectionnerFichier;
	}
	
	HTREEITEM htiSuiv = NULL;
	
	if (pDossier->m_lstDossier.GetNb()) {
		// Poursuivre la recherche dans les sous-dossiers
		
		htiSuiv = trv.GetChildItem(pDossier->m_hti);
		
		if (!htiSuiv) {
			// Lister les sous-dossiers
			pos = pDossier->m_lstDossier.GetPosDeb();
			while (pos)
				pDossier->m_lstDossier.GetSuiv(pos)->trvLister();
			// Rcuprer l'item
			htiSuiv = trv.GetChildItem(pDossier->m_hti);
		}
	}else{
		// Poursuivre la recherche dans le dossier frre suivant
		// S'il n'y en a pas, poursuivre l'arborescence
		
		const CDossier *pDossierCur = pDossier;
		do{
			htiSuiv = trv.GetNextSiblingItem(pDossierCur->m_hti);
			if (htiSuiv)  break;
			
			pDossierCur = pDossierCur->m_pParent;
		}while (pDossierCur);
	}
	
	if (htiSuiv) {
		// Dossier suivant trouv
		RechercherSuivant((const CDossier*)trv.GetItemData(htiSuiv));
		return;
	}
	
	AfxMessageBox(ERR_RECHERCHEFIN);
}


// Ajouter un item  l'arborescence
HTREEITEM CInterfDoc::InsertItem(TVINSERTSTRUCT* ptvis)
{
	return m_pDoc->m_ptrv->m_ptrv->InsertItem(ptvis);
}



// Suppression de dossier
void CInterfDoc::OnDossierSupprimer(CDossier* pDossier)
{
	// Prendre le parent du dossier comme dossier courant
	// si le dossier  supprimer est le dossier actif
	if (m_pDoc->m_pCur==pDossier && pDossier->m_pParent) {
		m_pDoc->m_pCur = pDossier->m_pParent;
		m_pDoc->m_plst->m_plst->DeleteAllItems();
		m_pDoc->m_pArc->m_pi->OnDossierChange();
	}
	
	// Supprimer les items dans l'arborescence
	CTreeCtrl *const ptrv = m_pDoc->m_ptrv->m_ptrv;
	if (pDossier->m_pParent)
		// Sous-dossier
		
		ptrv->DeleteItem(pDossier->m_hti);
		
	else{
		// Dossier racine: insupprimable
		
		// Ne pas dtruire le dossier racine lui-mme
		// mais que les items fils
		HTREEITEM hti = ptrv->GetChildItem(pDossier->m_hti);
		while (hti) {
			const HTREEITEM htiSuiv = ptrv->GetNextSiblingItem(hti);
			ptrv->DeleteItem(hti);
			hti = htiSuiv;
		}
	}
}


// Changement du dossier courant
void CInterfDoc::OnDossierChange()
{
	if (m_pDoc->m_papr)  m_pDoc->m_papr->SetApercu(NULL);
}
