// LBPlusItem.cpp
//
// Bote de liste avec dessin personnalis
// o chaque ligne reprsente un objet CPlusItem
// Affiche une icne reprsentant l'action  gauche
// de la spcification du ou des fichier(s)  compresser


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "LBPlusItem.h"

#include "PlusItem.h"


const int cIcone      = 16;
const int cMarge      =  1;
const int cMargeEntre =  3;


#if 0
BEGIN_MESSAGE_MAP(CLBPlusItem, CListBox)
	//{{AFX_MSG_MAP(CLBPlusItem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Constructeur
CLBPlusItem::CLBPlusItem()
{
	m_himl = ImageList_LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_COA),
		cIcone, nbCOA, RGB(192,192,192));
}

// Destructeur
CLBPlusItem::~CLBPlusItem()
{
	ImageList_Destroy(m_himl);
}


// Insrer un item
int CLBPlusItem::InsertString(int nItem, CPlusItem* ppi)
{
	LPTSTR pszItem = new TCHAR[ppi->DO_sFiltre.GetLength()+132];
	
	// Rcuprer le dossier et les parties
	TCHAR pszDebut[MAX_PATH];
	CLstCString2 lstPartie;
	const int len = ppi->ListerPartie(pszDebut, lstPartie);
	
	if (lstPartie.GetNb()==1)
		// Une seule partie: tout recopier tel quel
		
		lstrcpy(pszItem, pszDebut);
		
	else{
		// Plusieurs parties
		
		TCHAR *pcOut = pszItem;
		
		// Recopier le dossier
		pcOut += wsprintf(pcOut, _T("%s - "), pszDebut);
		
		// Recopier les parties
		POS pos = lstPartie.GetPosDeb();
		do{
			pcOut += lstrlen(lstrcpy(pcOut, (const TCHAR*)lstPartie.GetSuiv(pos)+len));
			if (!pos)  break;
			lstrcpy(pcOut, _T(" ; "));
			pcOut += 3;
		}while (pos);
		*pcOut = 0;
	}
	
	// Insrer l'item
	nItem = CListBox::InsertString(nItem, pszItem);
	SetItemDataPtr(nItem, ppi);
	
	delete [] pszItem;
	return nItem;
}


// Dimensions
void CLBPlusItem::MeasureItem(MEASUREITEMSTRUCT* pmis)
{
	// Calculer la hauteur d'un item
	CDC *const pdc = GetDC();
	CFont *const poldFont = (CFont*)pdc->SelectStockObject(DEFAULT_GUI_FONT);
	const CSize size = pdc->GetTextExtent(_T("A"), 1);
	pdc->SelectObject(poldFont);
	ReleaseDC(pdc);
	
	// Ne pas oublier les marges et la hauteur de l'icne
	pmis->itemHeight = cMarge + __max(size.cy, cIcone) + cMarge;
	
	// Calculer l'offset vertical du texte et de l'icne
	m_yoffTexte = (pmis->itemHeight-size.cy)/2;
	m_yoffIcone = (pmis->itemHeight-cIcone) /2;
}

// Dessin
void CLBPlusItem::DrawItem(DRAWITEMSTRUCT* pdis)
{
	const HDC  hdc   = pdis->hDC;
	const UINT state = pdis->itemState;
	
	// Choisir la bonne couleur de fond et de texte
	int iclFond, iclTexte;
	if (state & ODS_SELECTED) {
		iclFond  = COLOR_HIGHLIGHT;
		iclTexte = COLOR_HIGHLIGHTTEXT;
	}else{
		iclFond  = COLOR_WINDOW;
		iclTexte = COLOR_WINDOWTEXT;
	}
	::SetBkColor  (hdc, GetSysColor(iclFond));
	::SetTextColor(hdc, GetSysColor(iclTexte));
	
	// crire le texte
	const int lenItem = GetTextLen(pdis->itemID);
	LPTSTR pszItem = new TCHAR[lenItem+1];
	GetText(pdis->itemID, pszItem);
	::ExtTextOut(hdc,
		pdis->rcItem.left + cMarge + cIcone + cMargeEntre,
		pdis->rcItem.top  + m_yoffTexte,
		ETO_OPAQUE | ETO_CLIPPED, &pdis->rcItem,
		pszItem,lenItem, NULL);
	delete [] pszItem;
	
	if (lenItem>=0) {
		// Dessiner l'icne
		ImageList_DrawEx(m_himl,
			2*((CPlusItem*)pdis->itemData)->CO_nAction + ToBool(state & ODS_SELECTED),
			hdc, pdis->rcItem.left+cMarge,pdis->rcItem.top+m_yoffIcone,
			cIcone,cIcone, CLR_NONE,CLR_NONE, ILD_TRANSPARENT);
	}
	
	// Dessiner le rectangle de focus si ncessaire
	if (state & ODS_FOCUS)  ::DrawFocusRect(hdc, &pdis->rcItem);
}
