// Muzip.cpp


#include "StdAfx.h"
#include "Interract.h"   // Ici car utilise new
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"

#include <App.h>

#include "IOFichier.h"

#include "Options.h"
#include "ZipDoc.h"
#include "GZipDoc.h"
#include "TarDoc.h"
#include "UueDoc.h"
#include "ScriptDoc.h"
#include "MuzipArc.h"

#include "Z/UnZ.h"

#include "MainFrame.h"

#include "MuzipFrame.h"
#include "ArboView.h"
#include "MuzipView.h"
#include "ApercuView.h"

#include "ScriptFrame.h"
#include "ScriptView.h"

#include "dlgAssoc.h"
#include "dlgConfirm.h"
#include "dlgNouveau.h"
#include "dlgReparer.h"
#include "dlgExtraire.h"
#include "dlgProgress.h"
#include "dlgPlusItem.h"
#include "dlgOptions.h"

#include "Reg.h"
const LPCTSTR eszGeneralNbAssoc     = _T("NbAssociation");
const LPCTSTR eszGeneralAssoc       = _T("Association");
const LPCTSTR kszGeneralComp        = _T("Gnral\\Compression");
const LPCTSTR eszGeneralExtract     = _T("Extraction");
const LPCTSTR kszGeneralRech        = _T("Rechercher");
const LPCTSTR eszVoirPolice         = _T("Police");

const LPCTSTR eszGeneral            = _T("Gnral");
const LPCTSTR eszFiltre             = _T("Filtre");
const LPCTSTR eszContenu            = _T("Contenu");


bool CApp::s_fErreurFatale = false;

DWORD CApp::s_pos,  CApp::s_max;
DWORD CApp::s_pos2, CApp::s_max2;


bool       CApp::s_fMsg = true;
CLIPFORMAT CApp::s_cfMuzip;
int        CApp::s_nConfirm   = 1;
bool       CApp::s_fPasNommer = false;

CLstSurvDecomp CApp::s_lstSurvDecomp(true);
CLstStr1       CApp::s_lstDelDossier;

ARCHIVEPLUS  CApp::s_arPlus;
CPlusItem    CApp::s_pi;
EXTRACTION   CApp::s_ext;
RECHOPTIONS  CApp::s_rch;
ASSOC       *CApp::s_aAssoc;

CDlgProgress *CApp::s_pdlgProgress;
UINT          CApp::s_ndlgProgress = 0;
CString       CApp::s_sdlgProgress;

CFont CApp::s_fntVoir;

HIMAGELIST CApp::s_himlSystem;

CMuzipDocTemplate *CApp::s_pmdtScript;

bool CApp::s_fOuvreVisible = true;
bool CApp::s_fOccupe       = false;


CApp oApp;
CWinApp *const pApp = &oApp;


struct PLUSITEM : public PLUSOPTIONS, public FILTREOPTIONS
{
};


BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	ON_COMMAND(ID_APP_ABOUT,       OnAppAbout)
	ON_COMMAND(ID_FILE_NEW,        OnFileNew)
	ON_COMMAND(ID_FILE_NEW_SCRIPT, OnFileNewScript)
	ON_COMMAND(ID_FILE_REPARER,    OnFileReparer)
	ON_COMMAND(ID_FILE_OPTIONS,    OnFileOptions)
	ON_COMMAND(ID_FILE_OPEN,       OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CApp::CApp()
{
	s_cfMuzip = (CLIPFORMAT)RegisterClipboardFormat(_T("Muzip"));
	
	s_aAssoc = NULL;
	
	e_opt.m_nReparer = repPresumer;
}

// Destructeur
CApp::~CApp()
{
	delete [] s_aAssoc;
}


// Initialisation
BOOL CApp::InitInstance()
{
	srand((UINT)GetTickCount() ^ (UINT)GetCurrentProcessId());
	CSurvDecomp::s_hEvent = NULL;
	
	// Charger la DLL de ressources
	{
		const LPCTSTR pszResourceDLL = _T("Resource.dll");
		const HINSTANCE hInstRes = LoadLibrary(pszResourceDLL);
		if (!hInstRes) {
			s_fErreurFatale = true;
			CFileException(CFileException::fileNotFound, -1, pszResourceDLL).ReportError();
			return FALSE;
		}
		AfxSetResourceHandle(hInstRes);
		
		// Charger le titre de l'application
		free((void*)m_pszAppName);
		m_pszAppName = _tcsdup(CStringRes(AFX_IDS_APP_TITLE));
	}
	
	// Initialisation
	AfxOleInit();
	AfxInitRichEdit();
	s_fErreurFatale = !UNZ::InflateInit();
	if (s_fErreurFatale) {
		AfxMessageBox(ERR_INIT, MB_ICONERROR);
		return FALSE;
	}
	SetRegistryKey(_T("Ryder"));
	
	// Rcuprer la liste d'images systme
	SHFILEINFO shfi;
	s_himlSystem = (HIMAGELIST)SHGetFileInfo(_T(""), 0, &shfi, sizeof(shfi),
		SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	// Rcuprer les index des images des dossiers
	SHGetFileInfo(_T("A"), FILE_ATTRIBUTE_DIRECTORY, &shfi, sizeof(shfi),
		SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX);
	CArboView::s_iRepClosed = shfi.iIcon;
	SHGetFileInfo(_T("A"), FILE_ATTRIBUTE_DIRECTORY, &shfi, sizeof(shfi),
		SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX | SHGFI_OPENICON);
	CArboView::s_iRepOpen = shfi.iIcon;
	
	// Crer les modles de documents
	AddDocTemplate(new CMuzipDocTemplate(
		IDR_ZIPTYPE, IDR_MUZIPTYPE,
		RUNTIME_CLASS(CZipDoc),
		RUNTIME_CLASS(CMuzipFrame),
		RUNTIME_CLASS(CArboView)));
	AddDocTemplate(new CMuzipDocTemplate(
		IDR_GZIPTYPE, IDR_MUZIPTYPE,
		RUNTIME_CLASS(CGZipDoc),
		RUNTIME_CLASS(CMuzipFrame),
		RUNTIME_CLASS(CArboView)));
	AddDocTemplate(new CMuzipDocTemplate(
		IDR_TARTYPE, IDR_MUZIPTYPE,
		RUNTIME_CLASS(CTarDoc),
		RUNTIME_CLASS(CMuzipFrame),
		RUNTIME_CLASS(CArboView)));
	AddDocTemplate(new CMuzipDocTemplate(
		IDR_UUETYPE, IDR_MUZIPTYPE,
		RUNTIME_CLASS(CUueDoc),
		RUNTIME_CLASS(CMuzipFrame),
		RUNTIME_CLASS(CArboView)));
	AddDocTemplate(s_pmdtScript = new CMuzipDocTemplate(
		IDR_SCRIPTTYPE, IDR_SCRIPTTYPE,
		RUNTIME_CLASS(CScriptDoc),
		RUNTIME_CLASS(CScriptFrame),
		RUNTIME_CLASS(CScriptView)));
	
	// Lister les associations
	UINT nbAssoc = 0;
	CString sFilterExt;
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = GetNextDocTemplate(pos);
		if (pTemplate==(CDocTemplate*)s_pmdtScript)  continue;
		pTemplate->GetDocString(sFilterExt, CDocTemplate::filterExt);
		
		const TCHAR *pc = sFilterExt;
		for (;;) {
			TCHAR *pcFin = _tcschr(pc, ';');
			nbAssoc++;
			if (!pcFin)  break;
			pc = pcFin+1;
		}
	}
	s_aAssoc = new ASSOC[nbAssoc+1];
	s_aAssoc[nbAssoc].pszAssoc[0] = 0;
	nbAssoc = 0;
	pos = GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = GetNextDocTemplate(pos);
		if (pTemplate==(CDocTemplate*)s_pmdtScript)  continue;
		pTemplate->GetDocString(sFilterExt, CDocTemplate::filterExt);
		
		TCHAR *pc = (TCHAR*)(const TCHAR*)sFilterExt;
		for (;;) {
			TCHAR *pcFin = _tcschr(pc, ';');
			if (pcFin)  *pcFin = 0;
			
			CharLower(pc);
			lstrcpy(s_aAssoc[nbAssoc].pszAssoc, pc);
			s_aAssoc[nbAssoc].pszOld[0] = 0;
			nbAssoc++;
			
			if (!pcFin)  break;
			*pcFin = ';';
			pc = pcFin+1;
		}
	}
	
	
	//*** Lire les options
	
	UINT len;
	BYTE *pb;
	
	// Options gnrales
	e_opt.Load();
	
	// Associations
	nbAssoc = GetProfileInt(kszGeneral, eszGeneralNbAssoc, 0);
	if (nbAssoc>0) {
		if (GetProfileBinary(kszGeneral, eszGeneralAssoc, &pb, &len)) {
			if (len==nbAssoc*sizeof(ASSOC)) {
				// Rcuprer les associations
				
				int nAssoc;
				for (ASSOC *pAssoc=(ASSOC*)pb; nbAssoc; pAssoc++) {
					nbAssoc--;
					for (nAssoc=0; s_aAssoc[nAssoc].pszAssoc[0]; nAssoc++) {
						if (!lstrcmp(pAssoc->pszAssoc, s_aAssoc[nAssoc].pszAssoc)) {
							// Association trouve
							lstrcpy(s_aAssoc[nAssoc].pszOld, pAssoc->pszOld);
							break;
						}
					}
				}
			}
			delete [] pb;
		}
	}
	
	// Options d'ajout par dfaut
	s_arPlus.m_nSup = supRien;
	
	// Options de compression par dfaut
	if (GetProfileBinary(kszGeneralComp, eszGeneral, &pb, &len)) {
		if (len==sizeof(s_pi)) {
			(PLUSOPTIONS&)  s_pi = *(PLUSOPTIONS*)  (PLUSITEM*)pb;
			(FILTREOPTIONS&)s_pi = *(FILTREOPTIONS*)(PLUSITEM*)pb;
		}else{
			// Taille incorrecte
			delete [] pb;
			pb = NULL;
		}
	}
	
	if (pb)
		delete [] pb;
	else{
		// Options par dfaut
		
		s_pi.CO_nAction         = coaPlusMAJ;
		s_pi.CO_nNiveau         = 5;
		s_pi.CO_fActionDeplacer = FALSE;
		s_pi.CO_fActionNomCourt = FALSE;
		s_pi.CO_fArchiveMoins   = FALSE;
		s_pi.CO_fArchiveQue     = FALSE;
		s_pi.CO_nArbo           = arboSous;
		s_pi.CO_fQueNouveau     = FALSE;
		
		s_pi.TA_nActive         =
		s_pi.TA_nOp             =
		s_pi.TA_uTaille         =
		s_pi.TA_nUnite          = 0;
		
		s_pi.AT_nR              =
		s_pi.AT_nH              =
		s_pi.AT_nS              =
		s_pi.AT_nA              = 2;
		
		s_pi.OP_fSous           = TRUE;
		s_pi.OP_fCache          = FALSE;
	}
	
	s_pi.DO_sFiltre  = GetProfileString(kszGeneralComp, eszFiltre);
	s_pi.DO_sContenu = GetProfileString(kszGeneralComp, eszContenu);
	s_pi.DA_rdC.SetNow();
	s_pi.DA_rdM.SetNow();
	
	// Options d'extraction
	if (GetProfileBinary(kszGeneral, eszGeneralExtract, &pb, &len)) {
		if (len==sizeof(s_ext))
			s_ext = *(EXTRACTION*)pb;
		else{
			// Taille incorrecte
			delete [] pb;
			pb = NULL;
		}
	}
	if (pb)
		delete [] pb;
	else{
		// Options par dfaut
		
		s_ext.m_nAction      = exaAddMAJ;
		s_ext.m_fArbo        = TRUE;
		s_ext.m_fEcraseDem   = FALSE;
		s_ext.m_fEcraseDate  = FALSE;
		s_ext.m_fGardeErreur = FALSE;
	}
	
	// Options de recherche
	if (GetProfileBinary(kszGeneralRech, eszGeneral, &pb, &len)) {
		if (len==sizeof(FILTREOPTIONS))
			(FILTREOPTIONS&)s_rch = *(FILTREOPTIONS*)pb;
		else{
			// Taille incorrecte
			delete [] pb;
			pb = NULL;
		}
	}
	if (pb)
		delete [] pb;
	else{
		// Options par dfaut
		
		s_rch.TA_nActive =
		s_rch.TA_nOp     =
		s_rch.TA_uTaille =
		s_rch.TA_nUnite  = 0;
		
		s_rch.AT_nR      =
		s_rch.AT_nH      =
		s_rch.AT_nS      =
		s_rch.AT_nA      = 2;
		
		s_pi.OP_fSous    = TRUE;
		s_pi.OP_fCache   = FALSE;
	}
	
	s_rch.DO_sFiltre  = GetProfileString(kszGeneralRech, eszFiltre);
	s_rch.DO_sContenu = GetProfileString(kszGeneralRech, eszContenu);
	s_rch.OP_fSous    = TRUE;
	s_rch.OP_fCache   = TRUE;
	
	// Police du visualiseur interne
	if (GetProfileBinary(kszVoir, eszVoirPolice, &pb, &len)) {
		if (len==sizeof(LOGFONT))
			s_fntVoir.CreateFontIndirect((const LOGFONT*)pb);
		else{
			delete (LOGFONT*)pb;
			pb = NULL;
		}
	}
	if (pb)
		delete (LOGFONT*)pb;
	else
		s_fntVoir.CreateStockObject(SYSTEM_FONT);
	
	
	// Crer le thread de surveillance gnrale
	CSurvDecomp::s_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	DWORD idThread;
	CloseHandle(::CreateThread(NULL, 0, CSurvDecomp::prcThreadTous, NULL, 0, &idThread));
	
	// Charder la liste des derniers fichiers ouverts
	m_pRecentFileList = new CRecentFileList(0,
		CStringRes(IDS_RECENT1), CStringRes(IDS_RECENT2),
		e_opt.m_nGeneralMRU);
	m_pRecentFileList->ReadList();
	
	// Activer les liens DDE
	EnableShellOpen();
	
	// Afficher et mettre  jour la fentre principale
	m_pMainWnd = new CMainFrame;
	if (!((CMainFrame*)m_pMainWnd)->LoadFrame(IDR_MAINFRAME))  return FALSE;
	
	// Afficher la fentre principale
	// et activer l'ouverture par glisser/dplacer
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	m_pMainWnd->DragAcceptFiles();
	
	// Crer la fentre de progression
	s_pdlgProgress = new CDlgProgress;
	s_pdlgProgress->Create(CDlgProgress::IDD, m_pMainWnd);
	
	// Enregistrer Muzip
	Register();
	
	// Grer la ligne de commande
	CMuzipCmdLine cmdInfo;
	ParseCommandLine(cmdInfo);
	if (!ProcessShellCommand(cmdInfo))  goto Terminer;
	
	// Demande automatique d'affectation des archives  Muzip
	if (e_opt.m_fGeneralAssocVerifAuto) {
		
		// Vrifier que les extensions sont affectes  Muzip
		for (ASSOC *pAssoc=s_aAssoc; pAssoc->pszAssoc[0]; pAssoc++) {
			
			// Ouvrir la cl correspondant  l'association
			// et lire l'association courante
			HKEY hKey;
			TCHAR pszValeur[MAX_PATH];
			const bool fMuzip = pAssoc->GetAssocCur(hKey, pszValeur);
			if (hKey)  RegCloseKey(hKey);
			
			// Regarder si la valeur trouve est celle de Muzip
			if (!fMuzip) {
				// a ne correspond pas: Muzip n'est pas l'archiveur par dfaut
				// Demander confirmation puis la bote de dialogue
				// si Oui a t rpondu
				// Si OK a t rpondu, enregistrer la DLL d'extension du shell
				if (CDlgConfirm::GetReponse(e_opt.m_fGeneralAssocVerifAuto, DEM_ASSOCTOUT, cfmPlusDemander) &&
				    CDlgAssoc().DoModal()==IDOK)
					oApp.RegisterDLL(true);
				break;
			}
		}
	}
	
	// Afficher la bote de dialogue Ajouter au lancement
	// si aucune action n'a t faire  l'ouverture
	// et si l'option le permet
	if (cmdInfo.m_nShellCommand==CCommandLineInfo::FileNothing &&
	    e_opt.m_fGeneralOuvrirAuto)
		OnFileOpen();
	
	DossierSupprimer(_T("C:\\WINDOWS\\Bureau\\_Muzip"), false);
	
	return TRUE;
	
Terminer:
	m_pMainWnd->DestroyWindow();
	return FALSE;
}

// Terminaison
int CApp::ExitInstance()
{
	if (s_fErreurFatale)  return 0;
	
	FreeLibrary(AfxGetResourceHandle());
	
	POS pos;
	
	// Dtruire les fichiers  surveiller
	pos = s_lstSurvDecomp.GetPosDeb();
	while (pos) {
		CSurvDecomp *const psd = s_lstSurvDecomp.GetSuiv(pos);
		if (!psd->m_hProcess)  DeleteFile(psd->m_pszFichier);
	}
	
	// Dtruire les dossiers  surveiller
	pos = s_lstDelDossier.GetPosDeb();
	while (pos)
		DossierSupprimer(s_lstDelDossier.GetSuiv(pos));
	s_lstDelDossier.DeleteAll();
	
	// Dtruire la fentre de progression
	delete s_pdlgProgress;
	s_pdlgProgress = NULL;
	
	
	//*** Enregistrer les options
	
	// Options gnrales
	e_opt.Save();
	
	// Options de compression par dfaut
	WriteProfileBinary(kszGeneralComp, eszGeneral, (BYTE*)&s_pi, sizeof(s_pi));
	WriteProfileString(kszGeneralComp, eszFiltre,  s_pi.DO_sFiltre);
	WriteProfileString(kszGeneralComp, eszContenu, s_pi.DO_sContenu);
	
	// Associations
	int nbAssoc;
	for (nbAssoc=0; s_aAssoc[nbAssoc].pszAssoc[0]; nbAssoc++);
	WriteProfileInt   (kszGeneral, eszGeneralNbAssoc, nbAssoc);
	WriteProfileBinary(kszGeneral, eszGeneralAssoc,   (BYTE*)s_aAssoc,
		nbAssoc*sizeof(ASSOC));
	
	// Options d'extraction
	WriteProfileBinary(kszGeneral, eszGeneralExtract, (BYTE*)&s_ext, sizeof(s_ext));
	
	// Options de recherche
	WriteProfileBinary(kszGeneralRech, eszGeneral,
		(BYTE*)(FILTREOPTIONS*)&s_rch, sizeof(FILTREOPTIONS));
	WriteProfileString(kszGeneralRech, eszFiltre,  s_rch.DO_sFiltre);
	WriteProfileString(kszGeneralRech, eszContenu, s_rch.DO_sContenu);
	
	// Police des visualiseurs
	if (s_fntVoir.m_hObject) {
		LOGFONT lf;
		s_fntVoir.GetLogFont(&lf);
		WriteProfileBinary(kszVoir, eszVoirPolice, (BYTE*)&lf, sizeof(lf));
	}
	
	// Nettoyer
	UNZ::InflateClose();
	
	return CWinApp::ExitInstance();
}

// A propos
void CApp::OnAppAbout()
{
	CDialog(IDD_APROPOS).DoModal();
}


// Excuter une ligne de commande
bool CApp::ProcessShellCommand(CMuzipCmdLine& cmdInfo)
{
	// Dfinir le rpertoire courant  partir du premier fichier
	if (cmdInfo.m_arPlus.GetNb()) {
		TCHAR pszRep[MAX_PATH];
		lstrcpy(pszRep, cmdInfo.m_arPlus.GetDeb()->DO_sFiltre);
		TCHAR *const pcSep = _tcschr(pszRep, ';');
		if (pcSep)  *pcSep = 0;
		PathRemoveFileSpec(pszRep);
		SetCurrentDirectory(pszRep);
	}
	
	
	CMuzipArc *pArc = NULL;
	CDocument *pDoc = NULL;
	const int nbDoc = GetOpenDocumentCount();
	
	if (cmdInfo.m_nShellCommand!=FileSendMail &&
	    cmdInfo.m_nShellCommand!=FileGetArchiveInfo)
		m_pMainWnd->SetForegroundWindow();
	
	switch ((int)cmdInfo.m_nShellCommand) {
		
		// Ouvrir archive ou script
		// Grer le cas de l'excution de script
		case CCommandLineInfo::FileOpen:
			{
				// Ouvrir le document
				s_fOuvreVisible = false;
				CDocument *pDoc = OpenDocumentFile(cmdInfo.m_strFileName);
				CScriptDoc *const pScriptDoc = DYNAMIC_DOWNCAST(CScriptDoc, pDoc);
				if (pScriptDoc) {
					// S'il s'agit d'un script, l'excuter et le fermer
					pScriptDoc->OnScriptExecuter();
					pDoc->DoFileSave();
					pDoc->OnCloseDocument();
				}
			}
			break;
		
		// Compresser
		case FileComp:
			{
				if (cmdInfo.m_strFileName.IsEmpty()) {
					// Demander le nom de l'archive
					
					// Afficher la bote de dialogue ouvrir
					CFileDialog dlgOpen(TRUE, pszExtDefaut, NULL,
						OFN_HIDEREADONLY | OFN_PATHMUSTEXIST);
					if (!ShowFileOpenDialog(dlgOpen, false))  goto Fin;
					cmdInfo.m_strFileName = dlgOpen.GetPathName();
				}
				
				if (FichierCreer(cmdInfo.m_strFileName)) {
					
					// Ouvrir l'archive
					pArc = OpenArchive(cmdInfo.m_strFileName);
					
					// Ajouter
					if (pArc) {
						CPlusItem pi;
						pi.SetDefautExt();
						if (cmdInfo.FautDemanderOptions()) {
							CDlgPlusItem dlgPlusItem(pArc, pi, pArc->m_sMdp, false);
							if (dlgPlusItem.DoModal()==IDCANCEL)  goto Fin;
						}
						POS pos = cmdInfo.m_arPlus.GetPosDeb();
						while (pos)
							*(PLUSOPTIONS*)cmdInfo.m_arPlus.GetSuiv(pos) = pi;
						pArc->ArchivePlus(cmdInfo.m_arPlus);
					}
				}
			}
			break;
		
		// Dcompresser
		case FileDecomp:
			{
				if (cmdInfo.m_strFileName.IsEmpty())  goto Fin;
				
				// Ouvrir l'archive
				pArc = OpenArchive(cmdInfo.m_strFileName);
				
				// Extraire
				if (pArc) {
					TCHAR pszDestFull[MAX_PATH];
					if (!cmdInfo.m_sDest.IsEmpty())
						// Rcuprer le chemin d'accs d'extraction complet
						// et crer le dossier
						GetFullPathName(cmdInfo.m_sDest,
							nbArray(pszDestFull), pszDestFull, NULL);
					else
						*pszDestFull = 0;
					
					// Demander les options si ncessaire
					if (!*pszDestFull || cmdInfo.FautDemanderOptions()) {
						CDlgExtraire dlgExtraire(pArc);
						dlgExtraire.m_sDest = pszDestFull;
						if (dlgExtraire.DoModal()==IDCANCEL)  goto Fin;
						pArc->DossierExtraire(dlgExtraire.m_sDest, &dlgExtraire.m_ext);
					}else
						pArc->DossierExtraire(pszDestFull);
				}
			}
			break;
		
		// Envoyer mail
		case FileSendMail:
			{
				if (cmdInfo.m_strFileName.IsEmpty())  goto Fin;
				
				// Ouvrir l'archive
				s_fOuvreVisible = false;
				pDoc = OpenDocumentFile(cmdInfo.m_strFileName);
				CMuzipDoc *const pMuzipDoc = DYNAMIC_DOWNCAST(CMuzipDoc, pDoc);
				if (pMuzipDoc)  pMuzipDoc->OnFileSendMail();
			}
			break;
		
		// Rcuprer des informations
		case FileGetArchiveInfo:
			if (cmdInfo.m_pInterract) {   // Mapping d'interraction indispensable
				s_fPasNommer = true;
				pArc = OpenArchive(cmdInfo.m_strFileName);
				if (pArc)
					// Rcuprer les informations sur l'archive
					pArc->GetArchiveInfo(cmdInfo);
				else{
					// Indiquer qu'il y a eu erreur puis avertir l'appelant
					cmdInfo.m_pInterract->nbFichier = -1;
					CMuzipArc::OnGetArchiveInfoOK(cmdInfo.m_pInterract);
				}
				// On n'a plus besoin du mapping d'interraction
				delete cmdInfo.m_pInterract;
			}
			break;
		
		// diter script
		// ### Doit tre juste avant "default:" ###
		case FileScriptEdit:
			cmdInfo.m_nShellCommand = CCommandLineInfo::FileOpen;
		
		default:
			CWinApp::ProcessShellCommand(cmdInfo);
			break;
	}
	
	if (pArc)
		pArc->Release(false);
	else if (pDoc && nbDoc!=GetOpenDocumentCount()) {
		pDoc->DoFileSave();
		pDoc->OnCloseDocument();
	}
	
Fin:
	return !cmdInfo.m_fQuitter;
}


// Demander  l'utilisateur s'il ne faudrait pas masquer
// les prochanes erreurs
// Si pos==NULL aucun message n'est affich
// Par consquent passer la position courante dans la liste d'ajout
// comme argument  DemanderEncoreErreur() vite d'afficher
// un message pour le dernier lment d'une liste
bool CApp::DemanderEncoreErreur(POS pos)
{
	if (!pos)  return false;
	
	switch (AfxMessageBox(DEM_ENCOREERREUR, MB_YESNOCANCEL)) {
		
		case IDCANCEL:
			return false;
		
		case IDYES:
			s_fMsg = false;
		default: // IDNO
			return true;
	}
}


// Retourner le document correspondant  un nom de fichier
// ou NULL si le document n'est pas ouvert
CDocument* CApp::FindDocument(LPCTSTR pszFichier)
{
	CDocument *pDoc;
	
	// Regarder si le document est dj ouvert
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = GetNextDocTemplate(pos);
		if (pTemplate->MatchDocType(pszFichier, pDoc)==CDocTemplate::yesAlreadyOpen)
			// Le document est ouvert
			return pDoc;
	}
	
	return NULL;
}


// Attendre que l'application n'ait rien  faire
void CApp::DoEvents()
{
	WaitForInputIdle(m_hInstance, INFINITE);
	
	MSG msg;
	while (::PeekMessage(&msg, NULL,0,0, PM_REMOVE)) {
		if (!PreTranslateMessage(&msg)) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}
}


// Dfinir le texte de la barre d'tat
void CApp::SetMessageText(UINT nID)
{
	((CFrameWnd*)m_pMainWnd)->SetMessageText(nID);
	s_pdlgProgress->SetDlgItemText(IDCLBL, CStringRes(nID));
}
void CApp::SetMessageText(LPCTSTR psz)
{
	((CFrameWnd*)m_pMainWnd)->SetMessageText(psz);
	s_pdlgProgress->SetDlgItemText(IDCLBL, psz);
}
void CApp::SetProgressFichier(LPCTSTR pszFichier)
{
	s_pdlgProgress->SetDlgItemText(IDCLBL_FICHIER, pszFichier);
}

// Mettre  jour les informations sur la progression:
// En haut:          <nID> (<iCur>/<iTotal>)
// Juste en dessous: <NomFichier>
// - Un seul fichier
void CApp::SetProgress(UINT nID, LPCTSTR pszFichier)
{
	AfxFormatString1(e_sMsg, nID, NULL);
	SetMessageText(e_sMsg);
	SetProgressFichier(pszFichier);
}
// - Un fichier parmi plusieurs
void CApp::SetProgress(UINT nID, LPCTSTR pszFichier, UINT iCur, UINT iTotal)
{
	CString s;
	s.Format(_T("%u/%u"), iCur,iTotal);
	AfxFormatString1(e_sMsg, nID, s);
	SetMessageText(e_sMsg);
	SetProgressFichier(pszFichier);
}

// Initialiser l'indicateur de progression
void CApp::InitStatusAvance(const CMuzipArc* pArc, UINT nIDSTitre)
{
	if (pArc)
		AfxFormatString1(s_sdlgProgress, nIDSTitre, pArc->m_sPath);
	else
		s_sdlgProgress.Empty();
}

// Afficher l'indicateur de progression
void CApp::ShowStatusAvance(DWORD nMax, bool fPeutIgnorer)
{
	s_pos = 0;
	s_max = nMax;
	
	s_ndlgProgress++;
	
	if (!e_opt.m_fProgressAfficherMuzip)  return;
	
	if (!s_pdlgProgress->IsWindowVisible()) {
		// Masquer la deuxime barre de progression
		HideStatusAvance2();
		// Crer le timer d'attente avant l'affichage
		s_pdlgProgress->SetTimer(idTimerdlgProgress, e_opt.m_nProgressDelai, NULL);
	}
	
	// Initialiser le titre, vider la zone du fichier courant
	if (!s_sdlgProgress.IsEmpty())
		s_pdlgProgress->SetWindowText(s_sdlgProgress);
	s_pdlgProgress->SetDlgItemText(IDCLBL_FICHIER, NULL);
	
	// Initialiser l'indicateur
	s_pdlgProgress->m_prg1.SetRange(0, 100);
	s_pdlgProgress->m_prg1.SetPos(0);
	
	s_pdlgProgress->m_cmdIgnorer.EnableWindow(fPeutIgnorer);
	
	// Mettre  jour la fentre de progression
#ifndef _DEBUG
	s_pdlgProgress->SetWindowPos(&CWnd::wndTopMost, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
#endif
	s_pdlgProgress->UpdateWindow();
	
	// Attendre que l'application ait tout redessin
	DoEvents();
}
void CApp::ShowStatusAvance2(DWORD nMax)
{
	s_pos2 = 0;
	s_max2 = nMax;
	
	ASSERT(s_ndlgProgress>0);
	s_pdlgProgress->m_prg2.SetRange(0, 100);
	s_pdlgProgress->m_prg2.SetPos(0);
	
	if (!s_pdlgProgress->m_f2) {
		// Afficher la seconde barre de progression
		
		s_pdlgProgress->m_f2 = true;
		
		// Afficher la seconde barre de progression et son label
		s_pdlgProgress->GetDlgItem(IDCPRG_2)->ShowWindow(SW_SHOW);
		s_pdlgProgress->GetDlgItem(IDCLBL_2)->ShowWindow(SW_SHOW);
		
		const int yDifTotal = 70;
		const int yDif2     = yDifTotal/2;
		
		// Repositionner les boutons
		CButton* aBouton[] =
		{
			&s_pdlgProgress->m_cmdIgnorer,
			&s_pdlgProgress->m_cmdAnnuler,
		};
		for (int i=0; i<nbArray(aBouton); i++) {
			CButton &cmd = *aBouton[i];
			CRect rcBouton;
			
			cmd.GetWindowRect(rcBouton);
			rcBouton.top    += yDifTotal;
			rcBouton.bottom += yDifTotal;
			s_pdlgProgress->ScreenToClient(rcBouton);
			cmd.MoveWindow(rcBouton);
		}
		
		// Agrandir la fentre en hauteur
		CRect rc;
		s_pdlgProgress->GetWindowRect(rc);
		rc.top    -= yDif2;
		rc.bottom += yDif2;
		s_pdlgProgress->MoveWindow(rc);
		
		s_pdlgProgress->UpdateWindow();
	}
}

// Masquer l'indicateur de progression
void CApp::HideStatusAvance()
{
	ASSERT(s_ndlgProgress>0);
	s_ndlgProgress--;
	
	if (!s_ndlgProgress) {
		ResetProgressStatus();
		HideStatusAvance2();
		s_pdlgProgress->KillTimer(idTimerdlgProgress);
		s_pdlgProgress->ShowWindow(SW_HIDE);
		m_pMainWnd->SetForegroundWindow();
	}
	
	SetMessageText(AFX_IDS_IDLEMESSAGE);
}

// Masquer le second indicateur de progression
void CApp::HideStatusAvance2()
{
	if (s_pdlgProgress->m_f2) {
		// Masquer la deuxime barre de progression
		// en jouant sur la hauteur de la bote de dialogue
		// et la position verticale du bouton Annuler
		
		s_pdlgProgress->m_f2 = false;
		
		// Masquer la seconde barre de progression et son label
		s_pdlgProgress->GetDlgItem(IDCPRG_2)->ShowWindow(SW_HIDE);
		s_pdlgProgress->GetDlgItem(IDCLBL_2)->ShowWindow(SW_HIDE);
		
		// Rtrcir la fentre en hauteur
		CRect rc;
		s_pdlgProgress->GetWindowRect(rc);
		const int yDifTotal = 70;
		const int yDif2     = yDifTotal/2;
		rc.top    += yDif2;
		rc.bottom -= yDif2;
		s_pdlgProgress->MoveWindow(rc);
		
		// Repositionner les boutons
		CButton* aBouton[] =
		{
			&s_pdlgProgress->m_cmdIgnorer,
			&s_pdlgProgress->m_cmdAnnuler,
		};
		for (int i=0; i<nbArray(aBouton); i++) {
			CButton &cmd = *aBouton[i];
			CRect rcBouton;
			
			cmd.GetWindowRect(rcBouton);
			rcBouton.top    -= yDifTotal;
			rcBouton.bottom -= yDifTotal;
			s_pdlgProgress->ScreenToClient(rcBouton);
			cmd.MoveWindow(rcBouton);
		}
	}
}

// Dfinir la valeur de l'indicateur de progression
void CApp::SetStatusAvance(DWORD n)
{
	const DWORD pos = (s_max) ? n*100/s_max : 100;
	if (pos==s_pos)  return;
	s_pos = pos;
	
	s_pdlgProgress->m_prg1.SetPos(s_pos);
	DoEvents();
}
void CApp::AddStatusAvance(DWORD n)
{
	if (!s_max)  return;
	const DWORD posOld = s_pos*100/s_max;
	s_pos += n;
	const DWORD posNew = s_pos*100/s_max;
	if (posOld==posNew)  return;
	
	s_pdlgProgress->m_prg1.SetPos(posNew);
	DoEvents();
}
void CApp::AddStatusAvance2(DWORD n)
{
	if (!s_max2)  return;
	const DWORD posOld = s_pos2*100/s_max2;
	s_pos2 += n;
	const DWORD posNew = s_pos2*100/s_max2;
	if (posOld==posNew)  return;
	
	s_pdlgProgress->m_prg2.SetPos(posNew);
	DoEvents();
}

// Retourner le statut courant de la progression
PRGSTATUS CApp::GetProgressStatus()
{
	return s_pdlgProgress->m_prs;
}

// Retourner le statut courant de la progression
// aprs lui avoir permis de se mettre  jour
PRGSTATUS CApp::UpdateProgressStatus()
{
	DoEvents();
	return GetProgressStatus();
}

// Remettre  zro le statut courant de progression
void CApp::ResetProgressStatus()
{
	s_pdlgProgress->m_prs = prsOK;
}


// Rien  faire
BOOL CApp::OnIdle(LONG lCount)
{
	// Surveiller des fichiers dcompresss
	POS pos = s_lstSurvDecomp.GetPosDeb();
	while (pos)
		s_lstSurvDecomp.GetSuiv(pos)->Main();
	
	return CWinApp::OnIdle(lCount);
}


// Bote de message
int CApp::DoMessageBox(LPCTSTR lpszPrompt, UINT nType, UINT nIDPrompt)
{
	if (s_fMsg)  return CWinApp::DoMessageBox(lpszPrompt, nType, nIDPrompt);
	
	switch (nType) {
		
		case MB_ABORTRETRYIGNORE:
			return IDIGNORE;
		
		case MB_RETRYCANCEL:
			return IDCANCEL;
		
		case MB_YESNO:
		case MB_YESNOCANCEL:
			return IDYES;
		
		default:
			return IDOK;
	}
}



//*** CSurvDecomp

HANDLE CSurvDecomp::s_hEvent;

// Commencer la surveillance d'un fichier dcompress
CSurvDecomp::CSurvDecomp(HANDLE hProcess, LPCTSTR pszFichier,
	const CFichier* pFichier, CMuzipArc* pArc)
{
	CLstSurvDecomp &lstSurvDecomp = oApp.s_lstSurvDecomp;
	
	// Supprimer les doublons
	POS pos = lstSurvDecomp.GetPosDeb();
	while (pos) {
		const POS posSauve = pos;
		CSurvDecomp *const psd = lstSurvDecomp.GetSuiv(pos);
		if (psd->m_pFichier==pFichier) {
			lstSurvDecomp.DeleteAt(posSauve);
			break;
		}
	}
	
	// Rcuprer la date de modification du fichier
	const HANDLE hf = CreateFile(pszFichier, GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, 0, NULL);
	if (hf==INVALID_HANDLE_VALUE) {
Erreur:
		m_pszFichier = NULL;
		delete this;
		return;
	}
	const BOOL bOK = GetFileTime(hf, NULL, NULL, &m_ftModif);
	CloseHandle(hf);
	if (!bOK)  goto Erreur;
	m_dwAttr     = GetFileAttributes(pszFichier);
	
	m_hProcess   = hProcess;
	m_pszFichier = newDup(pszFichier);
	m_pFichier   = pFichier;
	m_pArc       = pArc;
	m_et         = 0;
	m_hEvent     = CreateEvent(NULL, TRUE, FALSE, NULL);
	lstSurvDecomp.AddDeb(this);
	
	// Crer et lancer le thread de surveillance
	DWORD idThread;
	m_hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)prcThread,
		(void*)this, 0, &idThread);
}

// Destruction
CSurvDecomp::~CSurvDecomp()
{
	if (m_pszFichier) {
		m_et |= etClose;
		
		// Terminer le thread de surveillance du processus
		PulseEvent(m_hEvent);
		WaitForSingleObject(m_hThread, INFINITE);
		
		CloseHandle(m_hEvent);
		
		delete [] m_pszFichier;
	}
}

// Surveiller un fichier dcompress
void CSurvDecomp::Main()
{
	if (m_hProcess==INVALID_HANDLE_VALUE && !(m_et & etFini))  return;
	if (m_hProcess)  m_hProcess = INVALID_HANDLE_VALUE;
	
	if ((m_et & (etModif | etAttr)) &&
	    AfxIsValidAddress(m_pArc, sizeof(*m_pArc)) &&
	    AfxIsValidAddress(m_pFichier->m_pDossier, sizeof(*m_pFichier->m_pDossier))) {
		// Le document et le dossier doivent tre valides
		
		if (m_et & etModif) {
			// Fichier modifi: demander son remplacement
			
			AfxFormatString1(e_sMsg, DEM_COMPMODIF, m_pszFichier);
			if (CDlgConfirm::GetReponse(e_opt.m_fConfirmCompModif)) {
				// Recompresser le fichier
				CArchivePlus arPlus(m_pFichier->m_pDossier);
				CPlusItem pi;
				m_pFichier->ToPlusItem(pi);
				pi.DO_sFiltre = m_pszFichier;
				arPlus.AddDeb(&pi);
				m_pArc->ArchivePlus(arPlus);
			}
		}else if ((m_pArc->GetCap() & capAttribut) && (m_et & etAttr)) {
			// Attributs modifis: les modifier directement
			
			AfxFormatString1(e_sMsg, DEM_COMPMODIF, m_pszFichier);
			if (CDlgConfirm::GetReponse(e_opt.m_fConfirmCompModif)) {
				// Juste changer les attributs
				((CFichier*)m_pFichier)->m_dwAttr = m_dwAttr;
				m_pArc->FautReconstruire(ToBool(e_opt.m_fCompRmProp));
			}
		}
		if (m_hProcess==INVALID_HANDLE_VALUE)
			oApp.s_lstSurvDecomp.DeleteAt(oApp.s_lstSurvDecomp.Find(this));
		else
			m_et &= ~(etModif | etAttr);
	}
}

// Vrifier si le fichier a t modifi
void CSurvDecomp::VerifModif()
{
	FILETIME ft;
	
	// Rcuprer la date de modification du fichier
	const HANDLE hf = CreateFile(m_pszFichier, GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, 0, NULL);
	if (hf!=INVALID_HANDLE_VALUE) {
		if (GetFileTime(hf, NULL, NULL, &ft) &&
		    CompareFileTime(&ft, &m_ftModif)) {
			m_ftModif = ft;
			m_et     |= etModif;
		}
		CloseHandle(hf);
	}
}

// Vrifier si les attributs du fichier ont t modifis
void CSurvDecomp::VerifAttribut()
{
	const DWORD dwAttr = GetFileAttributes(m_pszFichier);
	if (dwAttr!=(DWORD)-1 && dwAttr!=m_dwAttr) {
		m_et    |= etAttr;
		m_dwAttr = dwAttr;
	}
}


// Thread de surveillance gnrale
DWORD WINAPI CSurvDecomp::prcThreadTous(void*)
{
	TCHAR pszDossierTemp[MAX_PATH];
	if (!e_opt.GetDossierTemp(pszDossierTemp))  return 0;
	
	// 0: vnement de terminaison
	// 1: surveillance des modifications
	// 2: surveillance des attributs
	HANDLE aHandle[3];
	aHandle[0] = s_hEvent;
	aHandle[1] = FindFirstChangeNotification(pszDossierTemp,
		TRUE, FILE_NOTIFY_CHANGE_LAST_WRITE);
	aHandle[2] = FindFirstChangeNotification(pszDossierTemp,
		TRUE, FILE_NOTIFY_CHANGE_ATTRIBUTES);
	
	CLstSurvDecomp &lstSurvDecomp = oApp.s_lstSurvDecomp;
	POS pos;
	
	for (;;) {
		const DWORD n = WaitForMultipleObjects(3, aHandle, FALSE, INFINITE);
		if (n==WAIT_OBJECT_0)
			// vnement de terminaison
			break;
		
		pos = lstSurvDecomp.GetPosDeb();
		if (n==WAIT_OBJECT_0+1) {
			// Un fichier a t modifi
			while (pos)  lstSurvDecomp.GetSuiv(pos)->VerifModif();
		}else{
			// Les attributs d'un fichier ont t modifis
			while (pos)  lstSurvDecomp.GetSuiv(pos)->VerifAttribut();
		}
		
		FindNextChangeNotification(aHandle[n]);
	}
	
	FindCloseChangeNotification(aHandle[1]);
	FindCloseChangeNotification(aHandle[2]);
	return 0;
}

// Thread de surveillance
DWORD WINAPI CSurvDecomp::prcThread(CSurvDecomp* psd)
{
	int nbHandle = (psd->m_hProcess) ? 2 : 1;
	const HANDLE aHandle[2] = { psd->m_hEvent, psd->m_hProcess };
	
	WaitForMultipleObjects(nbHandle, aHandle, FALSE, INFINITE);
	if (psd->m_et!=etClose)
		// Processus termin
		psd->m_et |= etFini;
	
	return 0;
}


//*** CApp (suite)

// Nouvelle archive
void CApp::OnFileNew()
{
	CDlgNouveau dlgNouveau;
	if (dlgNouveau.DoModal()==IDCANCEL)  return;
	const CString &sFichier = dlgNouveau.GetPathName();
	
	// Fermer l'ancien document si ncessaire
	CDocument *const pDocDeja = FindDocument(sFichier);
	if (pDocDeja)  pDocDeja->OnCloseDocument();
	
	// Crer un fichier vide
	CFileWrite fw;
	if (!fw.Open(sFichier, FILE_SHARE_READ | FILE_SHARE_WRITE))  return;
	fw.Close();
	
	// Ouvrir le document et afficher la bote de dialogue Ajouter
	// si cela a t demand par l'utilisateur
	CMuzipDoc *const pDoc = DYNAMIC_DOWNCAST(CMuzipDoc, OpenDocumentFile(sFichier));
	if (dlgNouveau.m_fAjouter && pDoc)  pDoc->OnArchivePlus();
}

// Nouveau script
void CApp::OnFileNewScript()
{
	s_pmdtScript->OpenDocumentFile(NULL);
}


// Ouvrir
void CApp::OnFileOpen()
{
	CFileDialog dlgOpen(TRUE, pszExtDefaut, NULL,
		OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT | OFN_FILEMUSTEXIST);
	ShowFileOpenDialog(dlgOpen);
}


// Rparer
void CApp::OnFileReparer()
{
	e_opt.m_nReparer = repAltere;
	CDlgReparer dlgReparer;
	ShowFileOpenDialog(dlgReparer);
	e_opt.m_nReparer = repNon;
}

// Afficher une CFileDialog d'ouverture de fichier
#pragma warning(disable:4706)
bool CApp::ShowFileOpenDialog(CFileDialog& dlg, bool fOuvrir)
{
	// Crer la liste des filtres
	CString sFilterTous, sFilterAutre, sDefault;
	
	bool fPrem = true;
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = GetNextDocTemplate(pos);
		if (pTemplate==s_pmdtScript)  continue;
		
		CString sFilterExt, sFilterName;
		pTemplate->GetDocString(sFilterExt,  CDocTemplate::filterExt);
		pTemplate->GetDocString(sFilterName, CDocTemplate::filterName);
		
		if (fPrem)
			// Dfinir l'extension par dfaut (sauter le point)
			dlg.m_ofn.lpstrDefExt  = ((STRING)sFilterExt)+1;
		
		// Dfinir le filtre
		sFilterAutre += sFilterName;
		sFilterAutre += '|';
		TCHAR *pc = (TCHAR*)(const TCHAR*)sFilterExt;
		for (;;) {
			if (fPrem)  fPrem = false;
			else        sFilterTous  += ';';
			
			sFilterTous  += '*';
			sFilterAutre += '*';
			
			TCHAR *pcFin = _tcschr(pc, ';');
			if (pcFin)  *pcFin = 0;
			
			sFilterTous  += pc;
			sFilterAutre += pc;
			
			if (!pcFin)  break;
			sFilterAutre += ';';
			*pcFin = ';';
			pc = pcFin+1;
		}
		sFilterAutre += '|';
		dlg.m_ofn.nMaxCustFilter++;
	}
	sFilterAutre += CStringRes(AFX_IDS_ALLFILTER);
	
	CString sFilter;
	AfxFormatString2(sFilter, IDS_FILTREOPEN, sFilterTous, sFilterAutre);
	dlg.m_ofn.nMaxCustFilter++;
	TCHAR *pc = (STRING)sFilter;
	while ((pc = _tcschr(pc, '|')))  *pc++ = 0;
	
	// Initialiser la bote de dialogue
	static TCHAR pszRep[MAX_PATH];
	GetCurrentDirectory(nbArray(pszRep),pszRep);
	TCHAR pszFichiers[1<<10] = _T("");
	dlg.m_ofn.lpstrFilter     = sFilter;
	dlg.m_ofn.nFilterIndex    = 1;
	dlg.m_ofn.lpstrFile       = pszFichiers;
	dlg.m_ofn.nMaxFile        = nbArray(pszFichiers);
	dlg.m_ofn.lpstrInitialDir = pszRep;
	if (dlg.DoModal()==IDCANCEL)  return false;
	if (fOuvrir) {
		// Ouvrir les documents
		pos = dlg.GetStartPosition();
		while (pos)
			OpenDocumentFile(dlg.GetNextPathName(pos));
	}
	return true;
}
#pragma warning(default:4706)


// Options
void CApp::OnFileOptions()
{
	CDlgOptions().DoModal();
}


// Dfinir la police du visualiseur interne
void CApp::SetFontVoir(const LOGFONT* plf)
{
	// Recrer la police
	s_fntVoir.DeleteObject();
	s_fntVoir.CreateFontIndirect(plf);
	
	// Mettre  jour les contrles RTF de tous les visualiseurs
	POSITION pos = GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = GetNextDocTemplate(pos);
		if (pTemplate==s_pmdtScript)  continue;
		POSITION pos2 = pTemplate->GetFirstDocPosition();
		while (pos2) {
			CMuzipDoc *const pDoc = (CMuzipDoc*)pTemplate->GetNextDoc(pos2);
			CApercuView *const papr = pDoc->m_papr;
			if (papr)  papr->m_pApercu->OnSetFont();
		}
	}
}
