// Muzip2.cpp
//
// Classes auxiliaires dclares dans Muzip.h


#include "StdAfx.h"
#include "Interract.h"   // Ici car utilise new
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"

#include "PlusItem.h"
#include "Reg.h"
#include "Options.h"

#include "GZipDoc.h"

#include "dlgProgress.h"

#include <afxPriv.h>
#include <Pidl.h>


const LPCTSTR kszAppPath   = _T("Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\Muzip.exe");
const LPCTSTR kszScriptExt = _T(".mus");
const LPCTSTR kszScript    = _T("Muzip.Script");
const LPCTSTR kszArchive   = _T("Muzip.Archive");


static void ArgumentSuivant(LPTSTR& pszArgs, TCHAR*& pc);


// Passer  l'argument suivant
void ArgumentSuivant(LPTSTR& pszArgs, TCHAR*& pc)
{
	// Sauter le prochain guillemet (dbut du deuxime argument)
	pszArgs = _tcschr(pc+1, '"');
	if (pszArgs) {
		// Aller jusqu'au prochain guillemet
		pc = _tcschr(++pszArgs, '"');
		if (!pc)
			pszArgs = NULL;
		else
			*pc = 0;
	}
}


// Commande DDE
BOOL CApp::OnDDECommand(LPTSTR pszCommand)
{
	// Commandes acceptes: (une et une seule accepte)
	// [open("%1")]           Ouvrir l'archive ou excuter le script %1
	// [zip("%1","%2",...)]   Compresser %2, %3... dans l'archive %1
	// [unzip("%1")]          Dcompresser l'archive dans le dossier %1
	// [mail("%1")]           Attacher l'archive %1  un nouveau message
	// [gai("%1","%2")]       Rcuprer des informations sur l'archive %1, initialiser la liste de handle %2
	// [edit("%1")]           diter le script %1
	
	// Obligatoirement  la fin:
	// [FromMenu]             Commande excute  partir de l'extension
	//                        du menu contextuel du shell
	// [FromDrop]             Commande excute  partir
	//                        d'un glisser-dplacer dans le shell
	// [quit]                 Quitter (toujours excut en dernier)
	
	LPTSTR pszArgs;
	CMuzipCmdLine cmdInfo;
	
	// Rechercher les commandes [From*]
	// pour les enlever de la chane de commande
	LPTSTR pszFlag = _tcsstr(pszCommand, _T("[FromMenu]"));
	if (pszFlag)
		cmdInfo.m_es = esMenu;
	else{
		pszFlag = _tcsstr(pszCommand, _T("[FromDrop]"));
		if (pszFlag)
			cmdInfo.m_es = esDrop;
	}
	
	// Regarder s'il faudra quitter aprs excuter
	cmdInfo.m_fQuitter = ToBool(_tcsstr(pszCommand, _T("[quit]")));
	
	if      (pszFlag==pszCommand)  pszCommand += 12;
	else if (pszFlag)              *pszFlag = 0;
	
	struct
	{
		LPCTSTR      psz;
		SHELLCOMMAND sc;
	}
	const aDDE[] =
	{
		{ _T("[open(\""),  CCommandLineInfo::FileOpen },
		{ _T("[zip(\""),   (SHELLCOMMAND)    FileComp },
		{ _T("[unzip(\""), (SHELLCOMMAND)    FileDecomp },
		{ _T("[mail(\""),  (SHELLCOMMAND)    FileSendMail },
		{ _T("[gai(\""),   (SHELLCOMMAND)    FileGetArchiveInfo },
		{ _T("[edit(\""),  (SHELLCOMMAND)    FileScriptEdit },
	};
	
	pszArgs = NULL;
	for (int i=0; i<nbArray(aDDE); i++) {
		const int len = lstrlen(aDDE[i].psz);
		if (CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
				pszCommand,len, aDDE[i].psz,len)==CSTR_EQUAL) {
			cmdInfo.m_nShellCommand = aDDE[i].sc;
			pszArgs = pszCommand+len;
			break;
		}
	}
	if (!pszArgs)  return FALSE;
	
	TCHAR *pc;
	
	// Rcuprer le chemin d'accs du fichier
	pc = _tcschr(pszArgs, '"');
	if (!pc)  return FALSE;
	*pc = 0;
	cmdInfo.m_strFileName = pszArgs;
	
	if (cmdInfo.m_nShellCommand!=CCommandLineInfo::FileOpen) {
		
		// Rcuprer l'argument suivant dans pszArgs
		ArgumentSuivant(pszArgs, pc);
		
		if (cmdInfo.m_nShellCommand==FileComp) {
			// Fichiers  ajouter/supprimer
			
			if (!pszArgs)  return FALSE;
			
			// Crer un nouvel item de compression
			CPlusItem *const ppi = new CPlusItem;
			ppi->SetDefautExt();
			ppi->DO_sFiltre = pszArgs;
			cmdInfo.m_arPlus.AddFin(ppi);
			
		}else if (cmdInfo.m_nShellCommand==FileDecomp) {
			// Dossier d'extraction
			
			if (pszArgs)  cmdInfo.m_sDest = pszArgs;
			
		}else if (cmdInfo.m_nShellCommand==FileGetArchiveInfo) {
			// Numro du mapping puis ventuellement handle de la liste
			
			if (pszArgs) {
				
				// Numro du mapping
				const int nUnique = (int)_tcstoul(pszArgs, NULL, 0);
#ifdef _DEBUG
#undef new
#endif
				cmdInfo.m_pInterract = new (nUnique) CInterract(nUnique);
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
				
				// Rcuprer l'argument suivant dans pszArgs
				ArgumentSuivant(pszArgs, pc);
				
				// Handle de la liste
				if (pszArgs)  cmdInfo.m_hwndLst = (HWND)_tcstoul(pszArgs, NULL, 0);
			}
		}
	}
	
	// Excuter la ligne de commande
	CCommandLineInfo *const poldcmdInfo = m_pCmdInfo;
	m_pCmdInfo = &cmdInfo;
	ProcessShellCommand(cmdInfo);
	m_pCmdInfo = poldcmdInfo;
	
	if (cmdInfo.m_fQuitter)  m_pMainWnd->CloseWindow();
	
	return TRUE;
}


// Enregistrer Muzip dans le Registre
// Ne pas enregistrer la DLL
void CApp::Register()
{
	// Chemin d'accs
	TCHAR pszPath[MAX_PATH];
	const DWORD dwLen = ::GetModuleFileName(oApp.m_hInstance, pszPath, nbArray(pszPath));
	
	HKEY hKey;
	
	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE, kszAppPath,
		  0, NULL, 0, KEY_WRITE, NULL, &hKey, NULL)==ERROR_SUCCESS) {
		RegSetValueEx(hKey, NULL, 0, REG_SZ,
			(const BYTE*)pszPath, dwLen+1);
		RegCloseKey(hKey);
	}
	
	// Associations
	const LPCTSTR kszIcone   = _T("DefaultIcon");
	
	const LPCTSTR kszShell   = _T("shell");
	const LPCTSTR kszOpen    = _T("open");
	const LPCTSTR kszEdit    = _T("edit");
	const LPCTSTR kszCmd     = _T("command");
	const LPCTSTR kszDDE     = _T("ddeexec");
	const LPCTSTR kszApp     = _T("Application");
	const LPCTSTR kszTopic   = _T("Topic");
	const LPCTSTR kszIfExec  = _T("ifexec");
	
	const LPCTSTR kszShellEx = _T("shellex");
	const LPCTSTR kszPS      = _T("PropertySheetHandlers");
	const LPCTSTR pszCLSID   = _T("{06712C80-5BDC-11D4-B8EE-B5DE61CA987B}");
	const LPCTSTR pszPage    = _T("Muzip.Archive.Page");
	
	// Rechercher le chemin de la DLL contenant les ressources
	// (pour les icnes des archives et des scripts)
	TCHAR pszResDLL[MAX_PATH];
	GetModuleFileName(NULL, pszResDLL, nbArray(pszResDLL));
	PathRemoveFileSpec(pszResDLL);
	PathAppend(pszResDLL, _T("Resource.dll"));
	TCHAR pszIcone1[MAX_PATH+2], pszIcone2[MAX_PATH+2];
	wsprintf(pszIcone1, _T("%s,1"), pszResDLL);
	wsprintf(pszIcone2, _T("%s,2"), pszResDLL);
	
	struct REG
	{
		LPCTSTR pszKey1;
		LPCTSTR pszKey2;
		LPCTSTR pszKey3;
		LPCTSTR pszKey4;
		LPCTSTR pszKey5;
		LPCTSTR pszValue;
	};
	
	lstrcat(pszPath, _T(" \"%1\""));
	TCHAR pszEditScript[MAX_PATH+3];
	lstrcat(lstrcpy(pszEditScript, pszPath), _T(" /e"));
	
	const REG aReg[] =
	{
		{ kszScriptExt, NULL,       NULL,     NULL,    NULL,      kszScript },
		{ kszScript,    NULL,       NULL,     NULL,    NULL,      _T("Script Muzip") },
		{ kszScript,    kszIcone,   NULL,     NULL,    NULL,      pszIcone2 },
		{ kszScript,    kszShell,   kszOpen,  NULL,    NULL,      _T("E&xcuter") },
		{ kszScript,    kszShell,   kszOpen,  kszCmd,  NULL,      pszPath },
		{ kszScript,    kszShell,   kszOpen,  kszDDE,  NULL,      _T("[open(\"%1\")]") },
		{ kszScript,    kszShell,   kszOpen,  kszDDE,  kszIfExec, _T("[open(\"%1\")][quit]") },
		{ kszScript,    kszShell,   kszOpen,  kszDDE,  kszApp,    pszDDEApp },
		{ kszScript,    kszShell,   kszOpen,  kszDDE,  kszTopic,  pszDDETopic },
		{ kszScript,    kszShell,   kszEdit,  NULL,    NULL,      _T("&Edition") },
		{ kszScript,    kszShell,   kszEdit,  kszCmd,  NULL,      pszEditScript },
		{ kszScript,    kszShell,   kszEdit,  kszDDE,  NULL,      _T("[edit(\"%1\")]") },
		{ kszScript,    kszShell,   kszEdit,  kszDDE,  kszApp,    pszDDEApp },
		{ kszScript,    kszShell,   kszEdit,  kszDDE,  kszTopic,  pszDDETopic },
		
		{ kszArchive,   NULL,       NULL,     NULL,    NULL,      _T("Archive Muzip") },
		{ kszArchive,   kszIcone,   NULL,     NULL,    NULL,      pszIcone1 },
		{ kszArchive,   kszShell,   kszOpen,  NULL,    NULL,      _T("&Ouvrir") },
		{ kszArchive,   kszShell,   kszOpen,  kszCmd,  NULL,      pszPath },
		{ kszArchive,   kszShell,   kszOpen,  kszDDE,  NULL,      _T("[open(\"%1\")]") },
		{ kszArchive,   kszShell,   kszOpen,  kszDDE,  kszApp,    pszDDEApp },
		{ kszArchive,   kszShell,   kszOpen,  kszDDE,  kszTopic,  pszDDETopic },
		{ kszArchive,   kszShellEx, kszPS,    NULL,    NULL,      pszPage },
		{ kszArchive,   kszShellEx, kszPS,    pszPage, NULL,      pszCLSID },
		{ kszArchive,   kszShellEx, _T("{00021500-0000-0000-c000-000000000046}"), NULL, NULL, pszCLSID },
	};
	
	for (int i=0; i<nbArray(aReg); i++) {
		const REG &reg = aReg[i];
		
		TCHAR pszKey[MAX_PATH];
		if (reg.pszKey5)
			wsprintf(pszKey, _T("%s\\%s\\%s\\%s\\%s"),
				reg.pszKey1,reg.pszKey2,reg.pszKey3,reg.pszKey4,reg.pszKey5);
		else if (reg.pszKey4)
			wsprintf(pszKey, _T("%s\\%s\\%s\\%s"),
				reg.pszKey1,reg.pszKey2,reg.pszKey3,reg.pszKey4);
		else if (reg.pszKey3)
			wsprintf(pszKey, _T("%s\\%s\\%s"),
				reg.pszKey1,reg.pszKey2,reg.pszKey3);
		else if (reg.pszKey2)
			wsprintf(pszKey, _T("%s\\%s"),
				reg.pszKey1,reg.pszKey2);
		else
			lstrcpy(pszKey, reg.pszKey1);
		
		RegSetValue(HKEY_CLASSES_ROOT, pszKey, REG_SZ,
			reg.pszValue,lstrlen(pszKey)*sizeof(pszKey[0]));
	}
}


// Dsenregistrer Muzip et la DLL du Registre
void CApp::Unregister()
{
	// Dsenregistrer toutes les associations
	for (ASSOC *pAssoc=s_aAssoc; pAssoc->pszAssoc[0]; pAssoc++) {
		HKEY hKey;
		TCHAR pszValeur[MAX_PATH];
		if (pAssoc->GetAssocCur(hKey, pszValeur))
			pAssoc->Affecter(false, hKey, pszValeur);
		if (hKey)  RegCloseKey(hKey);
	}
	
	// Dsenregistrer la DLL
	RegisterDLL(false);
	
	// Supprimer toutes les cls
	RegDeleteKey(HKEY_LOCAL_MACHINE, kszAppPath);
	RegDeleteKey(HKEY_CLASSES_ROOT,  kszScriptExt);
	RegDeleteKey(HKEY_CLASSES_ROOT,  kszScript);
	RegDeleteKey(HKEY_CLASSES_ROOT,  kszArchive);
	
	// Notifier le changement d'association
	ASSOC::NotifyChange();
}


// Enregistrer ou dsenregistrer la DLL d'extension
void CApp::RegisterDLL(bool fRegister)
{
	do{
		
		//*** Il faut d'abord rcuprer le chemin de la DLL
		
		TCHAR pszDLL[MAX_PATH];
		*pszDLL = 0;
		
		// Mthode 1 - Rcuprer le chemin dans le Registre
		// Pour cela rcuprer le CLSID de la DLL
		LPWSTR wszCLSID;
		if (SUCCEEDED(StringFromCLSID(CLSID_MuzipExt, &wszCLSID))) {
			
			// Copier puis librer la chane Unicode
			CString sKey;
			sKey.Format(_T("CLSID\\%ls\\InprocServer32"), wszCLSID);
			e_pidlManager.Free(wszCLSID);
			
			// Lire le chemin dans le Registre
			HKEY hKey;
			if (RegOpenKeyEx(HKEY_CLASSES_ROOT, sKey, 0, KEY_QUERY_VALUE, &hKey)==ERROR_SUCCESS) {
				DWORD dwType, dwLen=sizeof(pszDLL);
				if (RegQueryValueEx(hKey, NULL, NULL, &dwType, (BYTE*)pszDLL, &dwLen)!=ERROR_SUCCESS || dwType!=REG_SZ)
					*pszDLL = 0;
				RegCloseKey(hKey);
			}
		}
		
		// Mthode 2 -  la barbare, en essayant avec le rpertoire courant
		if (!*pszDLL)  lstrcpy(pszDLL, _T("MuzipExt.dll"));
		
		
		bool fOK = false;
		
		// a y est, on a enfin le chemin de la DLL dans pszDLL !
		// On peut donc la charger et appeler sa mthode DllRegisterServer
		// ou DllUnregisterServer
		const HMODULE hDLL = LoadLibrary(pszDLL);
		if (hDLL) {
			typedef HRESULT (STDAPICALLTYPE *DLLREG)();
			
			const DLLREG pfnReg = (DLLREG)GetProcAddress(hDLL,
				(fRegister) ? "DllRegisterServer" : "DllUnregisterServer");
			if (pfnReg)  fOK = SUCCEEDED(pfnReg());
			
			FreeLibrary(hDLL);
		}
		
		if (fOK)  break;
		
	}while (fRegister && AfxMessageBox(ERR_REGISTERDLL,
		MB_RETRYCANCEL | MB_ICONEXCLAMATION)==IDRETRY);
}



//*** ASSOC


// Rcuprer la cl de l'association et l'association courante
// (pszValeur doit avoir une taille de MAX_PATH caractres)
// Retourner TRUE si l'association courante est Muzip
bool ASSOC::GetAssocCur(HKEY& hKey, LPTSTR pszValeur)
{
	*pszValeur = 0;
	
	// Ouvrir la cl correspondant  l'association
	if (RegCreateKeyEx(HKEY_CLASSES_ROOT, pszAssoc, 0, NULL, 0,
			KEY_QUERY_VALUE | KEY_NOTIFY | KEY_SET_VALUE,
			NULL, &hKey, NULL)!=ERROR_SUCCESS)
		// Erreur
		hKey = NULL;
	else{
		// Lire la valeur par dfaut de la cl (l'association courante)
		DWORD dwType;
		DWORD dwLen = MAX_PATH;
		if (RegQueryValueEx(hKey, NULL, NULL, &dwType,
				(BYTE*)pszValeur, &dwLen)==ERROR_SUCCESS && dwType!=REG_SZ)
			*pszValeur = 0;
	}
	
	return !lstrcmpi(pszValeur, pszClasseMuzipArchive);
}


// Affecter ou dsaffecter l'extension  Muzip
void ASSOC::Affecter(bool fToMuzip, HKEY hKey, LPCTSTR pszValeur)
{
	if (fToMuzip) {
		// Sauvegarder l'ancienne valeur
		// et mettre pszClasseMuzipArchive  la place
		lstrcpy(pszOld, pszValeur);
		RegSetValueEx(hKey, NULL, NULL, REG_SZ,
			(const BYTE*)pszClasseMuzipArchive, lstrlen(pszClasseMuzipArchive)+1);
	}else{
		// Restaurer l'ancienne valeur dans le registre
		RegSetValueEx(hKey, NULL, NULL, REG_SZ,
			(const BYTE*)pszOld, lstrlen(pszOld)+1);
		*pszOld = 0;
	}
}



// Notifier Windows de changements concernant les extensions
void ASSOC::NotifyChange()
{
	SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST | SHCNF_FLUSHNOWAIT, 0,0);
}



//*** CMuzipOp

// Constructeur
CMuzipOp::CMuzipOp(const CMuzipArc* pArc, UINT nIDSTitre)
{
	if (!oApp.s_ndlgProgress++) {
		// Afficher le curseur sablier
		// et dsactiver la fentre principale
		oApp.BeginWaitCursor();
		oApp.m_pMainWnd->EnableWindow(FALSE);
		oApp.s_pdlgProgress->EnableWindow(TRUE);
	}
	
	oApp.InitStatusAvance(pArc, nIDSTitre);
}

// Destructeur
CMuzipOp::~CMuzipOp()
{
	if (oApp.s_ndlgProgress==1) {
		oApp.HideStatusAvance();
		
		// Enlever le curseur sablier
		// et ractiver la fentre principale
		oApp.EndWaitCursor();
		oApp.m_pMainWnd->EnableWindow(TRUE);
		
	}else
		oApp.s_ndlgProgress--;
}


//*** CMuzipCmdLine
//
// Gre la compression/dcompression en ligne de commande

// Constructeur
CMuzipCmdLine::CMuzipCmdLine()
	: m_arPlus(NULL, true),
	  m_fQuitter(false), m_hwndLst(NULL), m_pInterract(NULL)
{
	m_nShellCommand = CCommandLineInfo::FileNothing;
	m_es            = esMuzip;
}

// Parseur de paramtres
void CMuzipCmdLine::ParseParam(LPCTSTR pszParam, BOOL bFlag, BOOL bLast)
{
	if (bFlag) {
		// Flag
		
		if (!pszParam[1]) {
			// Tous les flags n'ont qu'un caractre
			
			const TCHAR cFlag = (TCHAR)tolower(pszParam[0]);
			
			if (cFlag=='q') { m_fQuitter = true;  return; }
			
			if (m_nShellCommand==FileNothing) {
				if (cFlag=='z') { m_nShellCommand = (SHELLCOMMAND)FileComp;            return; }
				if (cFlag=='u') { m_nShellCommand = (SHELLCOMMAND)FileDecomp;          return; }
				if (cFlag=='a') { m_nShellCommand = (SHELLCOMMAND)FileSendMail;        return; }
				if (cFlag=='i') { m_nShellCommand = (SHELLCOMMAND)FileGetArchiveInfo;  return; }
				if (cFlag=='e') { m_nShellCommand = (SHELLCOMMAND)FileScriptEdit;      return; }
			}
			
			if (m_es==esMuzip) {
				if (cFlag=='m') { m_es = esMenu;  return; }
				if (cFlag=='g') { m_es = esDrop;  return; }
			}
			
			CCommandLineInfo::ParseParam(pszParam, bFlag, bLast);
		}
		
	}else{
		// Pas flag
		
		if (m_nShellCommand<FileComp) {
			// Aucun commutateur n'a t spcifi:
			// il s'agit de l'archive ou du script
			if (m_strFileName.IsEmpty())  m_strFileName = pszParam;
			
		}else if (m_nShellCommand==FileComp) {
				// Fichiers  ajouter/supprimer
				
				CPlusItem *const ppi = new CPlusItem;
				ppi->SetDefautExt();
				ppi->DO_sFiltre = pszParam;
				m_arPlus.AddFin(ppi);
			
		}else if (m_nShellCommand==FileDecomp) {
			// Dossier d'extraction
			
			if (m_sDest.IsEmpty())  m_sDest = pszParam;
			
		}else if (m_nShellCommand==FileGetArchiveInfo) {
			// Numro du mapping ou handle de la liste
			
			if (!m_pInterract) {
				// Numro du mapping
				const int nUnique = (int)_tcstoul(pszParam, NULL, 0);
#ifdef _DEBUG
#undef new
#endif
				m_pInterract = new (nUnique) CInterract(nUnique);
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
				
			}else if (!m_hwndLst)
				// Handle de la liste
				m_hwndLst = (HWND)_tcstoul(pszParam, NULL, 0);
			
		}else
			// Traitement par dfaut
			CCommandLineInfo::ParseParam(pszParam, bFlag, bLast);
	}
	
	if (bLast && m_nShellCommand==FileNothing && !m_strFileName.IsEmpty())
		m_nShellCommand = FileOpen;
}


// Indiquer s'il faut demander les options
bool CMuzipCmdLine::FautDemanderOptions() const
{
	return
		(m_es==esMuzip ||
		(m_es==esMenu && e_opt.m_fCompOptionsDropMenu) ||
		(m_es==esDrop && e_opt.m_fCompOptionsDropArchive));
}


//*** CMuzipDocTemplate

// Crer une archive
CMuzipArc* CMuzipDocTemplate::CreateArchive(CInterf* pi) const
{
	// Crer un document vide
	// Ne pas utiliser CreateNewDocument() car cette fonction
	// fait un tas de choses qui ne nous servent pas
	const CDocument *const pDoc = (CDocument*)m_pDocClass->CreateObject();
	
	// Crer l'archive
	ASSERT_KINDOF(CMuzipDoc, pDoc);
	CMuzipArc *const pArc = ((CMuzipDoc*)pDoc)->CreateArchive(pi);
	
	// Maintenant on n'a plus besoin du document
	delete pDoc;
	
	return pArc;
}

// Grer l'ouverture en mode invisible
void CMuzipDocTemplate::InitialUpdateFrame(CFrameWnd* pFrame, CDocument* pDoc, BOOL bMakeVisible)
{
	if (pDoc->IsKindOf(RUNTIME_CLASS(CGZipDoc)) && ((CGZipDoc*)pDoc)->m_fFautFermer) {
		pDoc->DoFileSave();
		pDoc->OnCloseDocument();
	}else{
		CMultiDocTemplate::InitialUpdateFrame(pFrame, pDoc, bMakeVisible);
		pFrame->ShowWindow(SW_MAXIMIZE);
		if (!CApp::s_fOuvreVisible) {
			pFrame->ShowWindow(SW_HIDE);
			CApp::s_fOuvreVisible = true;
		}
	}
}

// Indiquer si le modle de document correspond  un fichier
// en grant les extensions multiples
CMuzipDocTemplate::Confidence CMuzipDocTemplate::MatchDocType(LPCTSTR pszPathName, CDocument*& rpDocMatch)
{
	ASSERT(ToBool(pszPathName));
	rpDocMatch = NULL;
	
	// Vrifier que le document n'est pas ouvert
	POSITION pos = GetFirstDocPosition();
	while (pos) {
		CDocument *const pDoc = GetNextDoc(pos);
		if (pDoc->GetPathName()==pszPathName) {
			// Dj ouvert
			rpDocMatch = pDoc;
			return yesAlreadyOpen;
		}
	}
	
	// Rcuprer la chane du filtre
	CString sFilterExt;
	if (!GetDocString(sFilterExt, CDocTemplate::filterExt) ||
	     sFilterExt.IsEmpty())
		return yesAttemptForeign;
	
	// Regarder si le fichier a une des extensions proposes
	const LPCTSTR pszExt = PathFindExtension(pszPathName);
	if (pszExt) {
		const TCHAR *pcSep = sFilterExt;
		for (;;) {
			ASSERT(*pcSep=='.');
			
			const TCHAR *const pcSepTemp = _tcschr(pcSep, ';');
			
			// Regarder si l'extension correspond
			if (!pcSepTemp) {
				if (!lstrcmpi(pszExt, pcSep))  return yesAttemptNative;
				break;
			}
			if (CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
					pszExt,pcSepTemp-pcSep, pcSep,pcSepTemp-pcSep)==CSTR_EQUAL)
				return yesAttemptNative;
			pcSep = pcSepTemp+1;
		}
	}
	
	// L'extension ne correspond  aucun template
	return yesAttemptForeign;
}
