// Muzip2.h
//
// Classes auxiliaires utilises dans Muzip.cpp


#ifndef _MUZIP2_H_
#define _MUZIP2_H_
#if _MSC_VER>1000
#pragma once
#endif


#include "PlusItem.h"
class CMuzipArc;
class CInterf;
class CInterract;


enum EXECSOURCE
{
	esMuzip,
	esMenu,
	esDrop,
};


struct ASSOC
{
	TCHAR pszAssoc[16];
	TCHAR pszOld  [MAX_PATH];
	
	bool GetAssocCur(HKEY& hKey, LPTSTR pszValeur);
	void Affecter(bool fToMuzip, HKEY hKey, LPCTSTR pszValeur=NULL);
	
	
	static void NotifyChange();
};


// Opration longue de Muzip
class CMuzipOp
{
public:  // Fonctions
	
	CMuzipOp(const CMuzipArc* pArc=NULL, UINT nIDSTitre=0);
	~CMuzipOp();
};


// Gestion de la ligne de commande
enum
{
	FileComp = 100,
	FileDecomp,
	FileSendMail,
	FileGetArchiveInfo,
	FileScriptEdit,
};
#define SHELLCOMMAND  CCommandLineInfo::__unnamed

class CMuzipCmdLine : public CCommandLineInfo
{
public:  // Hritage
	
	CMuzipCmdLine();
	
	void ParseParam(LPCTSTR pszParam, BOOL bFlag, BOOL bLast);
	bool FautDemanderOptions() const;
	
	
public:  // Donnes
	
	CString      m_sDest;        // Dossier d'extraction
	CArchivePlus m_arPlus;       // Fichiers  ajouter
	CLstStr1     m_lstFichier;   // Fichiers  extraire
	EXECSOURCE   m_es;           // Source de la commande
	bool         m_fQuitter;     // TRUE s'il faut quitter aprs excution
	HWND         m_hwndLst;      // Liste  initialiser
	CInterract  *m_pInterract;   // Pour interraction avec la DLL
};


// Modle de documents
class CMuzipDocTemplate : public CMultiDocTemplate
{
public:  // Fonctions
	
	CMuzipDocTemplate(UINT nIDStrings, UINT nIDResource,
		CRuntimeClass* pDocClass,
		CRuntimeClass* pFrameClass,
		CRuntimeClass* pViewClass)
		: CMultiDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass)
		{
			m_strDocStrings.LoadString(nIDStrings);
		}
	
	UINT GetResourceID() const { return m_nIDResource; }
	
	CMuzipArc* CreateArchive(CInterf* pi) const;
	
	
public:  // Hritage
	
	void InitialUpdateFrame(CFrameWnd* pFrame, CDocument* pDoc, BOOL bMakeVisible=TRUE);
	Confidence MatchDocType(LPCTSTR pszPathName, CDocument*& rpDocMatch);
};


#endif
