// MuzipDoc.cpp


#include "StdAfx.h"
#include "Interract.h"   // Ici car utilise new
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "MuzipDoc.h"
#include "MuzipArc.h"
#include "TarDoc.h"
#include "GZipDoc.h"
#include "UueDoc.h"
#include "Interf.h"

#include "IOFichier.h"

#include "MainFrame.h"
#include "MuzipFrame.h"
#include "ArboView.h"
#include "MuzipView.h"
#include "ApercuView.h"

#include "PlusItem.h"
#include "Recherche.h"

#include "Decomp.h"

#include "dlgConfirm.h"
#include "dlgRech.h"
#include "dlgArchivePlus.h"
#include "dlgExtraire.h"
#include "dlgLister.h"
#include "dlgSfx.h"
#include "dlgMdp.h"
#include "dlgComment.h"
#include "dlgOptions.h"

#include "Options.h"
#include "Reg.h"


IMPLEMENT_DYNAMIC(CMuzipDoc, CDocument)
BEGIN_MESSAGE_MAP(CMuzipDoc, CDocument)
	//{{AFX_MSG_MAP(CMuzipDoc)
	ON_COMMAND          (ID_FILE_DELETE,               OnFileDelete)
	ON_COMMAND          (ID_FILE_SEND_MAIL,            OnFileSendMail)
	ON_COMMAND          (ID_ARCHIVE_PLUS,              OnArchivePlus)
	ON_COMMAND          (ID_ARCHIVE_GZIP,              OnArchiveGZip)
	ON_COMMAND          (ID_ARCHIVE_NOUVEAUDOSSIER,    OnArchiveNouveauDossier)
	ON_COMMAND          (ID_ARCHIVE_RM,                OnArchiveRm)
	ON_COMMAND          (ID_ARCHIVE_MDP,               OnArchiveMdp)
	ON_COMMAND          (ID_ARCHIVE_RECHERCHER,        OnArchiveRechercher)
	ON_COMMAND          (ID_ARCHIVE_RECHERCHERSUIVANT, OnArchiveRechercherSuivant)
	ON_COMMAND          (ID_ARCHIVE_RECHERCHERFILTRER, OnArchiveRechercherFiltrer)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE,                 OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_GZIP,              OnUpdateArchiveGZip)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_NOUVEAUDOSSIER,    OnUpdateArchiveNouveauDossier)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_MAJ,               OnUpdateArchiveMaj)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_RM,                OnUpdateArchiveRm)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_RECHERCHERFILTRER, OnUpdateArchiveRechercherFiltrer)
	ON_COMMAND          (ID_FILE_LISTER,               OnFileLister)
	ON_COMMAND          (ID_ARCHIVE_UUE,               OnArchiveUue)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_UUE,               OnUpdateArchiveUue)
	ON_COMMAND          (ID_ARCHIVE_MAJ,               OnArchiveMaj)
	ON_COMMAND          (ID_ARCHIVE_COMMENT,           OnArchiveComment)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_COMMENT,           OnUpdateArchiveComment)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_COMMENT,         OnUpdateIndicatorComment)
	ON_COMMAND          (ID_ARCHIVE_SFX,               OnArchiveSfx)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_SFX,               OnUpdateArchiveSfx)
	ON_COMMAND          (ID_APERCU_DOS,                OnApercuDOS)
	ON_COMMAND          (ID_APERCU_RETOUR,             OnApercuRetour)
	ON_COMMAND          (ID_APERCU_POLICE,             OnApercuPolice)
	ON_COMMAND          (ID_APERCU_OPTIONS,            OnApercuOptions)
	ON_UPDATE_COMMAND_UI(ID_APERCU_DOS,                OnUpdateApercuDOS)
	ON_UPDATE_COMMAND_UI(ID_APERCU_RETOUR,             OnUpdateApercuRetour)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_FILE_SEND_MAIL,            CDocument::OnUpdateFileSendMail)
END_MESSAGE_MAP()



// Constructeur
CMuzipDoc::CMuzipDoc()
{
	m_pArc   = NULL;
	m_pCur   = NULL;
	m_pDragD = NULL;
}

// Destructeur
CMuzipDoc::~CMuzipDoc()
{
	if (m_pArc)  m_pArc->Release(true);
}


// Ouverture
BOOL CMuzipDoc::OnOpenDocument(LPCTSTR pszFichier)
{
	if (m_pArc)  m_pArc->Release(true);
	
	m_pArc = OpenArchive(pszFichier, this);
	return ToBool(m_pArc);
}


// Supprimer le contenu
void CMuzipDoc::DeleteContents()
{
	m_pCur = NULL;
	if (m_pArc) {
		m_pArc->m_pi->OnDossierChange();
		m_pArc->Release(true);
	}
	
	m_pArc = CreateArchive(new CInterfDoc(this));
}


// Enregistrement
BOOL CMuzipDoc::OnSaveDocument(LPCTSTR)
{
	m_pArc->Reconstruire();
	return TRUE;
}


// Fermeture
void CMuzipDoc::OnCloseDocument()
{
	if (m_pArc)  m_pArc->CloseDocument();
	CDocument::OnCloseDocument();
}


// Reconstruire si ncessaire, avec demande de confirmation
BOOL CMuzipDoc::SaveModified()
{
	if (IsModified()) {
		// Demander confirmation
		const int nRes = AfxMessageBox(DEM_FERMER, MB_YESNOCANCEL);
		if (nRes==IDCANCEL)  return FALSE;
		if (nRes==IDYES)     m_pArc->Reconstruire();
	}
	return TRUE;
}


// Supprimer l'archive
void CMuzipDoc::OnFileDelete()
{
	// Supprimer l'archive et fermer le document
	m_pArc->ReadClose();
	if (CDlgConfirm::GetReponse(e_opt.m_fConfirmFileDelete, DEM_FILEDELETE) &&
	    FichierSupprimer(GetPathName(), true))
		OnCloseDocument();
	else
		m_pArc->ReadOpen();
}


// Lister l'archive
void CMuzipDoc::OnFileLister()
{
	CDlgLister(m_pArc).DoModal();
}


// Envoyer un message
void CMuzipDoc::OnFileSendMail()
{
	const BOOL bModified = IsModified();
	if (SaveModified()) {
		SetModifiedFlag(FALSE);
		m_pArc->ReadClose();
		CDocument::OnFileSendMail();
		m_pArc->ReadOpen();
		SetModifiedFlag(bModified);
	}
}


// Demander les fichiers  ajouter dans un dossier
// et passer le contrle au document pour la compression
void CMuzipDoc::OnArchivePlus()
{
	CArchivePlus arPlus(NULL, true);
	if (CDlgArchivePlus(m_pArc, arPlus, m_pArc->m_sMdp).DoModal()==IDOK)
		m_pArc->ArchivePlus(arPlus);
}

// Compresser en GZip
void CMuzipDoc::OnArchiveGZip()
{
	// Rajouter (ou remplacer) l'extension voulue  l'archive
	// et crer le fichier correspondant
	TCHAR pszFichier[MAX_PATH];
	if (e_opt.m_fCompGZipExtAjouter)
		wsprintf(pszFichier, _T("%s%s"), GetPathName(), e_opt.m_sCompGZipExt);
	else{
		lstrcpy(pszFichier, GetPathName());
		PathRenameExtension(pszFichier, '.'+e_opt.m_sCompGZipExt);
	}
	
	// Demander confirmation d'un ventuel crasement
	if (!FichierEcraser(pszFichier))  return;
	
	m_pArc->Convertir(pszFichier);
}
void CMuzipDoc::OnUpdateArchiveGZip(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(IsKindOf(RUNTIME_CLASS(CTarDoc)));
}

// Encoder en UUE
void CMuzipDoc::OnArchiveUue()
{
	// Rajouter (ou remplacer) l'extension voulue  l'archive
	// et crer le fichier correspondant
	TCHAR pszFichier[MAX_PATH];
	lstrcpy(pszFichier, GetPathName());
	PathRenameExtension(pszFichier, _T(".uue"));
	
	// Demander confirmation d'un ventuel crasement
	if (!FichierEcraser(pszFichier))  return;
	
	m_pArc->Convertir(pszFichier);
}
void CMuzipDoc::OnUpdateArchiveUue(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(!IsKindOf(RUNTIME_CLASS(CUueDoc)));
}

// Crer un auto-extractible
void CMuzipDoc::OnArchiveSfx()
{
	CDlgSfx dlgSfx;
	dlgSfx.m_sEXE = m_pArc->m_sPath;
	PathRenameExtension(dlgSfx.m_sEXE.GetBuffer(MAX_PATH), _T(".exe"));
	dlgSfx.m_sEXE.ReleaseBuffer();
	
	if (dlgSfx.DoModal()==IDOK && FichierEcraser(dlgSfx.m_sEXE))
		m_pArc->ArchiveSfx(dlgSfx.m_sEXE, dlgSfx.m_sDest, ToBool(dlgSfx.m_fEcraser));
}
void CMuzipDoc::OnUpdateArchiveSfx(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(ToBool(m_pArc->GetCap() & capSfx));
}


// Nouveau dossier
void CMuzipDoc::OnArchiveNouveauDossier()
{
	m_ptrv->ArchiveNouveauDossier(m_pCur);
}
void CMuzipDoc::OnUpdateArchiveNouveauDossier(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_pArc->GetCap() & capCommentaire);
}


// Mettre  jour
void CMuzipDoc::OnArchiveMaj()
{
	m_pArc->Reconstruire();
}
void CMuzipDoc::OnUpdateArchiveMaj(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(IsModified());
}


// Rechercher
void CMuzipDoc::OnArchiveRechercher()
{
	RECHOPTIONS &rch = oApp.s_rch;
	if (CDlgRech(true, rch).DoModal()==IDCANCEL)  return;
	m_pArc->Rechercher();
	
	if (m_plst) {
		if (m_pArc->m_fRechFiltre)  m_plst->OnUpdate(NULL, NULL,NULL);
		else                        m_plst->OnArchiveRechercherSuivant();
	}
}

// Rechercher suivant
void CMuzipDoc::OnArchiveRechercherSuivant()
{
	if (m_plst)  m_plst->OnArchiveRechercherSuivant();
}

// Filtrer recherche
void CMuzipDoc::OnArchiveRechercherFiltrer()
{
	m_pArc->m_fRechFiltre = !m_pArc->m_fRechFiltre;
	m_plst->OnUpdate(NULL,NULL,NULL);
}
void CMuzipDoc::OnUpdateArchiveRechercherFiltrer(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_pArc->m_fRechFiltre);
}


// Reconstruction manuelle
void CMuzipDoc::OnArchiveRm()
{
	if (m_pArc->m_fRm && IsModified()) {
		if (!CDlgConfirm::GetReponse(e_opt.m_fConfirmMaj, DEM_MAJ))
			return;
		m_pArc->Reconstruire();
	}
	m_pArc->m_fRm = !m_pArc->m_fRm;
}
void CMuzipDoc::OnUpdateArchiveRm(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_pArc->m_fRm);
}

// Mot de passe
void CMuzipDoc::OnArchiveMdp()
{
	CDlgMdp(m_pArc->m_sMdp).DoModal();
}

// Commentaires
void CMuzipDoc::OnArchiveComment()
{
	CDlgComment dlgComment;
	dlgComment.m_s = m_pArc->GetComment();
	if (dlgComment.DoModal()==IDOK)  m_pArc->SetComment(dlgComment.m_s);
}
void CMuzipDoc::OnUpdateArchiveComment(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(ToBool(m_pArc->GetCap() & capCommentaire));
}
void CMuzipDoc::OnUpdateIndicatorComment(CCmdUI*)
{
	const LPCTSTR pszComment = m_pArc->GetComment();
	((CMainFrame*)oApp.m_pMainWnd)->SetComment(pszComment && *pszComment);
}


// Enregistrer
void CMuzipDoc::OnUpdateFileSave(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(FALSE);
}


//*** Pour CApercuView

// Retour  la ligne automatique
void CMuzipDoc::OnApercuRetour()
{
	m_papr->m_fRetour = !m_papr->m_fRetour;
	m_papr->m_rtf.SetTargetDevice(NULL, !m_papr->m_fRetour);
}
void CMuzipDoc::OnUpdateApercuRetour(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_papr->m_fRetour);
}

// Texte DOS
void CMuzipDoc::OnApercuDOS()
{
	m_papr->m_fDOS = !m_papr->m_fDOS;
	m_papr->m_pApercu->MAJ();
}
void CMuzipDoc::OnUpdateApercuDOS(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_papr->m_fDOS);
}

// Police
void CMuzipDoc::OnApercuPolice()
{
	if (m_papr->m_pApercu->GetToolBarID()==IDR_APERCUPOLICE) {
		m_papr->m_pApercu->OnSetPoliceFont();
		return;
	}
	
	LOGFONT lf;
	oApp.s_fntVoir.GetLogFont(&lf);
	
	// Demander la police
	CFontDialog dlg(&lf, CF_BOTH);
	if (dlg.DoModal()==IDCANCEL)  return;
	dlg.GetCurrentFont(&lf);
	oApp.SetFontVoir(&lf);
}


// Options
void CMuzipDoc::OnApercuOptions()
{
	CDlgOptions((CPropertyPage CDlgOptions::*)&CDlgOptions::m_pgApercu).DoModal();
}
