// MuzipDrop.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "MuzipDrop.h"

#include "IOFichier.h"

#include "ArboView.h"

#include "MuzipDoc.h"
#include "MuzipArc.h"
#include "Dossier.h"
#include "Options.h"
#include "Decomp.h"

#include "PlusItem.h"
#include "dlgPlusItem.h"


CMuzipDataSource *CMuzipDataSource::s_pmds = NULL;


//*** CMuzipDropTarget

// Glisser-dplacer - Dplacement
DROPEFFECT CMuzipDropTarget::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint)
{
	if (dwKeyState)  m_dwKeyState = dwKeyState;
	
	// Rejeter le glisser-dplacer:
	// - si les donnes ne sont pas des fichiers
	// - si MAJ et CTRL sont enfonces (raccourcis impossibles)
	if (!pDataObject->IsDataAvailable(CF_HDROP) ||
	   (dwKeyState & (MK_SHIFT | MK_CONTROL))==(MK_SHIFT | MK_CONTROL))
		return DROPEFFECT_NONE;
	
	// MAJ: zipper puis supprimer l'original
	// CTRL: zipper sans supprimer l'original
	// Automatique: dplacer si source et destination dans
	// la mme archive, copier sinon
	
	// Grer la touche Maj
	if (dwKeyState & MK_SHIFT)  goto Move;
	
	// Grer le mode automatique
	
	if (!(dwKeyState & MK_CONTROL) &&
			pDataObject->IsDataAvailable(oApp.s_cfMuzip)) {
		// Rcuprer les donnes spciales  Muzip
		const HGLOBAL hMem = pDataObject->GetGlobalData(oApp.s_cfMuzip);
		const LPCTSTR pszNom = (LPCTSTR)GlobalLock(hMem);
		const bool fMeme = (!lstrcmpi(pszNom, m_pDoc->GetPathName()));
		GlobalUnlock(hMem);
		
		// Source et destination appartiennent  la mme archive
		if (fMeme)  goto Move;
	}
	
	// En dernier recours, prendre la copie par dfaut
	return DROPEFFECT_COPY;
	
	
Move:
	if (CMuzipDataSource::s_pmds) {
		if (CMuzipDataSource::s_pmds->m_pDossier) {
			// Empcher le dplacement d'un dossier
			// dans lui-mme ou dans un de ses sous-dossiers
			const CDossier *pDossier = m_pDoc->m_pDragD;
			while (pDossier) {
				if (pDossier==CMuzipDataSource::s_pmds->m_pDossier)
					return DROPEFFECT_NONE;
				pDossier = pDossier->m_pParent;
			}
		}else{
			// Empcher le dplacement d'un fichier dans son dossier
			if (CMuzipDataSource::s_pmds->m_lstFichier.GetDeb()->m_pDossier==m_pDoc->m_pDragD)
				return DROPEFFECT_NONE;
		}
	}
	
	return DROPEFFECT_MOVE;
}

// Glisser-dplacer - Lcher
BOOL CMuzipDropTarget::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint)
{
	if (dropEffect==DROPEFFECT_MOVE &&
	    pDataObject->IsDataAvailable(oApp.s_cfMuzip)) {
		
		// Rcuprer les donnes spciales  Muzip
		const HGLOBAL hMem = pDataObject->GetGlobalData(oApp.s_cfMuzip);
		const LPCTSTR pszNom = (LPCTSTR)GlobalLock(hMem);
		const bool fMeme = (!lstrcmpi(pszNom, m_pDoc->GetPathName()));
		GlobalUnlock(hMem);
		if (fMeme) {
			
			const CMuzipDataSource &mds = *CMuzipDataSource::s_pmds;
			
			// Renommer les fichiers/dossiers
			if (mds.m_pDossier) {
				// Dossier
				
				// Changer le parent du dossier:
				// l'enlever de son ancien parent
				CDossier *const poldParent = mds.m_pDossier->m_pParent;
				poldParent->m_lstDossier.RemoveAt(
					poldParent->m_lstDossier.Find(mds.m_pDossier));
				m_pDoc->m_ptrv->m_ptrv->DeleteItem(mds.m_pDossier->m_hti);
				// L'ajouter  son nouveau parent
				mds.m_pDossier->m_pParent = m_pDoc->m_pDragD;
				m_pDoc->m_pDragD->m_lstDossier.AddFin(mds.m_pDossier);
				mds.m_pDossier->MAJPath();
				mds.m_pDossier->trvLister();
				
			}else{
				// Fichiers
				
				POS pos = mds.m_lstFichier.GetPosDeb();
				while (pos) {
					CFichier *const pFichier = mds.m_lstFichier.GetSuiv(pos);
					
					// Changer le parent des fichiers:
					// l'enlever de son ancien parent
					pFichier->m_pDossier->m_lstFichier.RemoveAt(
						pFichier->m_pDossier->m_lstFichier.Find(pFichier));
					// L'ajouter  son nouveau parent
					pFichier->m_pDossier = m_pDoc->m_pDragD;
					pFichier->m_pDossier->m_lstFichier.AddFin(pFichier);
				}
			}
			m_pDoc->m_pArc->FautReconstruire(ToBool(e_opt.m_fCompRmMove));
			
			// Indiquer que le dplacement est dj effectu
			CMuzipDataSource::s_pmds = NULL;
			
			return TRUE;
			
			#undef mds
		}
	}
	
	// Demander les donnes
	const HDROP hDrop = (HDROP)pDataObject->GetGlobalData(CF_HDROP);
	if (!hDrop)  return TRUE;
	
	{
		oApp.m_pMainWnd->SetForegroundWindow();
		
		// Utiliser les options par dfaut,
		// en enlevant tous les critres restrictifs
		CPlusItem pi;
		pi.SetDefautExt();
		pi.CO_fActionDeplacer = (dropEffect==DROPEFFECT_MOVE);
		
		// Afficher les options si demand
		// Si le bouton droit est enfonc, inverser l'option
		// d'affichage des paramtres de compression
		if (ToBool(e_opt.m_fCompOptionsDropMuzip) ^
		    ToBool(m_dwKeyState & MK_RBUTTON)) {
			// Bouton droit enfonc: demander les options
			if (CDlgPlusItem(m_pDoc->m_pArc, pi, m_pDoc->m_pArc->m_sMdp, false).DoModal()==IDCANCEL)
				goto Erreur;
		}
		
		// Rcuprer la liste des fichiers
		UINT nbFichier = ::DragQueryFile(hDrop, (UINT)-1, NULL,0);
		if (!nbFichier)  goto Erreur;
		TCHAR pszFichier[MAX_PATH];
		for (;;) {
			nbFichier--;
			::DragQueryFile(hDrop, nbFichier, pszFichier, nbArray(pszFichier));
			pi.DO_sFiltre += pszFichier;
			if (!nbFichier)  break;
			pi.DO_sFiltre += ';';
		}
		
		// Ajouter les fichiers  l'archive
		// En mode dplacement, supprimer les fichiers ajouts avec succs
		CArchivePlus arPlus(m_pDoc->m_pCur);
		arPlus.AddDeb(&pi);
		m_pDoc->m_pArc->ArchivePlus(arPlus);
	}
	
Erreur:
	::DragFinish(hDrop);
	
	// Retourner TRUE mme en cas d'erreur,
	// pour ne pas laisser le message  CMainFrame
	return TRUE;
}

// Glisser-dplacer - Lcher tendu
DROPEFFECT CMuzipDropTarget::OnDropEx(COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint pt)
{
	if (!(m_dwKeyState & MK_RBUTTON))  return (DROPEFFECT)-1;
	
	// Crer le menu contextuel
	CMenu mnu;
	mnu.LoadMenu(IDM_CONTEXT);
	CMenu *const pMenu = mnu.GetSubMenu(2);
	
	// Dsactiver les items correspondant aux actions non-gres par la source
	if (!(dropList & DROPEFFECT_COPY))
		pMenu->EnableMenuItem(ID_DROP_COPY, MF_BYCOMMAND | MF_DISABLED);
	if (!(dropList & DROPEFFECT_MOVE))
		pMenu->EnableMenuItem(ID_DROP_MOVE, MF_BYCOMMAND | MF_DISABLED);
	
	// Dfinir l'item par dfaut
	pMenu->SetDefaultItem(
		  (dropDefault==DROPEFFECT_COPY) ? ID_DROP_COPY
		: (dropDefault==DROPEFFECT_MOVE) ? ID_DROP_MOVE
		: -1);
	
	// Afficher le menu, et convertir l'ID de l'item choisi en DROPEFFECT_*
	GetCursorPos(&pt);
	const UINT nID = (UINT)::TrackPopupMenu(*pMenu,
		TPM_LEFTALIGN | TPM_RIGHTBUTTON | TPM_RETURNCMD | TPM_NONOTIFY,
		pt.x,pt.y, 0, *oApp.m_pMainWnd, NULL);
	if      (nID==ID_DROP_COPY)  dropDefault = DROPEFFECT_COPY;
	else if (nID==ID_DROP_MOVE)  dropDefault = DROPEFFECT_MOVE;
	else                         return        DROPEFFECT_NONE;
	
	// OnDrop fait tout le travail
	return (OnDrop(pDataObject, dropDefault, pt)) ? dropDefault : DROPEFFECT_NONE;
}




//**** CMuzipDataSource

// Initialiser: utiliser le format de presse-papiers Muzip
// pour stocker le nom de l'archive source
void CMuzipDataSource::Init(const CMuzipDoc* pDoc)
{
	const LPCTSTR pszNomDoc = pDoc->GetPathName();
	const size_t len = (lstrlen(pszNomDoc)+1)*sizeof(TCHAR);
	const HGLOBAL hMem = GlobalAlloc(GMEM_SHARE, len);
	if (!hMem)  return;
	const LPTSTR pszNom = (LPTSTR)GlobalLock(hMem);
	if (!pszNom) {
		GlobalFree(hMem);
		return;
	}
	lstrcpy(pszNom, pszNomDoc);
	GlobalUnlock(hMem);
	CacheGlobalData(oApp.s_cfMuzip, hMem);
}

// Demande des donnes
BOOL CMuzipDataSource::OnRenderGlobalData(FORMATETC* pfe, HGLOBAL* phGlobal)
{
	if (m_fErreur)                            return FALSE;
	if (GetKeyState(GetSystemMetrics(SM_SWAPBUTTON)
	    ? VK_RBUTTON : VK_LBUTTON) & 0x8000)  return FALSE;
	if (pfe->cfFormat!=CF_HDROP)              return FALSE;
	if (!(pfe->dwAspect & DVASPECT_CONTENT))  return FALSE;
	if (*phGlobal)                            return FALSE;
	
	if (!m_pData) {
		// Pour viter d'avoir  reconstruire la structure DROPFILES
		//  chaque demande des donnes, on la construit la premire fois
		// dans un tampon interne  l'application, puis on copie ce tampon
		// dans un HGLOBAL  chaque fois que cela est demand
		
		TCHAR pszPathTemp[MAX_PATH];
		if (!e_opt.GetDossierDrag(pszPathTemp))  return FALSE;
		
		size_t lenTout = 1;   // Nul final supplmentaire
		LPTSTR pszTout;
		
		if (m_pDossier) {
			// Dossier
			
			// Dcompresser le dossier
			if (m_pDossier==m_pDossier->m_pArc) {
				TCHAR pszTitle[MAX_PATH];
				lstrcpy(pszTitle, m_pDossier->m_pArc->m_sPath);
				PathStripPath(pszTitle);
				PathRemoveExtension(pszTitle);
				PathAppend(pszPathTemp, pszTitle);
			}else
				PathAppend(pszPathTemp, m_pDossier->m_pszNom);
			
			if (!m_pDossier->DossierExtraire(pszPathTemp)) {
				m_fErreur = true;
				return FALSE;
			}
			
			// Copier la structure
			lenTout += lstrlen(pszPathTemp)+1;
			pszTout  = new TCHAR[lenTout];
			lstrcpy(pszTout, pszPathTemp);
			pszTout[lenTout-1] = 0;
			
		}else{
			// Fichiers
			
			CLstStr2 lstDest;
			POS pos;
			
			CMuzipArc *const pArc = m_lstFichier.GetDeb()->m_pArc;
			DECOMP::e_pfr = &pArc->m_fr;
			CMuzipOp mop(pArc, STA_ARCHIVEEXTRAIRET);
			
			// Initialiser la progression
			DWORD dwTotal = 0;
			pos = m_lstFichier.GetPosDeb();
			while (pos)
				dwTotal += m_lstFichier.GetSuiv(pos)->m_dwTailleC;
			oApp.ShowStatusAvance(dwTotal);
			
			UINT iFichier = 0;
			pos = m_lstFichier.GetPosDeb();
			while (pos && oApp.UpdateProgressStatus()!=prsAnnuler) {
				CFichier *const pFichier = m_lstFichier.GetSuiv(pos);
				oApp.SetProgress(STA_ARCHIVEEXTRAIRE, pFichier->m_pszNom,
					iFichier++, m_lstFichier.GetNb());
				
				// Dcompresser les fichiers
				// et rcuprer la longueur du nom de destination
				LPTSTR pszDest;
				if (!pFichier->ArchiveExtraireSuite(pszPathTemp, &pszDest) &&
				    !oApp.DemanderEncoreErreur(pos))
					break;
				new CSurvDecomp(NULL, pszDest, pFichier, pFichier->m_pArc);
				lstDest.AddFin(pszDest);
				lenTout += lstrlen(pszDest)+1;
			}
			oApp.HideStatusAvance();
			oApp.s_fMsg = true;
			
			// Si aucun fichier n'a pu tre dcompress, arrter l
			if (lenTout==1) {
				m_fErreur = true;
				return FALSE;
			}
			
			pszTout = new TCHAR[lenTout];
			TCHAR *pc = pszTout;
			pos = lstDest.GetPosDeb();
			while (pos) {
				// Composer la chane de noms de fichiers
				const LPTSTR psz = lstDest.GetSuiv(pos);
				lstrcpy(pc, psz);
				pc += lstrlen(psz);
				pc++;  // Copier la chane suivante aprs le nul final
			}
			*pc = 0;  // Nul final supplmentaire
			lstDest.DeleteAll();
		}
		
		// Allouer de la mmoire
		m_lenData = sizeof(DROPFILES)+lenTout;
		m_pData = new BYTE[m_lenData];
		
		// Construire la structure DROPFILES
		// et y rajouter la liste de fichiers
		DROPFILES *const pdf = (DROPFILES*)m_pData;
		pdf->pFiles = sizeof(DROPFILES);
		GetCursorPos(&pdf->pt);
		pdf->fNC    = TRUE;
		pdf->fWide  = sizeof(TCHAR)>1;
		memcpy(pdf+1, pszTout, lenTout);
		delete [] pszTout;
	}
	oApp.s_fMsg = true;
	
	// Allouer de la mmoire pour l'appelant
	// et y copier la structures DROPFILES
	*phGlobal = GlobalAlloc(GMEM_SHARE | GMEM_MOVEABLE, m_lenData);
	if (!*phGlobal)  return FALSE;
	memcpy(GlobalLock(*phGlobal), m_pData, m_lenData);
	GlobalUnlock(*phGlobal);
	
	return TRUE;
}


// Effectuer le glisser-dplacer
DROPEFFECT CMuzipDataSource::DoDragDrop()
{
	// Il faut interdit  la fentre principale la gestion
	// du glisser-dplacer de fichiers, car sinon si on fait glisser
	// des fichiers  compresser et qu'il y a erreur,
	// Muzip va essayer de les ouvrir en temps qu'archives !
	oApp.m_pMainWnd->DragAcceptFiles(FALSE);
	
	CMuzipDropSource dropSource;
	COleDataSource::DoDragDrop(DROPEFFECT_COPY | DROPEFFECT_MOVE, NULL, &dropSource);
	
	oApp.m_pMainWnd->DragAcceptFiles();
	return dropSource.m_dropEffect;
}


//*** CMuzipDataSource::CMuzipDropSource

// Changement d'icne
SCODE CMuzipDataSource::CMuzipDropSource::GiveFeedback(DROPEFFECT dropEffect)
{
	return COleDropSource::GiveFeedback(m_dropEffect = dropEffect);
}

// Demande de continuation
SCODE CMuzipDataSource::CMuzipDropSource::QueryContinueDrag(BOOL bEscapePressed, DWORD dwKeyState)
{
	const SCODE ret = COleDropSource::QueryContinueDrag(bEscapePressed, dwKeyState);
	if (ret==DRAGDROP_S_CANCEL)  m_dropEffect = DROPEFFECT_NONE;
	return ret;
}
