// MuzipExt.cpp


#include "StdAfx.h"
#include <Liste.h>

#include "../Interract.h"   // Avant #define INITGUID et autres

#define INITGUID
#include <InitGuid.h>
#include "MuzipExt.h"
#include "Resource.h"
#include <afxRes.h>
#include "../Franais/Resource.h"

#include "../Reg.h"


static HINSTANCE s_hInst, s_hInstRes;

const LPCTSTR pszDescription  = _T("Extension Shell de Muzip");
const LPCTSTR kszMuzip        = _T("Software\\Ryder\\Muzip");
const LPCTSTR kszMuzipGeneral = _T("Software\\Ryder\\Muzip\\Gnral");


// Dans GWL_USERDATA de la liste des pages de proprits
struct LSTDATA
{
	HWND        hwndLst;
	WNDPROC     poldWndProc;
	CInterract *pInterract;
};



#define pszZipExtA  ".zip"
#ifdef UNICODE
const LPCTSTR pszZipExt = _T(pszZipExtA);
#else
#define pszZipExt  pszZipExtA
#endif


static DWORD GetFlags();
static int   GetCLSID(LPTSTR pszCLSID);


namespace DDE
{
	static bool s_fOK;
	static HWND s_hwndServer;
	static HWND s_hwndClient;
	const LPCTSTR pszClasse = _T("MuzipExtDDE");
	static LRESULT CALLBACK prcFenetre(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	
	const DWORD maxCommand = 32*MAX_PATH;
	static TCHAR s_psz[maxCommand];
	
	static bool Executer();
};


#define ResultFromShort(i)   ResultFromScode(MAKE_SCODE(SEVERITY_SUCCESS, 0, (WORD)(i)))
#define HRVERIF(exp)         { if (FAILED(exp))  return E_FAIL; }
#define REGERR(f)            ((f)!=ERROR_SUCCESS)


static HICON s_hIcon = NULL;
static UINT  s_nbDLLRef = 0;
static UINT  s_aid[4];   // ID des items insrs dans le menu



const LPCTSTR pszMuzip = _T("Muzip.exe");

const LPCTSTR pszFromMenu = _T("\")][FromMenu]");
const LPCTSTR pszFromDrop = _T("\")][FromDrop]");



// Retourner les flags d'affichage
DWORD GetFlags()
{
	DWORD dwFlags = gsDefaut;
	HKEY hKey;
	if (!REGERR(RegOpenKeyEx(HKEY_CURRENT_USER, kszMuzipGeneral, 0, KEY_QUERY_VALUE, &hKey))) {
		DWORD dwType, dwLen=sizeof(dwFlags);
		if (REGERR(RegQueryValueEx(hKey, eszGeneralShell, 0, &dwType, (BYTE*)&dwFlags, &dwLen)) ||
		    dwType!=REG_DWORD)
			dwFlags = gsDefaut;
		RegCloseKey(hKey);
	}
	return dwFlags;
}


// Convertir le CLSID de MuzipExt en chane et retourner la longueur du rsultat
int GetCLSID(LPTSTR pszCLSID)
{
	// Convertir le CLSID en chane
	LPWSTR wszCLSID;
	if (FAILED(StringFromCLSID(CLSID_MuzipExt, &wszCLSID)))  return 0;
	
	// Copier puis librer la chane Unicode
	strfromW(pszCLSID, wszCLSID, MAX_PATH);
	IMalloc *pMalloc;
	if (SUCCEEDED(SHGetMalloc(&pMalloc))) {
		pMalloc->Free(wszCLSID);
		pMalloc->Release();
	}
	
	return lstrlen(pszCLSID);
}


// Notification DLL
BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwReason, void*)
{
	switch (dwReason) {
		
		// Attachement processus
		case DLL_PROCESS_ATTACH:
			s_hInst = hModule;
			
			// Charger la DLL contenant les ressources
			TCHAR pszResourceDLL[MAX_PATH];
			GetModuleFileName(s_hInst, pszResourceDLL, nbArray(pszResourceDLL));
			PathRemoveFileSpec(pszResourceDLL);
			PathAppend(pszResourceDLL, _T("Resource.dll"));
			s_hInstRes = LoadLibrary(pszResourceDLL);
			if (!s_hInstRes)  return FALSE;
			break;
		
		// Dtachement processus
		case DLL_PROCESS_DETACH:
			if (s_hInstRes)  FreeLibrary(s_hInstRes);
			break;
	}
	
	return TRUE;
}

// Demande de dchargement
STDAPI DllCanUnloadNow()
{
	return (s_nbDLLRef==0) ? S_OK : S_FALSE;
}

// Demande d'interface
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, void** ppvOut)
{
	*ppvOut = NULL;
	if (IsEqualIID(rclsid, CLSID_MuzipExt))
		return (new CMuzipExtClassFactory)->QueryInterface(riid, ppvOut);
	
	return CLASS_E_CLASSNOTAVAILABLE;
}


const LPCTSTR pszCM       = _T("ContextMenuHandlers\\Muzip");
const LPCTSTR pszApproved = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved");

struct
{
	LPCTSTR ksz1;
	LPCTSTR ksz2;
}
static const s_akszShellExt[] =
{
	{ _T("*"),             pszCM },
	{ _T("Directory"),     pszCM },
	{ _T("Muzip.Archive"), _T("DropHandler") },
};
const LPCTSTR pszShellExtFormat = _T("%s\\shellex\\%s");


// Enregistrement
STDAPI DllRegisterServer()
{
	int i;
	
	// Convertir le CLSID en chane
	TCHAR pszCLSID[MAX_PATH];
	const int lenCLSID = GetCLSID(pszCLSID);
	if (!lenCLSID)  return E_OUTOFMEMORY;
	
	HRESULT hr = SELFREG_E_CLASS;
	
	TCHAR pszDLL[MAX_PATH];
	HKEY hKey = NULL;
	TCHAR pszKey[MAX_PATH];
	const TCHAR pszApartment[] = _T("Apartment");
	
	GetModuleFileName(s_hInst, pszDLL, nbArray(pszDLL));
	
	// Crer la cl du CLSID
	wsprintf(pszKey, _T("CLSID\\%s"), pszCLSID);
	
	// CLSID\{CLSID} = description
	if (REGERR(RegCreateKeyEx(HKEY_CLASSES_ROOT, pszKey, 0, NULL, 0, KEY_WRITE, NULL, &hKey, NULL)))
		goto Erreur;
	if (REGERR(RegSetValueEx(hKey, NULL, 0, REG_SZ,
	   (const BYTE*)pszDescription, sizeof(pszDescription))))
		goto Erreur;
	
	// CLSID\{CLSID}\InProcServer32                 = <Chemin DLL>
	// CLSID\{CLSID}\InProcServer32, ThreadingModel = "Apartment"
	lstrcat(pszKey, _T("\\InprocServer32"));
	RegCloseKey(hKey);
	hKey = NULL;
	if (REGERR(RegCreateKeyEx(HKEY_CLASSES_ROOT, pszKey, 0, NULL, 0, KEY_WRITE, NULL, &hKey, NULL)))
		goto Erreur;
	if (REGERR(RegSetValueEx(hKey, NULL, 0, REG_SZ,
	   (const BYTE*)pszDLL, (lstrlen(pszDLL)+1)*sizeof(pszDLL[0]))))
		goto Erreur;
	if (REGERR(RegSetValueEx(hKey, _T("ThreadingModel"), 0, REG_SZ,
	   (const BYTE*)pszApartment, nbArray(pszApartment)*sizeof(pszApartment[0]))))
		goto Erreur;
	
	// HKEY_CLASSES_ROOT\*\shellex\ContextMenuHandlers\Muzip = <CLSID>
	// HKEY_CLASSES_ROOT\Directory\shellex\ContextMenuHandlers\Muzip = <CLSID>
	// HKEY_CLASSES_ROOT\Muzip.Archive\shellex\DragDropHandlers\Muzip = <CLSID>
	for (i=0; i<nbArray(s_akszShellExt); i++) {
		wsprintf(pszKey, pszShellExtFormat, s_akszShellExt[i].ksz1, s_akszShellExt[i].ksz2);
		if (REGERR(RegSetValue(HKEY_CLASSES_ROOT, pszKey,
				REG_SZ, pszCLSID, lenCLSID*sizeof(pszCLSID[0]))))
			goto Erreur;
	}
	
	// HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved
	//   <CLSID> = <Description>
	if (REGERR(RegCreateKeyEx(HKEY_LOCAL_MACHINE, pszApproved,
	    0, NULL, 0, KEY_WRITE, NULL, &hKey, NULL)))
		goto Erreur;
	if (REGERR(RegSetValueEx(hKey, pszCLSID, 0, REG_SZ,
	   (const BYTE*)pszDescription, nbArray(pszDescription))))
		goto Erreur;
	
	hr = S_OK;
	
Erreur:
	
	if (hKey)  RegCloseKey(hKey);
	
	return hr;
}

// Dsenregistrement
STDAPI DllUnregisterServer()
{
	int i;
	
	// Convertir le CLSID en chane
	// On va l'utiliser tout de suite aprs,
	// donc le copier dans pszKey
	TCHAR pszKey[MAX_PATH] = _T("CLSID\\");
	const int lenDebutCLSID = lstrlen(pszKey);
	if (!GetCLSID(pszKey+lenDebutCLSID))  return E_OUTOFMEMORY;
	
	// Effacer:
	// HKEY_CLASSES_ROOT\CLSID\{<CLSID>}
	// HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved, <CLSID>
	RegDeleteKey(HKEY_CLASSES_ROOT, pszKey);
	HKEY hKey;
	if (!REGERR(RegOpenKeyEx(HKEY_LOCAL_MACHINE, pszApproved, 0, KEY_SET_VALUE, &hKey))) {
		RegDeleteValue(hKey, pszKey+lenDebutCLSID);
		RegCloseKey(hKey);
	}
	// HKEY_CLASSES_ROOT\*\shellex\ContextMenuHandlers\Muzip
	// HKEY_CLASSES_ROOT\Directory\shellex\ContextMenuHandlers\Muzip
	// HKEY_CLASSES_ROOT\Muzip.Archive\shellex\DragDropHandlers\Muzip
	for (i=0; i<nbArray(s_akszShellExt); i++) {
		wsprintf(pszKey, pszShellExtFormat, s_akszShellExt[i].ksz1, s_akszShellExt[i].ksz2);
		RegDeleteKey(HKEY_CLASSES_ROOT, pszKey);
	}
	
	return S_OK;
}



//*** CMuzipExtClassFactory

// Constructeur
CMuzipExtClassFactory::CMuzipExtClassFactory()
{
	m_nbRef = 0;
	s_nbDLLRef++;
}

// Destructeur
CMuzipExtClassFactory::~CMuzipExtClassFactory()
{
	s_nbDLLRef--;
}


//*** IUnknown

// Demande d'interface
STDMETHODIMP CMuzipExtClassFactory::QueryInterface(REFIID riid, void** ppvOut)
{
	if (IsEqualIID(riid, IID_IUnknown) ||
	    IsEqualIID(riid, IID_IClassFactory))
		*ppvOut = (IClassFactory*)this;
	else{
		*ppvOut = NULL;
		return E_NOINTERFACE;
	}
	
	AddRef();
	return S_OK;
}

// Gestion des instances
STDMETHODIMP_(ULONG) CMuzipExtClassFactory::AddRef()
{
	return ++m_nbRef;
}
STDMETHODIMP_(ULONG) CMuzipExtClassFactory::Release()
{
	if (--m_nbRef)  return m_nbRef;
	delete this;
	return 0;
}



//*** IClassFactory

// Cration
STDMETHODIMP CMuzipExtClassFactory::CreateInstance(
	IUnknown* pUnkOuter, REFIID riid, void** ppvObj)
{
	*ppvObj = NULL;
	
	if (pUnkOuter)  return CLASS_E_NOAGGREGATION;
	
	// Crer l'objet principal
	CMuzipExt *const pMuzipExt = new CMuzipExt;
	if (!pMuzipExt)  return E_OUTOFMEMORY;
	return pMuzipExt->QueryInterface(riid, ppvObj);
}

// Blocage
STDMETHODIMP CMuzipExtClassFactory::LockServer(BOOL fLock)
{
	if (fLock)  m_nbRef++;
	else        m_nbRef--;
	return S_OK;
}



//*** CMuzipExt

// Constructeur
CMuzipExt::CMuzipExt()
{
	m_nbRef      = 0;
	s_nbDLLRef++;
	
	m_pdoFichier = NULL;
	m_hDrop      = NULL;
}

// Destructeur
CMuzipExt::~CMuzipExt()
{
	if (m_pdoFichier) {
		ReleaseStgMedium(&m_stmDrop);
		m_pdoFichier->Release();
	}
	s_nbDLLRef--;
}

// Demande d'interface
STDMETHODIMP CMuzipExt::QueryInterface(REFIID riid, void** ppvOut)
{
	if (IsEqualIID(riid, IID_IUnknown) ||
	    IsEqualIID(riid, IID_IShellExtInit))
		*ppvOut = (IShellExtInit*)this;
#define GERER_INTERFACE(nom) \
	else if (IsEqualIID(riid, IID_##nom)) \
		*ppvOut = (##nom*)this;
	GERER_INTERFACE(IContextMenu3)
	GERER_INTERFACE(IContextMenu2)
	GERER_INTERFACE(IContextMenu)
	GERER_INTERFACE(IPersistFile)
	GERER_INTERFACE(IDropTarget)
	GERER_INTERFACE(IQueryInfo)
	GERER_INTERFACE(IShellPropSheetExt)
#undef GERER_INTERFACE
	else{
		*ppvOut = NULL;
		return E_NOINTERFACE;
	}
	
	AddRef();
	return S_OK;
}

// Gestion des instances
STDMETHODIMP_(ULONG) CMuzipExt::AddRef()
{
	return ++m_nbRef;
}
STDMETHODIMP_(ULONG) CMuzipExt::Release()
{
	if (--m_nbRef)  return m_nbRef;
	delete this;
	return 0;
}


// Le fichier  manipuler est dfini
void CMuzipExt::InitFichier()
{
	const TCHAR apszExt[][4] =
	{
		_T("zip"),
		_T("gz"),_T("z"),_T("tgz"), _T("taz"),
		_T("tar"),
		_T("uue"), _T("uu"), _T("xxe"),
	};
	
	// Regarder si le fichier est une archive,
	// et lui ajouter l'extension Zip si ce n'en est pas une
	m_fIsArchive = false;
	lstrcpy(m_pszArchive, m_pszFichier);
	LPTSTR pszExt = PathFindExtension(m_pszArchive);
	if (pszExt && *pszExt) {
		pszExt++;   // Sauter le point
		for (int i=0;; i++) {
			if (i==nbArray(apszExt)) {
				lstrcpy(pszExt, pszZipExt+1);   // +1 pour sauter le point
				break;
			}
			if (!lstrcmpi(pszExt, apszExt[i])) {
				m_fIsArchive = true;
				break;
			}
		}
	}else
		lstrcpy(pszExt, pszZipExt);
	
	// m_pszArchiveQ == m_pszArchive mais avec des guillemets en plus
	PathQuoteSpaces(lstrcpy(m_pszArchiveQ, m_pszArchive));
}


//*** IShellExtInit

// Initialiser
STDMETHODIMP CMuzipExt::Initialize(
	LPCITEMIDLIST, IDataObject* pdo, HKEY)
{
	if (m_pdoFichier) {
		ReleaseStgMedium(&m_stmDrop);
		m_pdoFichier->Release();
		m_pdoFichier = NULL;
		m_hDrop      = NULL;
	}
	if (pdo) {
		
		// Rcuprer le HDROP dans fe.hGlobal
		FORMATETC fe;
		fe.cfFormat = CF_HDROP;
		fe.ptd      = NULL;
		fe.dwAspect = DVASPECT_CONTENT;
		fe.lindex   = -1;
		fe.tymed    = TYMED_HGLOBAL;
		HRVERIF(pdo->QueryGetData(&fe));
		HRVERIF(pdo->GetData(&fe, &m_stmDrop));
		
		// Il doit au moins y avoir un fichier
		m_nbDrop = DragQueryFile((HDROP)m_stmDrop.hGlobal, (UINT)-1, NULL, 0);
		if (!m_nbDrop)  return E_FAIL;
		
		m_pdoFichier = pdo;
		m_pdoFichier->AddRef();
		m_hDrop = (HDROP)m_stmDrop.hGlobal;
		DragQueryFile(m_hDrop, 0, m_pszFichier, nbArray(m_pszFichier));
		InitFichier();
	}
	return S_OK;
}


//*** IPersistFile

STDMETHODIMP CMuzipExt::Load(LPCOLESTR pszFichier, DWORD)
{
	strfromW(m_pszFichier, pszFichier, nbArray(m_pszFichier));
	InitFichier();
	return S_OK;
}


//*** IDropTarget

STDMETHODIMP CMuzipExt::DragEnter(
	IDataObject* pdo, DWORD, POINTL, DWORD* pdwEffect)
{
	if (!(GetFlags() & gsDrop))  return E_NOTIMPL;
	
	// Vrifier que les donnes comportent un objet de type HDROP
	// et changer en consquence la forme du curseur (copie ou interdit)
	FORMATETC fe;
	fe.cfFormat = CF_HDROP;
	fe.ptd      = NULL;
	fe.dwAspect = DVASPECT_CONTENT;
	fe.lindex   = -1;
	fe.tymed    = TYMED_HGLOBAL;
	*pdwEffect = (!pdo || pdo->QueryGetData(&fe)!=S_OK)
		? DROPEFFECT_NONE : DROPEFFECT_COPY;
	
	return S_OK;
}
STDMETHODIMP CMuzipExt::DragOver(DWORD, POINTL, DWORD*)
{
	return S_OK;
}
STDMETHODIMP CMuzipExt::DragLeave()
{
	return S_OK;
}
STDMETHODIMP CMuzipExt::Drop(
	IDataObject* pdo, DWORD, POINTL, DWORD* pdwEffect)
{
	// Rcuprer dans stm.hGlobal le handle HDROP
	// correspondant aux fichiers passs
	STGMEDIUM stm;
	FORMATETC fe;
	fe.cfFormat = CF_HDROP;
	fe.ptd      = NULL;
	fe.dwAspect = DVASPECT_CONTENT;
	fe.lindex   = -1;
	fe.tymed    = TYMED_HGLOBAL;
	if (!pdo)  return E_INVALIDARG;
	HRVERIF(pdo->QueryGetData(&fe));
	HRVERIF(pdo->GetData(&fe, &stm));
	
	m_hDrop  = (HDROP)stm.hGlobal;
	m_nbDrop = DragQueryFile(m_hDrop, (UINT)-1, NULL, 0);
	
	// Former la commande DDE:
	// [zip("%Archive%","%Fichiers%")]
	wsprintf(DDE::s_psz, _T("[zip(\"%s\",\""), m_pszArchive);
	ListerFichierMenu(pszFromDrop);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// MUZIP.EXE Archive /z g /q
		
		wsprintf(DDE::s_psz, _T("%s /z /g /q"), m_pszArchiveQ);
		ListerFichierMenuQ();
		DragQueryFile(m_hDrop, 0, m_pszDir, nbArray(m_pszDir));
		PathRemoveFileSpec(m_pszDir);
		m_hWnd  = NULL;
		m_nShow = SW_SHOWNORMAL;
		ShellExecute();
	}
	ReleaseStgMedium(&stm);
	
	*pdwEffect = DROPEFFECT_COPY;
	return S_OK;
}



//*** IContextMenu

// Demande d'ajout d'items de menu
STDMETHODIMP CMuzipExt::QueryContextMenu(
	HMENU hMenu, UINT indexMenu, UINT idCmdFirst, UINT, UINT uFlags)
{
	if (uFlags & (CMF_DEFAULTONLY | CMF_VERBSONLY))  return S_OK;
	
	// Lire le style des menus dans le registre
	const DWORD dwFlags = GetFlags();
	
	if (!(dwFlags & gsMenu))  return S_OK;
	
	// Rcuprer la version du Shell
	bool fShell4 = false;
	const HINSTANCE hShell32 = LoadLibrary(_T("Shell32.dll"));
	if (hShell32) {
		
		// Rcuprer la fonction DllGetVersion()
		const DLLGETVERSIONPROC pDllGetVersion =
			(DLLGETVERSIONPROC)GetProcAddress(hShell32,
				"DllGetVersion");
		
		// Appeler la fonction
		// Si elle est introuvable, c'est la version 4
		if (pDllGetVersion) {
			DLLVERSIONINFO dvi;
			dvi.cbSize = sizeof(dvi);
			if (SUCCEEDED(pDllGetVersion(&dvi)))
				fShell4 = (dvi.dwMajorVersion>=4);
		}else
			fShell4 = true;
		
		FreeLibrary(hShell32);
	}
	
	const bool fIcone     = ToBool(dwFlags & gsMenuIcone);
	const bool fOwnerDraw = (fShell4 && fIcone);
	
	const int maxItem = 5;
	const int buf = 256+MAX_PATH;
	static TCHAR s_apsz[maxItem][buf];
	LPTSTR psz = (LPTSTR)s_apsz;
	
	const UINT nType = (fOwnerDraw)
		? MFT_STRING | MFT_OWNERDRAW
		: MFT_STRING;
	
	MENUITEMINFO mii;
	mii.cbSize          = sizeof(mii);
	mii.wID             = idCmdFirst;
	if (!fOwnerDraw || fIcone) {
		// Dfinir les bitmaps de coche
		mii.hbmpChecked   = NULL;
		mii.hbmpUnchecked = (fIcone)
			? (HBITMAP)LoadImage(s_hInstRes,
				MAKEINTRESOURCE(IDB_APP), IMAGE_BITMAP, 0,0,
				LR_DEFAULTCOLOR | LR_DEFAULTSIZE | LR_LOADMAP3DCOLORS)
			: NULL;
	}
	
	if (dwFlags & gsMenuSous) {
		// Insrer un sous-menu
		
		// Crer le sous-menu
		mii.hSubMenu = CreatePopupMenu();
		
		// Insrer le sous-menu dans le menu donn par Windows
		mii.fMask      = (fIcone)
			? MIIM_TYPE | MIIM_SUBMENU | MIIM_CHECKMARKS
			: MIIM_TYPE | MIIM_SUBMENU;
		mii.fType      = MFT_STRING;
		mii.dwTypeData = psz;
		LoadString(s_hInstRes, AFX_IDS_APP_TITLE, psz, buf);
		InsertMenuItem(hMenu, indexMenu, TRUE, &mii);
		
		// Utiliser le sous menu comme menu parent,
		// et repartir au premier item
		hMenu     = mii.hSubMenu;
		indexMenu = 0;
		
	}else{
		// Insrer un sparateur
		InsertMenu(hMenu, indexMenu++, MF_BYPOSITION | MF_SEPARATOR, 0,NULL);
		idCmdFirst--;
	}
	
	// Rcuprer le nom du premier fichier slectionn,
	// sans chemin d'accs ni extension
	TCHAR pszFichier[MAX_PATH];
	lstrcpy(pszFichier, m_pszFichier);
	PathStripPath(pszFichier);
	
	// Prparer l'insertion d'items
	mii.fMask = (fOwnerDraw)
		? MIIM_ID | MIIM_TYPE | MIIM_DATA
		: MIIM_ID | MIIM_TYPE | MIIM_DATA | MIIM_CHECKMARKS;
	mii.fType = nType;
	
	UINT *pid = s_aid;
	if (m_fIsArchive) {
		// Archive
		
		// Ouvrir avec Muzip
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_OUVRIR, psz, buf);
		*_tcschr(psz, '\n') = 0;
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
		
		// Extraire...
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_EXTRAIRE, psz, buf);
		*_tcschr(psz, '\n') = 0;
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
		
		// Extraire dans
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_EXTRAIREAUTO, psz, buf);
		PathRemoveExtension(pszFichier);
		PathQuoteSpaces    (pszFichier);
		lstrcpy(_tcschr(psz, '\n'), pszFichier);
		m_idItemPerso = MAKELONG(mii.wID-idCmdFirst, 0);
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
		
		// Attacher  une archive
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_MAIL, psz, buf);
		*_tcschr(psz, '\n') = 0;
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
		
	}else{
		// Autres fichiers
		
		// Compresser...
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_COMPRESSER, psz, buf);
		*_tcschr(psz, '\n') = 0;
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
		
		// Compresser dans
		mii.dwItemData = (DWORD)(mii.dwTypeData = psz);
		LoadString(s_hInstRes, *pid++ = CMD_COMPRESSERAUTO, psz, buf);
		PathRenameExtension(pszFichier, pszZipExt);
		PathQuoteSpaces(pszFichier);
		lstrcpy(_tcschr(psz, '\n'), pszFichier);
		m_idItemPerso = MAKELONG(mii.wID-idCmdFirst, 1);
		mii.wID++;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		psz += buf;
	}
	
	if (!(dwFlags & gsMenuSous)) {
		// Insrer le sparateur final
		mii.fMask = MIIM_TYPE;
		mii.fType = MFT_SEPARATOR;
		InsertMenuItem(hMenu, indexMenu++, TRUE, &mii);
		idCmdFirst--;
	}
	
	// Retourner le nombre d'items ajouts
	return ResultFromShort(mii.wID-idCmdFirst+1);
}

// Commande invoque
STDMETHODIMP CMuzipExt::InvokeCommand(CMINVOKECOMMANDINFO* pcmi)
{
	if (!m_pdoFichier)  return E_FAIL;
	if (HIWORD(pcmi->lpVerb))  return E_INVALIDARG;
	
	if (pcmi->lpDirectory)
		strfromA(m_pszDir, pcmi->lpDirectory, nbArray(m_pszDir));
	else{
		lstrcpy(m_pszDir, m_pszFichier);
		PathRemoveFileSpec(m_pszDir);
	}
	
	m_hWnd  = pcmi->hwnd;
	m_nShow = pcmi->nShow;
	
	switch (s_aid[LOWORD(pcmi->lpVerb)-1]) {
		case CMD_OUVRIR:         cmdOuvrir();          break;
		case CMD_EXTRAIRE:       cmdExtraire();        break;
		case CMD_EXTRAIREAUTO:   cmdExtraireAuto();    break;
		case CMD_COMPRESSER:     cmdCompresser();      break;
		case CMD_COMPRESSERAUTO: cmdCompresserAuto();  break;
		case CMD_MAIL:           cmdMail();            break;
	}
	
	return S_OK;
}

// Texte d'aide demand
STDMETHODIMP CMuzipExt::GetCommandString(
	UINT idCmd, UINT, UINT*, LPSTR pszName, UINT cchMax)
{
	// Charger la chane dans un tampon de copie
	LPTSTR pszTemp = new TCHAR[cchMax];
	if (!pszTemp)  return E_FAIL;
	if (!LoadString(s_hInstRes, s_aid[idCmd-1], pszTemp, cchMax)) {
		delete [] pszTemp;
		return E_FAIL;
	}
	
	// Ne prendre qu' partir du '\n'
	strtoA(pszName, _tcschr(pszTemp, '\n')+1, cchMax);
	delete [] pszTemp;
	
	// Rajouter le nom du premier fichier slectionn si ncessaire
	if (idCmd==LOWORD(m_idItemPerso)) {
		char pszPath[MAX_PATH];
		strtoA(pszPath, m_pszFichier, nbArray(pszPath));
		PathStripPathA(pszPath);
		if (HIWORD(m_idItemPerso))  PathRenameExtensionA(pszPath, pszZipExtA);
		else                        PathRemoveExtensionA(pszPath);
		lstrcatA(pszName, pszPath);
	}
	
	return S_OK;
}


//*** IContextMenu2

// Dessin personnalis
STDMETHODIMP CMuzipExt::HandleMenuMsg(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return HandleMenuMsg2(uMsg, wParam, lParam, NULL);
}
STDMETHODIMP CMuzipExt::HandleMenuMsg2(UINT uMsg, WPARAM, LPARAM lParam, LRESULT*)
{
	switch (uMsg) {
		
		// Mensurations
		case WM_MEASUREITEM:
			{
				#define pmis  ((MEASUREITEMSTRUCT*)lParam)
				
				const HDC hdc = GetDC(NULL);
				SelectObject(hdc, GetStockObject(DEFAULT_GUI_FONT));
				SIZE size;
				GetTextExtentPoint32(hdc, (LPCTSTR)pmis->itemData,
					lstrlen((LPCTSTR)pmis->itemData), &size);
				ReleaseDC(NULL, hdc);
				
				pmis->itemWidth  = size.cx+GetSystemMetrics(SM_CYMENU);
				pmis->itemHeight = GetSystemMetrics(SM_CYMENU);
				
				#undef pmis
			}
			break;
		
		// Dessin
		case WM_DRAWITEM:
			{
				#define pdis  ((DRAWITEMSTRUCT*)lParam)
				
				// Dessiner le fond
				FillRect(pdis->hDC, &pdis->rcItem, GetSysColorBrush(
					(pdis->itemState & ODS_SELECTED)
						? COLOR_HIGHLIGHT : COLOR_MENU));
				
				// Dessiner l'icne
				if (!s_hIcon)
					s_hIcon = (HICON)LoadImage(s_hInstRes, MAKEINTRESOURCE(IDR_MAINFRAME),
						IMAGE_ICON, 16,16, 0);
				DrawIconEx(pdis->hDC,
					pdis->rcItem.left,
					(pdis->rcItem.top+pdis->rcItem.bottom-16)/2, s_hIcon,
					16,16, 0, NULL, DI_NORMAL);
				
				// Dessiner le texte
				SetTextColor(pdis->hDC, GetSysColor(
					(pdis->itemState & ODS_SELECTED)
						? COLOR_HIGHLIGHTTEXT : COLOR_MENUTEXT));
				SetBkMode(pdis->hDC, TRANSPARENT);
				pdis->rcItem.left += GetSystemMetrics(SM_CYMENU)+2;
				DrawText(pdis->hDC, (LPCTSTR)pdis->itemData, lstrlen((LPCTSTR)pdis->itemData),
					&pdis->rcItem, DT_SINGLELINE | DT_LEFT | DT_VCENTER);
				
				#undef pdis
			}
			break;
		
		// Raccourci clavier
		case WM_MENUCHAR:
			return E_FAIL;
	}
	
	return S_OK;
}


// Ouvrir l'archive
void CMuzipExt::cmdOuvrir()
{
	// Former la commande DDE:
	// [open("%Archive%")][FromMenu]
	wsprintf(DDE::s_psz, _T("[open(\"%s\")][FromMenu]"), m_pszArchive);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		lstrcpy(DDE::s_psz, m_pszArchiveQ);
		ShellExecute();
	}
}


// Extraire l'archive dans un dossier qui sera demand
void CMuzipExt::cmdExtraire()
{
	// Former la commande DDE:
	// [unzip("%Archive%")][FromMenu]
	wsprintf(DDE::s_psz, _T("[unzip(\"%s\")][FromMenu]"),
		m_pszFichier, m_pszFichier);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// %Archive% /u /m /q
		wsprintf(DDE::s_psz, _T("%s /u /m /q"), m_pszArchiveQ);
		ShellExecute();
	}
}

// Extraire l'archive dans le dossier du nom de l'archive
void CMuzipExt::cmdExtraireAuto()
{
	// Former les paramtres:
	// %Archive% /u /m /q %Dossier%
	TCHAR pszParam[MAX_PATH+10+MAX_PATH];
	// Archive et commutateurs
	wsprintf(pszParam, _T("%s /u /m /q "), m_pszArchiveQ);
	TCHAR *pcParam = pszParam+lstrlen(pszParam);
	// Dossier
	lstrcpy(pcParam, m_pszFichier);
	PathRemoveExtension(pcParam);
	
	// Former la commande DDE:
	// [unzip("%Archive%")][FromMenu]
	wsprintf(DDE::s_psz, _T("[unzip(\"%s\",\"%s\")][FromMenu]"),
		m_pszFichier, pcParam);
	
	// Mettre le nom du dossier entre guillemets
	// uniquement pour ShellExecute()
	PathQuoteSpaces(pcParam);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		lstrcpy(DDE::s_psz, pszParam);
		ShellExecute();
	}
}


// Compresser les fichiers dans une archive qui sera demande
void CMuzipExt::cmdCompresser()
{
	// Former la commande DDE:
	// [zip("","%Fichiers%")][FromMenu]
	lstrcpy(DDE::s_psz, _T("[zip(\"\",\""));
	ListerFichierMenu(pszFromMenu);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// MUZIP.EXE /z /m /q Fichiers
		lstrcpy(DDE::s_psz, _T("/z /m /q"));
		ListerFichierMenuQ();
		ShellExecute();
	}
}

// Compresser les fichiers dans une archive portant leur nom
void CMuzipExt::cmdCompresserAuto()
{
	// Former la commande DDE:
	// [zip("%Archive%","%Fichiers%")]
	wsprintf(DDE::s_psz, _T("[zip(\"%s\",\""), m_pszArchive);
	ListerFichierMenu(pszFromMenu);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// MUZIP.EXE Archive /z /m /q Fichiers
		wsprintf(DDE::s_psz, _T("%s /z /m /q"), m_pszArchiveQ);
		ListerFichierMenuQ();
		ShellExecute();
	}
}

// Attacher l'archive  un nouveau mail
void CMuzipExt::cmdMail()
{
	// Former la commande DDE:
	// [mail("%Archive%")]
	wsprintf(DDE::s_psz, _T("[mail(\"%s\")][FromMenu]"), m_pszArchive);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// MUZIP.EXE Archive /a /m /q
		wsprintf(DDE::s_psz, _T("%s /a /m /q"), m_pszArchiveQ);
		ShellExecute();
	}
}


// Lister les fichiers glisss-dplacs dans DDE::s_psz
// Les noms des fichiers sont spars par des points-virgule,
// et la chane est termine par _T("\")][FromMenu]")
void CMuzipExt::ListerFichierMenu(LPCTSTR pszFin)
{
	TCHAR *pc = DDE::s_psz+lstrlen(DDE::s_psz);
	for (UINT i=0; i<m_nbDrop; i++) {
		// Insrer un espace suivi du nom du fichier
		if (i)  *pc++ = ';';
		pc += DragQueryFile(m_hDrop, i, pc, MAX_PATH);
	}
	lstrcpy(pc, pszFin);
}

// Lister les fichiers glisss-dplacs dans DDE::s_psz
// avec guillemets si ncessaire, et terminer la chane
// Les noms des fichiers sont spars par des espaces
void CMuzipExt::ListerFichierMenuQ()
{
	TCHAR *pc = DDE::s_psz+lstrlen(DDE::s_psz);
	for (UINT i=0; i<m_nbDrop; i++) {
		// Insrer un espace suivi du nom du fichier
		*pc++ = ' ';
		DragQueryFile(m_hDrop, i, pc, MAX_PATH);
		PathQuoteSpaces(pc);
		pc += lstrlen(pc);
	}
	*pc = 0;
}

// Executer DDE::s_psz avec ShellExecute
void CMuzipExt::ShellExecute()
{
	::ShellExecute(NULL, NULL, pszMuzip, DDE::s_psz, m_pszDir, m_nShow);
}

// Rcuprer les informations sur l'archive
CInterract* CMuzipExt::GetArchiveInfo(LSTDATA* plstData)
{
	const HWND hwndLst = (plstData) ? plstData->hwndLst : NULL;
	
	// Trouver un numro inutilis
	TCHAR pszEvent[nbArray(pszEventFormat)+2];
	HANDLE hEvent;
	for (int nUnique=1;; nUnique++) {
		
		// Composer le nom de l'vnement
		wsprintf(pszEvent, pszEventFormat, nUnique);
		
		// Le crer et s'assurer qu'il n'existant pas avant
		hEvent = CreateEvent(NULL, FALSE, FALSE, pszEvent);
		if (!hEvent)  return NULL;
		if (GetLastError()!=ERROR_ALREADY_EXISTS)  break;
	}
	CInterract *pInterract = new (nUnique) CInterract(nUnique);
	if (!pInterract)  return NULL;
	pInterract->nbFichier = -1;
	
	pInterract->hwndActive = GetActiveWindow();
	
	// Former la commande DDE:
	// [gai("%Archive%","%nUnique%","%hwndLst%")]
	wsprintf(DDE::s_psz, _T("[gai(\"%s\",\"%d\",\"%lu\")]"),
		m_pszArchive, nUnique, hwndLst);
	
	// Excuter Muzip
	if (!DDE::Executer()) {
		// Former les paramtres:
		// MUZIP.EXE Archive /i /q pszEvent hwndLst
		
		wsprintf(DDE::s_psz, _T("%s /i /q %d %lu"),
			m_pszArchiveQ, nUnique, hwndLst);
		lstrcpy(m_pszDir, m_pszArchiveQ);
		PathRemoveFileSpec(m_pszDir);
		m_hWnd  = NULL;
		m_nShow = SW_HIDE;
		ShellExecute();
	}
	
	// Attendre que Muzip calcule ce qu'on demande
	// On fixe un dlai pour viter qu'Explorer ne gle
	// si on essaye d'ouvrir une trs grosse archive
	// 10 secondes en mode page de proprits (on a le temps),
	// 3 secondes sinon (pour la bulle d'aide)
	WaitForSingleObject(hEvent, (hwndLst) ? 10000 : 3000);
	CloseHandle(hEvent);
	
	if (pInterract->nbFichier==-1) {
		// Muzip n'a pas rpondu  temps
		delete pInterract;
		pInterract = NULL;
	}
	
	return pInterract;
}



//*** IQueryInfo

// Demande de l'info-bulle
STDMETHODIMP CMuzipExt::GetInfoTip(DWORD, LPWSTR* poszTip)
{
	if (!(GetFlags() & gsInfoBulle))  return E_NOTIMPL;
	if (!*m_pszFichier)  return E_NOTIMPL;
	
	IMalloc *pMalloc;
	if (FAILED(SHGetMalloc(&pMalloc)))  return E_NOTIMPL;
	
	HRESULT hrRes = E_FAIL;
	CInterract *const pInterract = GetArchiveInfo();
	if (pInterract) {
		
		//*** Formatter les valeurs
		
		// Rcuprer la chane de formattage
		TCHAR pszFormat[128];
		if (!LoadString(s_hInstRes, IDS_INFOBULLE, pszFormat, nbArray(pszFormat)))
			goto Suite;
		
		// Formatter le nombre de fichiers et la taille dcompresse totale
		WCHAR oszTailleN[32];
		StrFormatByteSizeW(pInterract->dwTailleN, oszTailleN, nbArray(oszTailleN));
		
		// Formatter dans le type de chane natif
		// car wsprintfW n'est pas disponible sous Windows 9x
		WCHAR osz[128];
#ifdef UNICODE
		wsprintf(osz, pszFormat, pInterract->nbFichier, oszTailleN);
#else
		TCHAR psz[nbArray(osz)];
		wsprintf(psz, pszFormat, pInterract->nbFichier, oszTailleN);
		strtoW(osz, psz, nbArray(osz));
#endif
		
		// Allouer un tampon et y copier la chane
		*poszTip = (LPWSTR)pMalloc->Alloc((lstrlenW(osz)+1)*sizeof(poszTip[0]));
		if (!*poszTip) {
			hrRes = E_OUTOFMEMORY;
			goto Suite;
		}
		
		// Tout est OK
		lstrcpyW(*poszTip, osz);
		hrRes = S_OK;
	}
Suite:
	
	pMalloc->Release();
	
	// Ractiver la fentre
	if (pInterract) {
		SetActiveWindow(pInterract->hwndActive);
		delete pInterract;
	}
	
	return hrRes;
}


// Ajout de page
STDMETHODIMP CMuzipExt::AddPages(LPFNADDPROPSHEETPAGE lpfnAddPage, LPARAM lParam)
{
	// Il faut une et une seule archive
	if (m_nbDrop!=1)  return S_OK;
	
	// Crer la page de proprits
	PROPSHEETPAGE psp;
	psp.dwSize      = sizeof(psp);
	psp.dwFlags     = PSP_USECALLBACK;
	psp.hInstance   = s_hInstRes;
	psp.pszTemplate = MAKEINTRESOURCE(IDD_PROPPAGE);
	psp.pfnDlgProc  = PropPageDlgProc;
	psp.pfnCallback = PropPageCallback;
	psp.lParam      = (LPARAM)this;
	
	// La page de proprits compte comme une rfrence  la DLL
	AddRef();
	
	// Crer et ajouter la page
	const HPROPSHEETPAGE hPage = CreatePropertySheetPage(&psp);
	if (hPage) {
		if (lpfnAddPage(hPage, lParam))  return S_OK;
		DestroyPropertySheetPage(hPage);
	}
	
	Release();
	return S_OK;
}

// Remplacement de page
STDMETHODIMP CMuzipExt::ReplacePage(UINT, LPFNADDPROPSHEETPAGE, LPARAM)
{
	return E_FAIL;
}



// Excuter une commande DDE
bool DDE::Executer()
{
	bool fOK = false;
	
	// Enregistrer la classe DDE et crer une fentre
	WNDCLASS wc;
	if (!GetClassInfo(s_hInst, pszClasse, &wc)) {
		wc.style         = 0;
		wc.lpfnWndProc   = prcFenetre;
		wc.cbClsExtra    =
		wc.cbWndExtra    = 0;
		wc.hInstance     = s_hInst;
		wc.hIcon         = NULL;
		wc.hCursor       = NULL;
		wc.hbrBackground = NULL;
		wc.lpszMenuName  = NULL;
		wc.lpszClassName = pszClasse;
		VERIF(RegisterClass(&wc));
	}
	s_hwndClient = CreateWindow(pszClasse, NULL,
		WS_BORDER, 0,0,0,0, NULL,NULL, s_hInst, NULL);
	VERIF(s_hwndClient);
	
	{
		const ATOM atomApp   = GlobalAddAtom(pszDDEApp);
		const ATOM atomTopic = GlobalAddAtom(pszDDETopic);
		s_hwndServer = NULL;
		SendMessage((HWND)-1, WM_DDE_INITIATE,
			(WPARAM)s_hwndClient, MAKELPARAM(atomApp,atomTopic));
		GlobalDeleteAtom(atomApp);
		GlobalDeleteAtom(atomTopic);
		if (!s_hwndServer)  goto Fin;   // WM_DDE_ACK non-reu
		
		
		LPARAM lParam;
		
		// Mettre la commande dans un HGLOBAL
		const HGLOBAL hCommand = GlobalAlloc(
			GMEM_MOVEABLE | GMEM_DDESHARE, lstrlen(s_psz)+1);
		if (!hCommand) {
Terminate:
			lParam = PackDDElParam(WM_DDE_TERMINATE, (UINT)s_hwndClient, 0);
			if (!PostMessage(s_hwndServer, WM_DDE_TERMINATE, lParam, 0))
				FreeDDElParam(WM_DDE_TERMINATE, lParam);
			goto Fin;
		}
		const LPSTR pszCommand = (LPSTR)GlobalLock(hCommand);
		if (!pszCommand) {
			GlobalFree(hCommand);
			goto Terminate;
		}
		strtoA(pszCommand, s_psz, maxCommand);
		GlobalUnlock(hCommand);
		
		// Envoyer la commande
		lParam = PackDDElParam(WM_DDE_EXECUTE, 0, (UINT)hCommand);
		if (!PostMessage(s_hwndServer, WM_DDE_EXECUTE, (WPARAM)s_hwndClient, lParam))  {
			FreeDDElParam(WM_DDE_EXECUTE, lParam);
			GlobalFree(hCommand);
			goto Terminate;
		}
	}
	
	fOK = true;
	
	
Fin:
	DestroyWindow(s_hwndClient);
	return fOK;
}


// Fentre DDE cliente
LRESULT CALLBACK DDE::prcFenetre(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if (uMsg==WM_DDE_ACK) {
		if (!s_hwndServer) {
			// Rponse du serveur
			s_hwndServer = (HWND)wParam;
			GlobalDeleteAtom(HIWORD(lParam));
			GlobalDeleteAtom(LOWORD(lParam));
		}else{
			// Nettoyer
			DDEACK ack;
			HGLOBAL hGlobal;
			UnpackDDElParam(uMsg, lParam, (UINT*)&ack, (UINT*)&hGlobal);
			s_fOK = (!ack.fAck && !ack.fBusy);
			GlobalFree(hGlobal);
			FreeDDElParam(uMsg, lParam);
			
			// Terminer
			PostMessage(s_hwndServer, WM_DDE_TERMINATE, (WPARAM)s_hwndClient, 0);
		}
	}else if (uMsg==WM_DDE_TERMINATE) {
		if (!s_fOK)  PostMessage(s_hwndServer, WM_DDE_TERMINATE, (WPARAM)s_hwndClient, 0);
	}
	
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}


//*** Page de proprits

// Callback
UINT CALLBACK CMuzipExt::PropPageCallback(HWND, UINT uMsg, PROPSHEETPAGE* ppsp)
{
	if (uMsg==PSPCB_RELEASE)  ((CMuzipExt*)ppsp->lParam)->Release();
	
	return TRUE;
}

// Procdure de bote de dialogue
// Paramtre personnalis (DWL_USER) == (CMuzipExt*)this
#pragma warning (disable: 4701)
BOOL CALLBACK CMuzipExt::PropPageDlgProc(HWND hDlg, UINT uMsg, WPARAM, LPARAM lParam)
{
	if (uMsg==WM_INITDIALOG)
		// Initialisation
		SetWindowLong(hDlg, DWL_USER, (LONG)((PROPSHEETPAGE*)lParam)->lParam);
	
	CMuzipExt *const pme = (CMuzipExt*)GetWindowLong(hDlg, DWL_USER);
	
	switch (uMsg) {
		
		// Initialisation
		case WM_INITDIALOG:
			{
				// Sous-classer la liste
				// Mmoriser d'abord l'ancienne procdure de fentre
				// dans GWL_USERDATA avant de sous-classer
				const HWND hwndLst = GetDlgItem(hDlg, IDCLST);
				LSTDATA *const plstData = new LSTDATA;
				plstData->hwndLst     = hwndLst;
				plstData->poldWndProc = (WNDPROC)GetWindowLong(hwndLst, GWL_WNDPROC);
				SetWindowLong(hwndLst, GWL_USERDATA, (LONG)plstData);
				SetWindowLong(hwndLst, GWL_WNDPROC,  (LONG)LstProc);
				
				// Initialiser les labels
				CInterract *const pInterract = pme->GetArchiveInfo(plstData);
				plstData->pInterract = pInterract;
				if (pInterract) {
					
					TCHAR psz[64];
					
					// Nombre de fichiers et de dossiers
					TCHAR pszNb[64];
					LoadString(s_hInstRes, IDS_NB, pszNb,nbArray(pszNb));
					wsprintf(psz, pszNb, pInterract->nbFichier, pInterract->nbDossier);
					SetDlgItemText(hDlg, IDCLBL_NB, psz);
					
					// Taille
					StrFormatByteSize(pInterract->dwTailleN, psz,nbArray(psz));
					SetDlgItemText(hDlg, IDCLBL_TAILLEN, psz);
					
					// Taille compresse
					StrFormatByteSize(pInterract->dwTailleC, psz,nbArray(psz));
					SetDlgItemText(hDlg, IDCLBL_TAILLEC, psz);
				}
				
				// Ractiver la fentre
				SetActiveWindow(pInterract->hwndActive);
			}
			break;
		
		default:
			return FALSE;
	}
	
	return TRUE;
}
#pragma warning (default: 4701)


// Sous-classement de la liste
LRESULT CALLBACK CMuzipExt::LstProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LSTDATA *const plstData = (LSTDATA*)GetWindowLong(hWnd, GWL_USERDATA);
	CInterract *const pInterract = plstData->pInterract;
	
	switch (uMsg) {
		
		// Ajout/dfinition de colonne
		case LVM_SETCOLUMN:
		case LVM_INSERTCOLUMN:
			lParam = (LPARAM)&pInterract->lvc;
			((LVCOLUMN*)lParam)->pszText = pInterract->psz;
			break;
		
		// Ajout/dfinition d'item
		case LVM_SETITEM:
		case LVM_INSERTITEM:
			lParam = (LPARAM)&pInterract->lvi;
			if (((LVITEM*)lParam)->pszText!=LPSTR_TEXTCALLBACK)
				((LVITEM*)lParam)->pszText = pInterract->psz;
			break;
	}
	
	const LRESULT lr = CallWindowProc(plstData->poldWndProc, hWnd, uMsg, wParam, lParam);
	
	// Destruction finale: nettoyage
	if (uMsg==WM_NCDESTROY) {
		delete pInterract;
		delete plstData;
	}
	
	return lr;
}
