// MuzipExt.h


#ifndef _MUZIPEXT_H_
#define _MUZIPEXT_H_


// Menus contextuels pour Windows 95
class CMuzipExtClassFactory : public IClassFactory
{
public:  // Hritage
	
	CMuzipExtClassFactory();
	~CMuzipExtClassFactory();
	
	// IUnknown
	STDMETHODIMP         QueryInterface(REFIID riid, void** ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	
	// IClassFactory
	STDMETHODIMP CreateInstance(IUnknown* pUnkOuter, REFIID riid, void** ppvObj);
	STDMETHODIMP LockServer(BOOL fLock);
	
	
protected:  // Donnes
	
	ULONG m_nbRef;
};


class  CInterract;
struct LSTDATA;


// Classe de l'application
class CMuzipExt : public
	IShellExtInit,
	IDropTarget,
	IContextMenu3,
	IPersistFile,
	IQueryInfo,
	IShellPropSheetExt
{
public:  // Hritage
	
	CMuzipExt();
	~CMuzipExt();
	
	void InitFichier();
	
	
	// IUnknown
	STDMETHODIMP         QueryInterface(REFIID riid, void** ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	
	// IShellExtInit
	STDMETHODIMP Initialize(LPCITEMIDLIST pidlFolder, IDataObject* pDataObj, HKEY hKeyID);
	
	// IDropTarget
	STDMETHODIMP DragEnter(
		IDataObject* pDataObj, DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
	STDMETHODIMP DragOver(
		DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
	STDMETHODIMP DragLeave();
	STDMETHODIMP Drop(
		IDataObject* pDataObj, DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
	
	STDMETHODIMP HandleMenuMsg (UINT uMsg, WPARAM wParam, LPARAM lParam);
	STDMETHODIMP HandleMenuMsg2(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* plResult);
	
	// IContextMenu
	STDMETHODIMP QueryContextMenu(
		HMENU hMenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags);
	STDMETHODIMP InvokeCommand(CMINVOKECOMMANDINFO* pcmi);
	STDMETHODIMP GetCommandString(
		UINT idCmd, UINT uFlags, UINT*, LPSTR pszName, UINT cchMax);
	
	// IPersistFile
	STDMETHODIMP GetClassID(CLSID*)             { return E_FAIL; }
	STDMETHODIMP IsDirty()                      { return S_FALSE; }
	STDMETHODIMP Load         (LPCOLESTR, DWORD);
	STDMETHODIMP Save         (LPCOLESTR, BOOL) { return E_FAIL; }
	STDMETHODIMP SaveCompleted(LPCOLESTR)       { return E_FAIL; }
	STDMETHODIMP GetCurFile   (LPOLESTR*)       { return E_FAIL; }
	
	// IQueryInfo
	STDMETHODIMP GetInfoFlags(DWORD*) { return E_NOTIMPL; }
	STDMETHODIMP GetInfoTip(DWORD dwFlags, LPWSTR* poszTip);
	
	// IShellPropSheetExt
	STDMETHODIMP AddPages   (              LPFNADDPROPSHEETPAGE lpfnAddPage,     LPARAM lParam);
	STDMETHODIMP ReplacePage(UINT uPageID, LPFNADDPROPSHEETPAGE lpfnReplacePage, LPARAM lParam);
	
	
public:  // Fonctions
	
	void cmdOuvrir();
	void cmdExtraire();
	void cmdExtraireAuto();
	void cmdCompresser();
	void cmdCompresserAuto();
	void cmdMail();
	
	
protected:  // Interne
	
	void ListerFichierMenu(LPCTSTR pszFin);
	void ListerFichierMenuQ();
	
	void ShellExecute();
	
	CInterract* GetArchiveInfo(LSTDATA* plstData=NULL);
	
	
	// Page de proprits
	static UINT    CALLBACK PropPageCallback(HWND hDlg, UINT uMsg, PROPSHEETPAGE* ppsp);
	static BOOL    CALLBACK PropPageDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK LstProc         (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	
	
	// Chemin d'accs du fichier cliqu et de l'archive correspondante
	TCHAR        m_pszFichier [MAX_PATH];
	TCHAR        m_pszArchive [MAX_PATH];
	TCHAR        m_pszArchiveQ[MAX_PATH];   // m_pszArchive avec guillemets si ncessaire
	TCHAR        m_pszDir     [MAX_PATH];
	bool         m_fIsArchive;   // TRUE si le fichier est une archive
	HWND         m_hWnd;         // Pour ShellExecute
	int          m_nShow;        // Idem
	
	// Donnes du menu contextuel
	IDataObject *m_pdoFichier;
	STGMEDIUM    m_stmDrop;
	HDROP        m_hDrop;
	UINT         m_nbDrop;
	
	// Gestion du menu contextuel
	DWORD        m_idItemPerso;
	
	UINT         m_nbRef;
};


#endif
