// MuzipView.cpp


#include "StdAfx.h"
#include "Interract.h"   // Ici car utilise new
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "MuzipDoc.h"
#include "MuzipView.h"
#include "ArboView.h"
#include "ApercuView.h"
#include "MuzipArc.h"

#include "Options.h"
#include "Decomp.h"

#include "dlgConfirm.h"
#include "dlgProprietes.h"

#include "Resource.h"

#include <Pidl.h>


IMPLEMENT_DYNCREATE(CMuzipView, CListView)
BEGIN_MESSAGE_MAP(CMuzipView, CListView)
	//{{AFX_MSG_MAP(CMuzipView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_NOTIFY_REFLECT(NM_RCLICK,                OnRClick)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO,          OnGetDispInfo)
	ON_NOTIFY_REFLECT(LVN_ITEMACTIVATE,         OnItemActivate)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED,          OnItemChanged)
	ON_NOTIFY_REFLECT(LVN_KEYDOWN,              OnKeyDown)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK,          OnColumnClick)
	ON_NOTIFY_REFLECT(LVN_BEGINDRAG,            OnBeginDrag)
	ON_NOTIFY_REFLECT(LVN_BEGINLABELEDIT,       OnBeginLabelEdit)
	ON_NOTIFY_REFLECT(LVN_ENDLABELEDIT,         OnEndLabelEdit)
	ON_COMMAND(ID_EDIT_SELECT_ALL,              OnEditSelectAll)
	ON_COMMAND(ID_EDIT_SELECT_INVERT,           OnEditSelectInvert)
	ON_COMMAND(ID_ARCHIVE_MOINS,                OnArchiveMoins)
	ON_COMMAND(ID_ARCHIVE_EXTRAIRE,             OnArchiveExtraire)
	ON_COMMAND(ID_ARCHIVE_RENOMMER,             OnArchiveRenommer)
	ON_COMMAND(ID_ARCHIVE_PROPRIETES,           OnArchiveProprietes)
	ON_COMMAND(ID_ARCHIVE_TESTER,               OnArchiveTester)
	ON_COMMAND(ID_ARCHIVE_RECHERCHERSUIVANT,    OnArchiveRechercherSuivant)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_MOINS,      OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_EXTRAIRE,   OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_RENOMMER,   OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_PROPRIETES, OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_SEL,      OnUpdateIndicatorEtat)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_TOTAL,    OnUpdateIndicatorEtat)
	ON_COMMAND(ID_MUZIPVIEW_APERCU,             OnApercu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CImageList CMuzipView::s_imlHdr;


// Cration
int CMuzipView::OnCreate(CREATESTRUCT* pcs)
{
	m_plst = &GetListCtrl();
	m_fPasEdit = true;
	
	// Slection unique et toujours visible
	pcs->style |= LVS_REPORT | LVS_SHOWSELALWAYS | LVS_EDITLABELS |
		LVS_SHAREIMAGELISTS;
	if (CListView::OnCreate(pcs)==-1)  return -1;
	CMuzipDoc *const pDoc = GetDocument();
	
	InitListCtrl(*m_plst, &e_oInterract);
	
	// Tri initial
	m_nTriColonne = 0;
	m_fTriSens    = 0;
	Trier();
	
	// Enregistrer la cible de glisser/dplacer
	m_mdt.m_pDoc = pDoc;
	m_mdt.Register(m_plst);
	
	// Passer la vue au document
	pDoc->m_plst = this;
	
	return 0;
}


// Initialiser une liste
void CMuzipView::InitListCtrl(CListCtrl& lst, CInterract* pInterract)
{
	CHeaderCtrl *const phdr = lst.GetHeaderCtrl();
	
	// Styles
	lst.SetExtendedStyle(LVS_EX_HEADERDRAGDROP | e_opt.m_nAffichageStyleEx);
	phdr->ModifyStyle(0, HDS_FULLDRAG | HDS_DRAGDROP);
	
	// Liste d'images de l'en-tte des colonnes
	if (!s_imlHdr)  s_imlHdr.Create(IDB_TRI, 16, 2, RGB(192,192,192));
	
	// Crer les colonnes
	TCHAR pszColonne[128], *pcColonne = pszColonne;
	::LoadString(AfxGetResourceHandle(), IDS_COLONNES, pszColonne, 128);
	LVCOLUMN &lvc = pInterract->lvc;
	lvc.mask     = LVCF_TEXT | LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM;
	lvc.iSubItem = 0;
	lvc.pszText  = pInterract->psz;
	
	struct
	{
		UINT uAlign;
		UINT cx;
	}
	const aColonne[] =
	{
		{ LVCFMT_LEFT,   100 },   // Nom
		{ LVCFMT_LEFT,   130 },   // Type
		{ LVCFMT_RIGHT,  100 },   // Taille
		{ LVCFMT_RIGHT,  100 },   // Compress
		{ LVCFMT_CENTER,  45 },   // %
		{ LVCFMT_CENTER, 120 },   // Modifi
		{ LVCFMT_LEFT,    50 },   // Attributs
		{ LVCFMT_LEFT,   100 },   // Chemin
	};
	
	for (int i=0; i<nbArray(aColonne); i++) {
		TCHAR *const pcColonne2 = _tcschr(pcColonne, '\n');
		*pcColonne2 = 0;
		lstrcpy(lvc.pszText, pcColonne);
		pcColonne = pcColonne2+1;
		lvc.fmt      = aColonne[i].uAlign;
		lvc.cx       = aColonne[i].cx;
		lst.InsertColumn(lvc.iSubItem++, &lvc);
	}
	
	// Affecter la liste d'images systme  la liste,
	// et notre liste d'images  l'en-tte
	ListView_SetImageList(lst, oApp.s_himlSystem, LVSIL_SMALL);
	lst.GetHeaderCtrl()->SetImageList(&s_imlHdr);
}


// Mettre  jour
void CMuzipView::OnUpdate(CView*, LPARAM, CObject*)
{
	// Vider la liste
	m_plst->DeleteAllItems();
	
	// Arrter l si aucun dossier n'est slectionn
	CMuzipDoc *const pDoc = GetDocument();
	CMuzipArc *const pArc = pDoc->m_pArc;
	if (!pDoc->m_pCur)  return;
	
	// Prparer l'ajout des items
	const bool fRechFiltre = pArc->m_fRechFiltre;
	
	// Ajouter les items
	CLstFichier &lstFichier = pDoc->m_pCur->m_lstFichier;
	POS pos = lstFichier.GetPosDeb();
	int nItem = 0;
	while (pos) {
		CFichier *const pFichier = lstFichier.GetSuiv(pos);
		
		// Appliquer le filtre si ncessaire
		if (!fRechFiltre || pFichier->m_fRech)
			pFichier->lstLister(*m_plst, nItem++);
	}
	
	// Retrier
	Trier();
}


// Destruction
void CMuzipView::OnDestroy()
{
	CListView::OnDestroy();
	
	GetDocument()->m_plst = NULL;
}


// Slectionner tout
void CMuzipView::OnEditSelectAll()
{
	LVITEM lvi;
	lvi.iItem     = m_plst->GetItemCount();
	lvi.mask      = LVIF_STATE;
	lvi.stateMask =
	lvi.state     = LVIS_SELECTED | LVIS_FOCUSED;
	while (--lvi.iItem>=0)  m_plst->SetItem(&lvi);
}

// Inverser la slection
void CMuzipView::OnEditSelectInvert()
{
	LVITEM lvi;
	lvi.iItem     = m_plst->GetItemCount();
	lvi.mask      = LVIF_STATE;
	lvi.stateMask = LVIS_SELECTED;
	
	while (--lvi.iItem>=0) {
		m_plst->GetItem(&lvi);
		lvi.stateMask = (lvi.stateMask==LVIS_SELECTED)
			? 0 : LVIS_SELECTED;
		m_plst->SetItem(&lvi);
	}
}


// Supprimer
void CMuzipView::OnArchiveMoins()
{
	if (!CDlgConfirm::GetReponse(e_opt.m_fConfirmArchiveMoins, DEM_ARCHIVEMOINS))
		return;
	
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	SetRedraw(FALSE);
	m_plst->DeleteAllItems();
	GetDocument()->m_pArc->ArchiveMoins(lstSel);
	OnUpdate(NULL,NULL,NULL);
	SetRedraw(TRUE);
	Invalidate();
}

// Extraire
void CMuzipView::OnArchiveExtraire()
{
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	GetDocument()->m_pArc->ArchiveExtraire(lstSel);
}

// Renommer
void CMuzipView::OnArchiveRenommer()
{
	m_plst->EditLabel(m_plst->GetSelectionMark());
}

// Proprits
void CMuzipView::OnArchiveProprietes()
{
	CDlgProprietes dlgProprietes(NULL, this);
	GetLstFichierSel(dlgProprietes.m_lstFichier);
	dlgProprietes.DoModal();
}

// Tester
void CMuzipView::OnArchiveTester()
{
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	CMuzipArc *const pArc = GetDocument()->m_pArc;
	if (!lstSel.GetNb())  pArc->ListerFichier(lstSel);
	pArc->ArchiveTester(lstSel);
}


// MAJ: Un fichier au moins doit tre slectionn
void CMuzipView::OnUpdateFautSel(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fPasEdit && m_plst->GetSelectedCount());
}


// Barre d'tat
void CMuzipView::OnUpdateIndicatorEtat(CCmdUI* pCmdUI)
{
	// Faire la somme des tailles des fichiers
	LONGLONG ddwTailleN = 0;
	
	if (pCmdUI->m_nID==ID_INDICATOR_SEL) {
		POSITION pos = m_plst->GetFirstSelectedItemPosition();
		while (pos) {
			const CFichier *const pFichier = (CFichier*)m_plst->GetItemData(m_plst->GetNextSelectedItem(pos));
			ddwTailleN += pFichier->m_dwTailleN;
		}
	}else{
		LVITEM lvi;
		lvi.iItem = m_plst->GetItemCount();
		lvi.mask  = LVIF_PARAM;
		while (--lvi.iItem>=0) {
			m_plst->GetItem(&lvi);
			ddwTailleN += ((CFichier*)lvi.lParam)->m_dwTailleN;
		}
	}
	
	// Formatter
	WCHAR osz[128];
	StrFormatByteSizeW(ddwTailleN, osz, nbArray(osz));
	CString s;
	if (pCmdUI->m_nID==ID_INDICATOR_SEL)
		s.Format(IDS_FMTSEL,   m_plst->GetSelectedCount(), osz);
	else
		s.Format(IDS_FMTTOTAL, m_plst->GetItemCount(),     osz);
	
	pCmdUI->Enable();
	pCmdUI->SetText(s);
}


// Remplir une liste avec les fichiers slectionns
void CMuzipView::GetLstFichierSel(CLstFichier& lstFichier)
{
	POSITION pos = m_plst->GetFirstSelectedItemPosition();
	while (pos)
		lstFichier.AddFin((CFichier*)m_plst->GetItemData(m_plst->GetNextSelectedItem(pos)));
}

// Rcuprer le fichier slectionn, ou NULL s'il y en a aucun ou plusieurs
CFichier* CMuzipView::GetFichierSel()
{
	CFichier *pFichier = NULL;
	
	if (m_plst->GetSelectedCount()==1) {
		POSITION pos = m_plst->GetFirstSelectedItemPosition();
		pFichier = (CFichier*)m_plst->GetItemData(m_plst->GetNextSelectedItem(pos));
	}
	
	return pFichier;
}


// Clic droit
#pragma warning (disable: 4706)
void CMuzipView::OnRClick(NMHDR*, LRESULT*)
{
	m_sm.Nettoyer();
	
	const UINT nb = m_plst->GetSelectedCount();
	if (!nb)  return;
	CPoint pt;
	GetCursorPos(&pt);
	
	// Crer le menu contextuel des fichiers
	CMenu mnu;
	mnu.LoadMenu(IDM_CONTEXT);
	m_sm.SetMenu(mnu.GetSubMenu(0));
	
	DECOMP::e_pfr = &GetDocument()->m_pArc->m_fr;
	TCHAR pszTemp[MAX_PATH];
	
	// Rcuprer le dossier de dcompression et son interface
	IShellFolder *psf;
	if (e_opt.GetDossierTemp(pszTemp) &&
	    (psf = e_pidlManager.GetFolder(pszTemp))) {
		
		// Dcompresser les fichiers et rcuprer leur PIDL
		LPITEMIDLIST *const apidl = new LPITEMIDLIST[m_plst->GetSelectedCount()];
		UINT nbSel = 0;
		POSITION pos = m_plst->GetFirstSelectedItemPosition();
		while (pos) {
			
			// Dcompresser
			LPTSTR pszDest;
			CFichier *const pFichier = (CFichier*)m_plst->GetItemData(m_plst->GetNextSelectedItem(pos));
			if (!pFichier->ArchiveExtraireSuite(pszTemp, &pszDest))  break;
			new CSurvDecomp(NULL, pszDest, pFichier, GetDocument()->m_pArc);
			
			// Rcuprer le PIDL
			const LPITEMIDLIST pidl = e_pidlManager.GetFile(psf,
				PathFindFileName(pszDest));
			if (pidl)  apidl[nbSel++] = pidl;
			
			// On n'a plus besoin du nom
			delete [] pszDest;
		}
		oApp.s_fMsg = true;
		
		m_sm.InitFiles(psf, nbSel, apidl);
		
		// Dtruire les PIDL
		while (nbSel)  e_pidlManager.Free(apidl[--nbSel]);
		delete [] apidl;
		
		// Nettoyer le dossier
		psf->Release();
	}
	
	// Afficher le menu
	m_sm.GetMenu()->TrackPopupMenu(
		TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x,pt.y, this);
}
#pragma warning (default: 4706)

// Double-clic
void CMuzipView::OnItemActivate(NMHDR*, LRESULT*)
{
	ExecuterVerbe(NULL);
}

// Slection modifie
// BUG: on est oblig de dlocaliser ce que devrait faire cette fonction
// dans OnApercu sinon il y a un bug  l'affichage d'un AfxMessageBox:
// la vue reoit un BeginDrag() sans aucune raison valable !
void CMuzipView::OnItemChanged(NMLISTVIEW*, LRESULT*)
{
	if (e_opt.m_fApercuMAJAuto || !m_plst->GetSelectedCount()) {
		CFichier *pFichier = GetFichierSel();
		if (pFichier && (pFichier->m_dwTailleN>>10)<e_opt.m_nApercuTaille)
			PostMessage(WM_COMMAND, ID_MUZIPVIEW_APERCU);
	}else
		GetDocument()->m_papr->PeutApercu();
}

// Mettre  jour l'apercu
void CMuzipView::OnApercu()
{
	GetDocument()->m_papr->SetApercu(GetFichierSel());
}

// Touche enfonce
void CMuzipView::OnKeyDown(NMLVKEYDOWN* pNMKD, LRESULT*)
{
	if (pNMKD->wVKey==VK_DELETE)  OnArchiveMoins();
}


// Clic sur une colonne
void CMuzipView::OnColumnClick(NMLISTVIEW* pNMLV, LRESULT*)
{
	// Trier les items selon la colonne clique
	if (m_nTriColonne==pNMLV->iSubItem)  m_fTriSens    = !m_fTriSens;
	else                                 m_nTriColonne = pNMLV->iSubItem;
	Trier();
}


// - Si les pointeurs p1 et p2 sont nuls, impossible de trier
// - Si le tri est dcroissant, changer p1 et p2
//   pour inverser le rsultat de la comparaison,
//   et rendre lParamSort positif pour qu'il contienne
//   le numro de la colonne  trier  partir de 1

// Trier le contenu d'un dossier
int CALLBACK CMuzipView::prcTriDossier(CFichier* p1, CFichier* p2, LPARAM nColonne)
{
	if (!p1 || !p2)  return 0;
	
	// changer les deux lments  comparer
	// si on doit trier dans l'autre sens (colonne ngative)
	if (nColonne<0) {
		nColonne = -nColonne;
		CFichier *const p3 = p1;
		p1 = p2;
		p2 = p3;
	}
	
	switch (nColonne) {
		
		case 1:
			// Nom
			return lstrcmpi(p1->m_pszNom, p2->m_pszNom);
		
		case 2:
			// Type
			
			// Rcuprer le type des fichiers
			SHFILEINFO shfi1;
			SHGetFileInfo(p1->m_pszNom, FILE_ATTRIBUTE_NORMAL,
				&shfi1, sizeof(shfi1), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
			SHFILEINFO shfi2;
			SHGetFileInfo(p2->m_pszNom, FILE_ATTRIBUTE_NORMAL,
				&shfi2, sizeof(shfi2), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
			return lstrcmpi(shfi1.szTypeName, shfi2.szTypeName);
		
		case 3:
			// Taille
			return p1->m_dwTailleN - p2->m_dwTailleN;
		
		case 4:
			// Compress
			return p1->m_dwTailleC - p2->m_dwTailleC;
		
		case 5:
			// %
			return p1->m_nPC - p2->m_nPC;
		
		case 6:
			// Modifi
			return (int)(p1->m_dtM - p2->m_dtM).GetTotalSeconde();
		
		case 7:
			// Attributs
			return lstrcmp(p1->m_pszAttr, p2->m_pszAttr);
		
#if 0   // Inutile: tous les dossiers ont le mme chemin d'accs
		case 8:
			// Chemin d'accs
			return lstrcmpi(p1->m_pDossier->m_pszPath, p2->m_pDossier->m_pszPath);
#endif
		
		default:
			return 0;
	}
}

// Trier selon une colonne prcise
// Si inewTriSens n'est pas prcis, inverse le sens du tri
// Si inewTriSens>0, tri croissant; Si inewTriSens<0, tri dcroissant
// Si rien n'est spcifi, met  jour le tri
void CMuzipView::Trier()
{
	CHeaderCtrl *const phdr = m_plst->GetHeaderCtrl();
	const int nbItem = phdr->GetItemCount();
	
	// Placer l'image correspondant au sens du tri
	// sur la bonne colonne
	HDITEM hdi;
	for (int i=0; i<nbItem; i++) {
		hdi.mask     = HDI_FORMAT;
		phdr->GetItem(i, &hdi);
		if (i==m_nTriColonne) {
			hdi.mask   = HDI_FORMAT | HDI_IMAGE;
			hdi.fmt   |= HDF_IMAGE;
			hdi.iImage = m_fTriSens;
		}else{
			hdi.mask   = HDI_FORMAT;
			hdi.fmt   &= ~HDF_IMAGE;
		}
		phdr->SetItem(i, &hdi);
	}
	
	// Effectuer le tri
	m_plst->SortItems((PFNLVCOMPARE)prcTriDossier, (m_nTriColonne+1) * ((m_fTriSens) ? -1 : 1));
}


// Demande d'informations
void CMuzipView::OnGetDispInfo(NMLVDISPINFO* pNMDI, LRESULT*)
{
	if (!(pNMDI->item.mask & LVIF_TEXT))  return;
	
	const CFichier *const pFichier = (CFichier*)pNMDI->item.lParam;
	switch (pNMDI->item.iSubItem) {
		
		// Nom
		case 0:
			pNMDI->item.pszText = pFichier->m_pszNom;
			break;
		
		// Attributs
		case 6:
			pNMDI->item.pszText = (LPTSTR)pFichier->m_pszAttr;
			break;
		
		// Chemin
		case 7:
			pNMDI->item.pszText = pFichier->m_pDossier->m_pszPath;
			break;
	}
}

// Glisser-dplacer
void CMuzipView::OnBeginDrag(NMLISTVIEW* pNMLV, LRESULT*)
{
	// Construire la source de donnes OLE
	CMuzipDataSource mds;
	GetLstFichierSel(mds.m_lstFichier);
	mds.DelayRenderData(CF_HDROP);
	mds.Init(GetDocument());
	
	// Effectuer le glisser-dplacer
	if (mds.DoDragDrop()==DROPEFFECT_MOVE) {
		m_plst->SetSelectionMark(pNMLV->iItem);
		oApp.s_nConfirm--;
		OnArchiveMoins();
		oApp.s_nConfirm++;
	}
}


// Renommage - dbut
void CMuzipView::OnBeginLabelEdit(NMLVDISPINFO*, LRESULT* pResult)
{
	*pResult = m_fPasEdit = false;
}

// Renommage - fin
#pragma warning (disable: 4706)
void CMuzipView::OnEndLabelEdit(NMLVDISPINFO* pNMDI, LRESULT* pResult)
{
	m_fPasEdit = true;
	
	// Si on a annul le renommage, ne rien faire
	const LPTSTR pszNom = pNMDI->item.pszText;
	if (pszNom) {
		CFichier *const pFichier = (CFichier*)pNMDI->item.lParam;
		if (*pResult = pFichier->Renommer(pszNom)) {
			// Raffecter l'icne car il peut y avoir eu changement d'extension
			SHFILEINFO shfi;
			SHGetFileInfo(pFichier->m_pszNom, 0, &shfi, sizeof(shfi),
				SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
			pNMDI->item.mask   = LVIF_IMAGE;
			pNMDI->item.iImage = shfi.iIcon;
			m_plst->SetItem(&pNMDI->item);
		}
	}
}
#pragma warning (default: 4706)


// Excuter un verbe sur la slection
void CMuzipView::ExecuterVerbe(LPCTSTR pszVerbe)
{
	// Rcuprer le dossier temporaire
	TCHAR pszTemp[MAX_PATH];
	if (!e_opt.GetDossierTemp(pszTemp))  return;
	
	// Dcompresser et excuter les fichiers slectionns
	CMuzipArc *const pArc = GetDocument()->m_pArc;
	DECOMP::e_pfr = &pArc->m_fr;
	POSITION pos = m_plst->GetFirstSelectedItemPosition();
	while (pos) {
		CFichier *const pFichier = (CFichier*)m_plst->GetItemData(m_plst->GetNextSelectedItem(pos));
		LPTSTR pszDest;
		if (!pFichier->ArchiveExtraireSuite(pszTemp, &pszDest))  break;
		pFichier->SurvExecuter(pszDest, pszTemp, pszVerbe);
		delete [] pszDest;
	}
	oApp.s_fMsg = true;
}


// Poursuivre la recherche
void CMuzipView::OnArchiveRechercherSuivant()
{
	GetDocument()->m_pCur->RechercherSuivant(m_plst->GetSelectionMark());
}


// Glisser-dplacer - Dplacement
DROPEFFECT CMuzipView::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint pt)
{
	GetDocument()->m_pDragD = GetDocument()->m_pCur;
	return m_mdt.OnDragOver(pDataObject, dwKeyState, pt);
}


// Glisser-dplacer - Lcher
BOOL CMuzipView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint pt)
{
	const BOOL bRet = m_mdt.OnDrop(pDataObject, dropEffect, pt);
	CFrameWnd *const pParentFrame = GetParentFrame();
	pParentFrame->ActivateFrame(SW_SHOW);
	pParentFrame->SetActiveView(this);
	return bRet;
}

// Glisser-dplacer - Lcher tendu
DROPEFFECT CMuzipView::OnDropEx(COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint pt)
{
	const BOOL bRet = m_mdt.OnDropEx(pDataObject, dropDefault, dropList, pt);
	CFrameWnd *const pParentFrame = GetParentFrame();
	pParentFrame->ActivateFrame(SW_SHOW);
	pParentFrame->SetActiveView(this);
	return bRet;
}


// Messages
LRESULT CMuzipView::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult;
	return (m_sm.WindowProc(uMsg, wParam, lParam, &lResult))
		? lResult
		: CListView::WindowProc(uMsg, wParam, lParam);
}
