// MuzipView.h


#ifndef _MUZIPVIEW_H_
#define _MUZIPVIEW_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "MuzipDrop.h"

#include <ShellMenu.h>
class CInterract;


class CMuzipView : public CListView
{
	DECLARE_DYNCREATE(CMuzipView)
	
public:  // Fonctions
	
	CMuzipView() { m_sm.SetWnd(this); }
	
	CMuzipDoc* GetDocument() { return (CMuzipDoc*)m_pDocument; }
	CListCtrl *m_plst;
	
	void GetLstFichierSel(CLstFichier& lstFichier);
	CFichier* GetFichierSel();
	
	void Trier();
	
	void ExecuterVerbe(LPCTSTR pszVerbe);
	
	
protected:  // Donnes
	
	CMuzipDropTarget m_mdt;    // Cible du glisser-dplacer
	
	CDossier  *m_pDossier;     // Dossier list
	int        m_nTriColonne;  // Colonne trie
	bool       m_fTriSens;     // Sens de tri
	bool       m_fPasEdit;     // FALSE si un item est en cours de renommage
	
	CShellMenu m_sm;           // Gestion du menu du shell
	
	
	static int CALLBACK prcTriDossier(CFichier* p1, CFichier* p2, LPARAM nColonne);
	
	static CImageList s_imlHdr;   // Liste d'images de sens du tri
	
	
public:  // Statique
	
	static void InitListCtrl(CListCtrl& lst, CInterract* pInterract);
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CMuzipView)
	public:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	protected:
	virtual LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt)
		{ return m_mdt.OnDragEnter(pDataObject, dwKeyState, pt); }
	DROPEFFECT OnDragOver (COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt);
	BOOL       OnDrop     (COleDataObject* pDataObject, DROPEFFECT dropEffect,                       CPoint pt);
	DROPEFFECT OnDropEx   (COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint pt);
	
	
public:  // Messages
	
	//{{AFX_MSG(CMuzipView)
	afx_msg int  OnCreate(CREATESTRUCT* pcs);
	afx_msg void OnDestroy();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditSelectInvert();
	afx_msg void OnArchiveMoins();
	afx_msg void OnArchiveExtraire();
	afx_msg void OnArchiveRenommer();
	afx_msg void OnArchiveProprietes();
	afx_msg void OnArchiveTester();
	afx_msg void OnArchiveRechercherSuivant();
	afx_msg void OnUpdateFautSel      (CCmdUI* pCmdUI);
	afx_msg void OnUpdateIndicatorEtat(CCmdUI* pCmdUI);
	afx_msg void OnRClick        (NMHDR*        pNMHDR, LRESULT* pResult);
	afx_msg void OnGetDispInfo   (NMLVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnItemActivate  (NMHDR*        pNMHDR, LRESULT* pResult);
	afx_msg void OnItemChanged   (NMLISTVIEW*   pNMLV,  LRESULT* pResult);
	afx_msg void OnKeyDown       (NMLVKEYDOWN*  pNMKD,  LRESULT* pResult);
	afx_msg void OnColumnClick   (NMLISTVIEW*   pNMLV,  LRESULT* pResult);
	afx_msg void OnBeginDrag     (NMLISTVIEW*   pNMLV,  LRESULT* pResult);
	afx_msg void OnBeginLabelEdit(NMLVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnEndLabelEdit  (NMLVDISPINFO* pNMDI,  LRESULT* pResult);
	afx_msg void OnApercu();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
