// Options.h


#ifndef _OPTIONS_H_
#define _OPTIONS_H_
#if _MSC_VER>1000
#pragma once
#endif


// Valeur               Type utilis
// nAffichageSouris     AFFICHAGESOURIS
// nAffichageSouris1    AFFICHAGESOURIS1
// nDossiersExtract     DOSSIERS3
// nDossiersAjout       DOSSIERS3
// nDossiersTemp        DOSSIERS2
// nDossiersDrag        DOSSIERS2


#define ManipulerPage(fonction) \
	fonction(General) \
	fonction(Affichage) \
	fonction(Apercu) \
	fonction(Comp) \
	fonction(Progress) \
	fonction(Dossiers) \
	fonction(Confirm) \
	fonction(Shell)


#define ManipulerValeurGeneral(fonction, fonction2) \
	fonction(fonction2, General, BOOL, f,OuvrirAuto,         FALSE) \
	fonction(fonction2, General, BOOL, f,AssocVerifAuto,     TRUE) \
	fonction(fonction2, General, BOOL, f,Commentaire,        TRUE) \
	fonction(fonction2, General, BOOL, f,Corbeille,          TRUE) \
	fonction(fonction2, General, BOOL, f,TjVisible,          FALSE) \
	fonction(fonction2, General, BOOL, f,SupprDossierVide,   TRUE) \
	fonction(fonction2, General, UINT, n,MRU,                4)
#define ManipulerChaineGeneral(fonction, fonction2)

#define ManipulerValeurAffichage(fonction, fonction2) \
	fonction(fonction2, Affichage, BOOL, f,Grille,             FALSE) \
	fonction(fonction2, Affichage, BOOL, f,SelLigne,           FALSE) \
	fonction(fonction2, Affichage, BOOL, f,ModifHeure,         FALSE) \
	fonction(fonction2, Affichage, int,  n,Souris,             afsWindows) \
	fonction(fonction2, Affichage, int,  n,Souris1,            afssJamais)
#define ManipulerChaineAffichage(fonction, fonction2)

#define ManipulerValeurApercu(fonction, fonction2) \
	fonction(fonction2, Apercu, BOOL, f,MAJAuto,            TRUE) \
	fonction(fonction2, Apercu, BOOL, f,DefautTexte,        TRUE) \
	fonction(fonction2, Apercu, UINT, n,Taille,              500) \
	fonction(fonction2, Apercu, BOOL, f,PoliceTout,         TRUE)
#define ManipulerChaineApercu(fonction, fonction2) \
	fonction(fonction2, Apercu, PolicePlus, _T(""))

#define ManipulerValeurComp(fonction, fonction2) \
	fonction(fonction2, Comp, BOOL, f,OptionsDropMuzip,   TRUE) \
	fonction(fonction2, Comp, BOOL, f,OptionsDropMenu,    TRUE) \
	fonction(fonction2, Comp, BOOL, f,OptionsDropArchive, TRUE) \
	fonction(fonction2, Comp, BOOL, f,GZipExtAjouter,     FALSE) \
	fonction(fonction2, Comp, BOOL, f,RmProp,             TRUE) \
	fonction(fonction2, Comp, BOOL, f,RmMove,             TRUE) \
	fonction(fonction2, Comp, BOOL, f,RmAmovible,         TRUE) \
	fonction(fonction2, Comp, UINT, n,RmTaille,           1)
#define ManipulerChaineComp(fonction, fonction2) \
	fonction(fonction2, Comp, PasCompExt, _T("arc;arj;b64;bhx;cab;gz;hqx;lzh;taz;tgz;tz;z;zip;zoo")) \
	fonction(fonction2, Comp, GZipExt,    _T("tgz"))

#define ManipulerValeurProgress(fonction, fonction2) \
	fonction(fonction2, Progress, BOOL, f,AfficherMuzip,      TRUE) \
	fonction(fonction2, Progress, BOOL, f,AfficherDrop,       TRUE) \
	fonction(fonction2, Progress, BOOL, f,AfficherExplorer,   TRUE) \
	fonction(fonction2, Progress, BOOL, f,Detail,             TRUE) \
	fonction(fonction2, Progress, UINT, n,Delai,              1000)
#define ManipulerChaineProgress(fonction, fonction2)

#define ManipulerValeurDossiers(fonction, fonction2) \
	fonction(fonction2, Dossiers, int,  n,Ajout,              0) \
	fonction(fonction2, Dossiers, int,  n,Extract,            0) \
	fonction(fonction2, Dossiers, int,  n,Temp,               0) \
	fonction(fonction2, Dossiers, int,  n,Drag,               0)
#define ManipulerChaineDossiers(fonction, fonction2) \
	fonction(fonction2, Dossiers, Ajout,      _T("")) \
	fonction(fonction2, Dossiers, Extract,    _T("")) \
	fonction(fonction2, Dossiers, Temp,       _T("")) \
	fonction(fonction2, Dossiers, Drag,       _T(""))

#define ManipulerValeurConfirm(fonction, fonction2) \
	fonction(fonction2, Confirm, BOOL, f,Maj,                TRUE) \
	fonction(fonction2, Confirm, BOOL, f,CompModif,          TRUE) \
	fonction(fonction2, Confirm, BOOL, f,DecompTar,          TRUE) \
	fonction(fonction2, Confirm, BOOL, f,Ignorer,            TRUE) \
	fonction(fonction2, Confirm, BOOL, f,PlusPlusieurs,      TRUE) \
	fonction(fonction2, Confirm, BOOL, f,OuvrirNotepad,      TRUE) \
	fonction(fonction2, Confirm, BOOL, f,Ecraser,            TRUE) \
	fonction(fonction2, Confirm, BOOL, f,FileDelete,         TRUE) \
	fonction(fonction2, Confirm, BOOL, f,ArchiveMoins,       TRUE)
#define ManipulerChaineConfirm(fonction, fonction2)



#define ManipulerValeurComplet(fonction, fonction2) \
	ManipulerValeurGeneral  (fonction, fonction2) \
	ManipulerValeurAffichage(fonction, fonction2) \
	ManipulerValeurApercu   (fonction, fonction2) \
	ManipulerValeurComp     (fonction, fonction2) \
	ManipulerValeurProgress (fonction, fonction2) \
	ManipulerValeurDossiers (fonction, fonction2) \
	ManipulerValeurConfirm  (fonction, fonction2)

#define ManipulerChaineComplet(fonction, fonction2) \
	ManipulerChaineGeneral  (fonction, fonction2) \
	ManipulerChaineAffichage(fonction, fonction2) \
	ManipulerChaineApercu   (fonction, fonction2) \
	ManipulerChaineComp     (fonction, fonction2) \
	ManipulerChaineProgress (fonction, fonction2) \
	ManipulerChaineDossiers (fonction, fonction2) \
	ManipulerChaineConfirm  (fonction, fonction2)


#define ManipulerAutreComplet(fonction, fonction2) \
	fonction(fonction2, Affichage, UINT, n,StyleEx,            0)



// Rajouter le type CString et le prfixe 's' aux chanes
#define fnManipulerMembres1(fonction, page, type, prefixe, nom, defaut) \
	fonction(page, type,    prefixe, nom, defaut)
#define fnManipulerMembres2(fonction, page,                nom, defaut) \
	fonction(page, CString, s,       nom, defaut)
#define ManipulerMembres(fonction) \
	ManipulerValeurComplet(fnManipulerMembres1, fonction) \
	ManipulerChaineComplet(fnManipulerMembres2, fonction)


// Macros Manipuler sans 'fonction2'
#define fnManipulerValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(type, ##prefixe##page##nom, defaut)
#define ManipulerValeur(fonction) \
	ManipulerValeurComplet(fnManipulerValeur, fonction) \
	ManipulerAutreComplet( fnManipulerValeur, fonction)
#define fnManipulerChaine(fonction, page, nom, defaut) \
	fonction(##page##nom, defaut)
#define ManipulerChaine(fonction) \
	ManipulerChaineComplet(fnManipulerChaine, fonction)

// Macros Manipuler sans 'fonction' et avec le nom complet de la valeur
#define fnManipulerNomPageValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(##type, ##prefixe##page##nom, defaut)
#define fnManipulerNomPageChaine(fonction, page,                nom, defaut) \
	fonction(CString, s##page##nom, defaut)
#define ManipulerNomPage(fonction) \
	ManipulerValeurComplet(fnManipulerNomPageValeur, fonction) \
	ManipulerAutreComplet( fnManipulerValeur,        fonction) \
	ManipulerChaineComplet(fnManipulerNomPageChaine, fonction)

#define fnManipulerNomValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(##type, ##prefixe##nom, defaut)
#define fnManipulerNomChaine(fonction, page,                nom, defaut) \
	fonction(CString, s##nom, defaut)
#define fndclMembresNom(type, nom, defaut)  type m_##nom;
#define dclMembresDePage(page) \
	ManipulerValeur##page(fnManipulerNomValeur, fndclMembresNom) \
	ManipulerChaine##page(fnManipulerNomChaine, fndclMembresNom)


// Longueur totale de toutes les chanes (somme de _opt.m_len*)
#define fnTotalLen(nom, defaut)  _opt.m_len##nom +
#define TotalLen   (ManipulerChaine(fnTotalLen) 0)


enum AFFICHAGESOURIS
{
	afsWindows,
	afsClicUn,
	afsClicDeux,
};
enum AFFICHAGESOURIS1
{
	afssJamais,
	afssPointe,
	afssToujours,
};

enum DOSSIERS3
{
	opdArchive,
	opdDernier,
	opdPrecis,
};
enum DOSSIERS2
{
	opdtAuto,
	opdtPrecis,
};

enum REPARER
{
	repNon,
	repPresumer,
	repVerifier,
	repAltere,
};


// Options gnrales
class COptions
{
public:  // Fonctions
	
	COptions() : m_lstPasCompExt(true) {}
	
	void Load();
	void Save();
	
	void Appliquer();
	void MAJAffichageStyleEx();
	void MAJPasCompExt();
	
	bool GetDossierTemp(LPTSTR pszDossier) const;
	bool GetDossierDrag(LPTSTR pszDossier) const;
	
	
public:  // Donnes
	
	#define dclMembre(type, nom, defaut)  type m_##nom;
	ManipulerNomPage(dclMembre)
	#undef  dclMembre
	
	CLstStr2 m_lstPasCompExt;   // Extensions  ne pas compresser
	REPARER  m_nReparer;        // Niveau de rparation
};


extern COptions e_opt;


#endif
