// PlusItem.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "PlusItem.h"

#include "Fichier.h"
#include "Dossier.h"

#include "dlgAjouter.h"


//*** CPlusItem

// Affectation
CPlusItem& CPlusItem::operator = (const CPlusItem& pi)
{
	*(PLUSOPTIONS*)this = (PLUSOPTIONS)pi;
	
	DA_rdC     = pi.DA_rdC;
	DA_rdM     = pi.DA_rdM;
	
	TA_nActive = pi.TA_nActive;
	TA_nOp     = pi.TA_nOp;
	TA_uTaille = pi.TA_uTaille;
	TA_nUnite  = pi.TA_nUnite;
	
	AT_nR      = pi.AT_nR;
	AT_nH      = pi.AT_nH;
	AT_nS      = pi.AT_nS;
	AT_nA      = pi.AT_nA;
	
	OP_fSous   = pi.OP_fSous;
	OP_fCache  = pi.OP_fCache;
	
	return *this;
}


// E/S
void CPlusItem::Serialize(CArchive& ar, WORD verPI)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		ar << DO_sFiltre;
		ar.Write((FILTREOPTIONS*)this, sizeof(FILTREOPTIONS));
		
		switch (verPI) {
			case verPlusItem1:  ar.Write((PLUSOPTIONS1*)this, sizeof(PLUSOPTIONS1));  break;
			case verPlusItem2:  ar.Write((PLUSOPTIONS2*)this, sizeof(PLUSOPTIONS2));  break;
		}
		
		
	}else{
		// Chargement
		
		ar >> DO_sFiltre;
		if (verPI==verPlusItem1) {
			// On a supprim une valeur de la structure  partir de verPlusItem2:
			// il faut lire en deux parties
			ar.Read((FILTREOPTIONS*)this, sizeof(DA_rdC)+sizeof(DA_rdM));
			// Ignorer la valeur supprime
			BYTE abIgnore[sizeof(CRechDate)];
			ar.Read(abIgnore, sizeof(CRechDate));
			// Lire la suite
			ar.Read(&TA_nActive, sizeof(FILTREOPTIONS)-(sizeof(DA_rdC)+sizeof(DA_rdM)));
		}else
			ar.Read((FILTREOPTIONS*)this, sizeof(FILTREOPTIONS));
		
		switch (verPI) {
			case verPlusItem1:  ar.Read((PLUSOPTIONS1*)this, sizeof(PLUSOPTIONS1));  break;
			case verPlusItem2:  ar.Read((PLUSOPTIONS2*)this, sizeof(PLUSOPTIONS2));  break;
		}
		
		// Initialiser pour les anciennes versions
		if (verPI<verPlusItem2)  CO_fQueNouveau = FALSE;
	}
}


// Demander la spcification (liste de fichiers, dossiers...)
bool CPlusItem::DemanderSpec()
{
	return (CDlgAjouter(this).DoModal()==IDOK);
}


// Rcuprer les options de compression par dfaut
// pour les oprations extrieures  Muzip
// (glisser-dplacer, menu contextuel...)
// Cela revient  utiliser les options par dfaut
// en enlevant tous les critres restrictifs
void CPlusItem::SetDefautExt()
{
	*this = oApp.s_pi;
	
	CO_nAction         = coaPlusMAJ;
	CO_fActionDeplacer = FALSE;
	CO_fActionNomCourt = FALSE;
	CO_fArchiveMoins   = FALSE;
	CO_fArchiveQue     = FALSE;
	CO_nArbo           = arboSous;
	CO_fQueNouveau     = FALSE;
	
	DA_rdC.fActive     =
	DA_rdM.fActive     = false;
	
	TA_nActive         = 0;
	
	AT_nR              =
	AT_nH              =
	AT_nS              =
	AT_nA              = 2;
	
	OP_fSous           = TRUE;
	OP_fCache          = TRUE;
}


// Lister les parties de la spcification
int CPlusItem::ListerPartie(LPTSTR pszDebut, CLstCString2& lstPartie)
{
	const TCHAR *const pszFiltre = DO_sFiltre;
	const TCHAR *pcIn;
	TCHAR *pcOut;
	POS pos;
	
	// Chercher la chane commune la plus grande
	// au dbut de toutes les parties
	
	// Lister les parties
	TCHAR pszPartie[MAX_PATH];
	pcIn = pszFiltre;
	for (;;) {
		pcOut = pszPartie;
		while (*pcIn && *pcIn!=';')  *pcOut++ = *pcIn++;
		*pcOut = 0;
		lstPartie.AddFin(pszPartie);
		if (!*pcIn)  break;
		pcIn++;
	}
	
	int len;
	if (lstPartie.GetNb()==1) {
		// Une seule partie: la recopier normalement
		lstrcpy(pszDebut, pszFiltre);
		pcOut = _tcsrchr(pszDebut, '\\');
		len = (pcOut) ? pcOut-pszDebut : 0;
	}else{
		
		// Effectuer la recherche
		const TCHAR *pcOK  = pcIn = pszFiltre;
		const TCHAR *pcFin = _tcschr(pcOK, ';');
		for (;;) {
			pcIn = _tcschr(pcIn, '\\');
			if (!pcIn || (pcFin && pcIn>pcFin))  break;
			
			pos = lstPartie.GetPosDeb();
			lstPartie.GetSuiv(pos);   // Ignorer la premire partie
			                          // car c'est le comparant
			while (pos)
				if (CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
						lstPartie.GetSuiv(pos),pcIn-pszFiltre, pszFiltre,pcIn-pszFiltre)!=CSTR_EQUAL)
					goto Termine;
			
			pcOK = ++pcIn;
		}
	Termine:
		len = pcOK-pszFiltre;
		
		// Recopier le chemin de base
		lstrcpyn(pszDebut, pszFiltre, len+1);
	}
	
	// Retourner la longueur du dossier
	// (= caractres  ignorer dans les parties)
	return len;
}



//*** CArchivePlus

// Constructeur
// Le mode de suppression est fix  aucun
// pour viter des mauvaises surprises  l'utilisateur
// (suppression de tout l'archive sauf des fichiers ajouts...)
CArchivePlus::CArchivePlus(CDossier* pDossier, bool fAutoDel)
	: CLstPlusItem(fAutoDel)
{
	*(ARCHIVEPLUS*)this = oApp.s_arPlus;
	m_nSup = supRien;
	if (pDossier)  m_sDossier = pDossier->m_pszPath;
}

// E/S
void CArchivePlus::Serialize(CArchive& ar, WORD verPI)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		ar << verPI;
		
		ar.Write((ARCHIVEPLUS1*)this, sizeof(ARCHIVEPLUS1));
		if (verPI>=verPlusItem2)  ar << m_sDossier;
		
		// crire les items
		ar << (DWORD)GetNb();
		POS pos = GetPosDeb();
		while (pos)
			GetSuiv(pos)->Serialize(ar, verPI);
		
	}else{
		// Chargement
		
		ar >> verPI;
		if (verPI<verPlusItem1 || verPI>verPlusItem2)
			AfxThrowArchiveException(CArchiveException::badSchema);
		
		ar.Read((ARCHIVEPLUS1*)this, sizeof(ARCHIVEPLUS1));
		if (verPI>=verPlusItem2)  ar >> m_sDossier;
		
		// Initialiser pour les anciennes versions
		if (verPI<verPlusItem2)  m_sDossier.Empty();
		
		// Lire les items
		DWORD nb;
		ar >> nb;
		while (nb) {
			nb--;
			CPlusItem *const ppi = new CPlusItem;
			ppi->Serialize(ar, verPI);
			AddFin(ppi);
		}
	}
}
