// RechDate.cpp
//
// CRechDate - couple de deux dates formant un intervalle


#include "StdAfx.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#include "AppResource.h"
#include "RechDate.h"


// Remplir des donnes extrieures avec la structure
void CRechDate::Export(int& fActive,
		UINT& uJ1, UINT& uM1, UINT& uA1,
		UINT& uJ2, UINT& uM2, UINT& uA2)
{
	fActive = CRechDate::fActive;
	uJ1 = dt1.m_uJour;
	uM1 = dt1.m_uMois;
	uA1 = dt1.m_uAn;
	uJ2 = dt2.m_uJour;
	uM2 = dt2.m_uMois;
	uA2 = dt2.m_uAn;
}

// Remplir la structure avec des donnes extrieures
void CRechDate::Import(int fActive,
		UINT uJ1, UINT uM1, UINT uA1,
		UINT uJ2, UINT uM2, UINT uA2)
{
	CRechDate::fActive = ToBool(fActive);
	dt1.SetD(uJ1, uM1, uA1);
	dt2.SetD(uJ2, uM2, uA2);
}


// Entres/sorties sur un CRechDate
void DDX_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd)
{
	DDX_Check (pDX, nIDC,   rd.fActive);
	DDX_TempsD(pDX, nIDC+1, rd.dt1);
	DDX_TempsD(pDX, nIDC+4, rd.dt2);
}

// Vrifier la validit d'un CRechDate
void DDV_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd)
{
	if (pDX->m_bSaveAndValidate && rd.PasValide()) {
		AfxMessageBox(ERR_DATEINVALIDE);
		pDX->m_hWndLastControl = ::GetDlgItem(*pDX->m_pDlgWnd,
			nIDC+((rd.dt1.PasValide()) ? rd.dt1 : rd.dt2).PasValide());
		pDX->Fail();
	}
}
