// RechDate.h


#ifndef _RECHDATE_H_
#define _RECHDATE_H_
#if _MSC_VER>1000
#pragma once
#endif


class CRechDate
{
public:  // Fonctions
	
	CRechDate() { SetNow(); }
	CRechDate(bool fActive, CTempsDHS& dt1, CTempsDHS& dt2)
		: fActive(fActive), dt1(dt1), dt2(dt2) {}
	
	void Export(int& fActive,
		UINT& uJ1, UINT& uM1, UINT& uA1,
		UINT& uJ2, UINT& uM2, UINT& uA2);
	
	void Import(int fActive,
		UINT uJ1, UINT uM1, UINT uA1,
		UINT uJ2, UINT uM2, UINT uA2);
	
	// Remplir les deux dates avec la date actuelle
	inline void SetNow()
		{
			fActive = false;
			dt1.SetNow();
			dt2.SetNow();
		}
	
	// Indiquer si la date est valide
	inline bool PasValide() const
		{
			return fActive && (dt1.PasValide() || dt2.PasValide());
		}
	
	// Indiquer si la date donne corresond au critre
	inline bool Correspond(const FILETIME ft) const
		{
			const CTempsD dt = ft;
			return dt1<=dt && dt<=dt2;
		}
	
	
public:  // Donnes
	
	bool fActive;  // Prendre en compte la date dans la recherche
	CTempsD dt1;   // Date de dbut de la priode de validit
	CTempsD dt2;   // Date de fin de la priode de validit
};


void DDX_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd);
void DDV_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd);


#endif
