// ScriptDoc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "App.h"
#include "ScriptDoc.h"

#include "MuzipDoc.h"
#include "MuzipView.h"
#include "MuzipArc.h"

#include "dlgArchivePlus.h"
#include "dlgMdp.h"

#include <FileBuf.h>


const DWORD idScript  = 'SZUM';  // MUZS


IMPLEMENT_DYNCREATE(CScriptDoc, CDocument)
BEGIN_MESSAGE_MAP(CScriptDoc, CDocument)
	//{{AFX_MSG_MAP(CScriptDoc)
	ON_COMMAND(ID_SCRIPT_MODIFIER,      OnScriptModifier)
	ON_COMMAND(ID_SCRIPT_EXECUTER,      OnScriptExecuter)
	ON_COMMAND(ID_SCRIPT_OUVRIRARCHIVE, OnScriptOuvrirArchive)
	ON_COMMAND(ID_ARCHIVE_MDP,          OnArchiveMdp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// E/S
void CScriptDoc::Serialize(CArchive& ar)
{
	WORD verScript;   // Version du script
	WORD verPI=0;     // Version des CPlusItem
	
	if (ar.IsStoring()) {
		// Enregistrement
		
		verScript = verScript2;
		ar
			<< idScript
			<< verScript
			<< m_sArchive;
		
		if (verScript>=verScript2)  verPI = verPlusItem2;
		else                        verPI = verPlusItem1;
		
	}else{
		// Lecture
		
		// Vrifier l'ID
		DWORD id;
		ar >> id;
		if (id!=idScript)  AfxThrowArchiveException(CArchiveException::badIndex);
		
		// Vrifier le numro de version
		ar >> verScript;
		if (verScript<verScript1 || verScript>verScript2)
			AfxThrowArchiveException(CArchiveException::badSchema);
		
		// Charger le nom de l'archive  traiter
		ar >> m_sArchive;
	}
	
	m_arPlus.Serialize(ar, verPI);
}


// Supprimer le contenu
void CScriptDoc::DeleteContents()
{
	m_arPlus.DeleteAll();
}


// Modifier
void CScriptDoc::OnScriptModifier()
{
	if (CDlgArchivePlus(NULL, m_arPlus, m_sMdp).DoModal()==IDOK)
		SetModifiedFlag();
}

// Excuter
void CScriptDoc::OnScriptExecuter()
{
	// Ouvrir le fichier pour s'assurer qu'il existe
	CFileRead fr;
	fr.SetVerbeux(false);
	if (fr.Open(m_sArchive, 0, OPEN_ALWAYS))  fr.Close();
	
	// Ouvrir l'archive, y compresser les fichiers, et la refermer
	CMuzipArc *const pArc = OpenArchive(m_sArchive);
	if (!pArc)  return;
	pArc->ArchivePlus(m_arPlus);
	pArc->Release(false);
}

// Ouvrir l'archive
void CScriptDoc::OnScriptOuvrirArchive()
{
	pApp->OpenDocumentFile(m_sArchive);
}


// Mot de passe
void CScriptDoc::OnArchiveMdp()
{
	CDlgMdp(m_sMdp).DoModal();
}
