// ScriptFrame.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "ScriptFrame.h"


IMPLEMENT_DYNCREATE(CScriptFrame, CMDIChildWnd)
BEGIN_MESSAGE_MAP(CScriptFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CScriptFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Cration
int CScriptFrame::OnCreate(CREATESTRUCT* pcs)
{
	if (CMDIChildWnd::OnCreate(pcs)==-1)  return -1;
	
#ifndef _DEBUG
	// Empcher le redessinement lors du redimensionnement
	::SetClassLong(*this, GCL_STYLE, ::GetClassLong(*this, GCL_STYLE)
		& ~CS_HREDRAW & ~CS_VREDRAW);
#endif
	
	return 0;
}


// Tailles
void CScriptFrame::OnGetMinMaxInfo(MINMAXINFO* pmmi)
{
	const CScrollView *const pView = DYNAMIC_DOWNCAST(CScrollView, GetActiveView());
	if (pView) {
		const CSize size = pView->GetTotalSize();
		CRect rc(0,0, size.cx,size.cy);
		AdjustWindowRect(rc, GetStyle(), FALSE);
		pmmi->ptMinTrackSize.x = rc.Width();
		pmmi->ptMinTrackSize.y = rc.Height();
	}
	CMDIChildWnd::OnGetMinMaxInfo(pmmi);
}

// Taille
void CScriptFrame::OnSize(UINT nType, int cx, int cy)
{
	CMDIChildWnd::OnSize(nType, cx, cy);
	
	CView *const pView = GetActiveView();
	if (pView)
		pView->GetDlgItem(IDCSCR)->ShowWindow((nType==SIZE_MAXIMIZED) ? SW_HIDE : SW_SHOW);
}
