// ScriptView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "ScriptView.h"

#include "ScriptDoc.h"


IMPLEMENT_DYNCREATE(CScriptView, CFormView)
BEGIN_MESSAGE_MAP(CScriptView, CFormView)
	//{{AFX_MSG_MAP(CScriptView)
	ON_WM_SIZE()
	ON_WM_DROPFILES()
	ON_EN_CHANGE (IDCTXT_ARCHIVE,   OnTxtArchiveChange)
	ON_BN_CLICKED(IDCCMD_PARCOURIR, OnParcourir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


#if 0
// Contrles
void CScriptView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CScriptView)
	//}}AFX_DATA_MAP
}
#endif


// Initialisation
void CScriptView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	
	CWnd *const pFrame = GetParent();
	
	// Calculer les dimensions idales de la frame
	const CSize size = GetTotalSize();
	CRect rc(0,0, size.cx,size.cy);
	AdjustWindowRect(rc, pFrame->GetStyle(), FALSE);
	
	// Masquer la bordure cliente et redimensionner la frame
	ModifyStyleEx(WS_EX_CLIENTEDGE, 0);
	pFrame->SetWindowPos(NULL, 0,0, rc.Width(),rc.Height(), SWP_NOZORDER | SWP_NOMOVE);
	
	// Initialiser la bote de dialogue
	SetDlgItemText(IDCTXT_ARCHIVE, GetDocument()->m_sArchive);
	DragAcceptFiles();
}


// Taille
void CScriptView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);
	
	// Dplacer galement la case de redimensionnement
	CWnd *const pscr = GetDlgItem(IDCSCR);
	if (pscr)
		pscr->SetWindowPos(NULL,
			cx-GetSystemMetrics(SM_CXHSCROLL),
			cy-GetSystemMetrics(SM_CYHSCROLL),
			0,0, SWP_NOZORDER | SWP_NOSIZE);
}


// Glisser-dplacer
void CScriptView::OnDropFiles(HDROP hDropInfo)
{
	TCHAR pszArchive[MAX_PATH];
	if (DragQueryFile(hDropInfo, 0, pszArchive,nbArray(pszArchive))) {
		// Glisser-dplacer d'une archive
		SetDlgItemText(IDCTXT_ARCHIVE, pszArchive);
		DragFinish(hDropInfo);
	}else
		CFormView::OnDropFiles(hDropInfo);
}


// Nom de l'archive - changement
void CScriptView::OnTxtArchiveChange()
{
	GetDlgItemText(IDCTXT_ARCHIVE, GetDocument()->m_sArchive);
}


// Parcourir
void CScriptView::OnParcourir()
{
	CFileDialog dlg(TRUE, pszExtDefaut, GetDocument()->m_sArchive,
		OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, NULL, this);
	if (oApp.ShowFileOpenDialog(dlg, false))
		SetDlgItemText(IDCTXT_ARCHIVE, dlg.GetPathName());
}
