// Tar.h


#ifndef _TAR_TAR_H_
#define _TAR_TAR_H_
#if _MSC_VER>1000
#pragma once
#endif


struct TARHEADER
{
	char pszPath[100];      // Chemin d'accs, nul final
	char mode[8];           // Spcial Unix
	char idUser [8];        // Spcial Unix
	char idGroup[8];        // Spcial Unix
	char taille[12];        // Taille du fichier (octal ASCII)
	char dtM[12];           // Date de modification (time_t octal ASCII)
	char pszCheckSum[8];    // Checksum de TARHEADER
	char cType;             // Type du fichier
	char pszLien[100];      // Spcial Unix
	char pszMagic[8];       // Flags spciaux, nul final
	char pszNomUser [32];   // Spcial Unix
	char pszNomGroup[32];   // Spcial Unix
	char devMajor[8];       // Spcial Unix
	char devMinor[8];       // Spcial Unix
};

union TARRECORD
{
	BYTE pb[512];
	TARHEADER th;
};

// Le champ CheckSum est rempli d'espaces pendant le calcul du checksum
const char cCheckSumVide = ' ';

// pszMagic
const char pszMagicUG [8] = "ustar  ";   // pszNomUser et pszNomGroup valides
const char pszMagicGNU[8] = "GNUtar ";   // Entre au format GNU


// cType
const char tartNormalUnix = '\0';   // Fichier disque normal compatible Unix
const char tartNormal     = '0';    // Fichier disque normal
const char tartLien       = '1';    // Lien vers un fichier dj archiv (sauter)
const char tartLienSym    = '2';    // Lien symbolique (sauter)
const char tartCar        = '3';    // Fichier spcial de caractre (sauter)
const char tartBloc       = '4';    // Fichier spcial de bloc (sauter)
const char tartRep        = '5';    // Rpertoire
const char tartFIFO       = '6';    // Fichier spcial FIFO (sauter)
const char tartContigu    = '7';    // Fichier contigu (= normal)
//*** Dbut extension GNU
const char tartRepListe   = 'D';    // Liste de fichiers/rperoires (ignorer)
const char tartMultiVol   = 'M';    // Fichier continu sur un autre volume
const char tartHeaderVol  = 'V';    // Header de volume (ignorer)
//*** Fin extension GNU


#endif
