// UnZ.h


#ifndef _Z_UNZ_H_
#define _Z_UNZ_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Fen.h"

#include <FileBuf.h>
#include "../Decomp.h"


class CZipFichier;
class CGZipFichier;
class CHuft;

namespace UNZ
{
	bool InflateInit();
	void InflateClose();
	
#ifdef MUZIPEXE
	bool TesterMDP(const BYTE* pbEnTete, CZipFichier* pzf);
#else
	bool TesterMDP(const BYTE* pbEnTete);
#endif
	
	void InputDeferLeftover();
	void InputUndefer();
	
#ifdef MUZIPEXE
	bool ExtraireZip (CZipFichier*  pzf,  LPCTSTR pszFichierOut);
	bool ExtraireGZip(CGZipFichier* pgzf, LPCTSTR pszFichierOut);
#else
	bool ExtraireZip (LPCTSTR pszFichier, LPCTSTR pszFichierOut);
#endif
	bool Inflate();
	bool InflateDynamic();
	bool InflateStore();
	bool InflateCode(CHuft* tl, CHuft* td, int bl, int bd);
	bool Flush(const void* pv, DWORD len);
	
	extern long  e_lenComp;
	extern BYTE *e_pbIn;
	extern int   e_lenIn;
}


#endif
