// Z/ZipArc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "../Muzip.h"
#include "ZArc.h"

#include "../PlusItem.h"
#include "../CRC32.h"
#include "Fen.h"


long  e_nReste;        // Bits restant  traiter dans la fentre


static CFileRead *s_pfr;     // Fichier Zip en cours de lecture
static DWORD s_nCRC;



// Lire un nouveau tampon dans le fichier d'entre,
// mettre  jour le CRC et la taille du fichier d'entre
// len>=2 (pour conversion des fins de ligne)
DWORD CZArc::LireFichier(BYTE* pbBuf, DWORD len)
{
	if (!len)  return 0;
	
	const DWORD lenLu = s_pfr->ReadLen(pbBuf, len);
	if (lenLu) {
		s_nCRC   = crc32(s_nCRC, pbBuf, lenLu);
		e_lenIn += lenLu;
	}
	
	return lenLu;
}


// Compresser un fichier
DWORD CZArc::Compresser(CFichier* pFichier, CFileRead& fr, CFileWrite& fw,
	DWORD* pnCRC, int nNiveau, ZMETHODE nMethode, WORD* pnAttrI)
{
	DWORD lenC;
	
	s_pfr    = &fr;
	e_lenFen = 0;
	e_lenIn  = 0;
	s_nCRC   = 0;
	
	fw.SetVerbeux(false);
	
	const bool fProgress2 = !(GetCap() & capMaxUnFichier);
	
	TRY
	{
		if (nMethode==zmDeflate) {
			// Compression Deflate
			
			if (fProgress2)  oApp.ShowStatusAvance2(pFichier->m_dwTailleN);
			
			biInit(&fw);
			ctInit(pnAttrI, &nMethode);
			lmInit(nNiveau);
			
				lenC = Deflate();
			
		}else{
			// Pas de compression
			
			const UINT lenBuf = 0x1000;
			if (fProgress2)  oApp.ShowStatusAvance2(pFichier->m_dwTailleN/lenBuf);
			BYTE ab[lenBuf];
			for (;;) {
				const DWORD len = LireFichier(ab, sizeof(ab));
				if (!len)  break;
				Write(ab, len, fw);
				oApp.AddStatusAvance(len);
				oApp.AddStatusAvance2();
			}
			lenC = e_lenIn;
		}
	}
	CATCH_ALL(e)
	{
		e->ReportError();
		lenC = 0;
	}
	END_CATCH_ALL
	
	*pnCRC = s_nCRC;
	return lenC;
}
