// Zip/Zip.h


#ifndef _ZIP_ZIP_H_
#define _ZIP_ZIP_H_
#if _MSC_VER>1000
#pragma once
#endif


// Tampon d'E/S fichier
const size_t lenFileBuf = 32768;


#pragma pack(push,1)

struct HEADERFINSIG
{
	DWORD sig;         // Signature (sigFin)
	WORD  nDisque;     // Numro de ce disque
	WORD  nDisqueD;    // Numro du disque de dpart
	WORD  nbEntry;     // Nombre d'entres sur ce disque
	WORD  nbEntryT;    // Nombre total d'entres
	DWORD nTailleT;    // Taille du rpertoire central entier
	DWORD off;         // Offset du central sur le disque de dpart
	WORD  lenCom;      // Longueur des commentaires du Zip
};
struct HEADERFIN
{
	WORD  nDisque;     // Numro de ce disque
	WORD  nDisqueD;    // Numro du disque de dpart
	WORD  nbEntry;     // Nombre d'entres sur ce disque
	WORD  nbEntryT;    // Nombre total d'entres
	DWORD nTailleT;    // Taille du rpertoire central entier
	DWORD off;         // Offset du central sur le disque de dpart
	WORD  lenCom;      // Longueur des commentaires du Zip
};

struct HEADERLOCSIG
{
	DWORD sig;         // Signature (sigLoc)
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtra;    // Longueur du champ extra
};
struct HEADERLOC
{
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtra;    // Longueur du champ extra
};

struct HEADERLOCEXTSIG
{
	DWORD sig;         // Signature (sigLocExt)
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
};

struct HEADERLOCEXT
{
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
};

struct HEADERCENSIG
{
	DWORD sig;         // Signature (sigCen)
	WORD  nVerC;       // Version du crateur
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse (utilis que pour les E/S)
	DWORD nTailleN;    // Taille dcompresse (utilis que pour les E/S)
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtraC;   // Longueur du champ extra central
	WORD  lenCom;      // Longueur des commentaires
	WORD  nDisque;     // N du disque (si Zip multi-volumes)
	WORD  nAttrI;      // Attributs internes du fichier
	DWORD nAttrE;      // Attributs externes du fichier
	DWORD off;         // Offset du rpertoire local
};
struct HEADERCEN
{
	WORD  nVerC;       // Version du crateur
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse (utilis que pour les E/S)
	DWORD nTailleN;    // Taille dcompresse (utilis que pour les E/S)
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtraC;   // Longueur du champ extra central
	WORD  lenCom;      // Longueur des commentaires
	WORD  nDisque;     // N du disque (si Zip multi-volumes)
	WORD  nAttrI;      // Attributs internes du fichier
	DWORD nAttrE;      // Attributs externes du fichier
	DWORD off;         // Offset du rpertoire local
};

#pragma pack(pop)


const UINT lenSig    =  4;   // Longueur des signatures
const UINT lenEtendu = 16;   // Longueur de l'en-tte tendu

// Signatures des en-ttes
const DWORD sigLoc    = 0x04034B50;
const DWORD sigCen    = 0x02014B50;
const DWORD sigFin    = 0x06054B50;
const DWORD sigLocExt = 0x08074B50;

// Dcalages des valeurs dans les en-ttes
const UINT locVerE       =  0;
const UINT locFlag       =  2;
const UINT locfCrypte    =  1;  // Crypt
const UINT locfEtendu    =  8;  // En-tte local tendu
const UINT locMethode    =  4;
const UINT locDateHeureM =  6;
const UINT locCRC        = 10;
const UINT locTailleC    = 14;
const UINT locTailleN    = 18;
const UINT loclenNom     = 22;
const UINT loclenExtra   = 24;

const UINT extCRC        =  0;
const UINT extTailleC    =  4;
const UINT extTailleN    =  8;

const UINT cenVerC       =  0;
const UINT cenVerE       =  2;
const UINT cenFlag       =  4;
const UINT cenMethode    =  6;
const UINT cenDateHeureM =  8;
const UINT cenCRC        = 12;
const UINT cenTailleC    = 16;
const UINT cenTailleN    = 20;
const UINT cenlenNom     = 24;
const UINT cenlenExtraC  = 26;
const UINT cenlenCom     = 28;
const UINT cenDisque     = 30;
const UINT cenAttrI      = 32;
const UINT cenAttrE      = 34;
const UINT cenOff        = 38;
const UINT cenFin        = 42;

const UINT finDisque     =  0;   // Numro de ce disque
const UINT finDisqueD    =  2;   // Numro du disque de dpart
const UINT finEntry      =  4;   // Nombre d'entres sur ce disque
const UINT finEntryT     =  6;   // Nombre total d'entres
const UINT finTailleT    =  8;   // Taille du rpertoire central entier
const UINT finOff        = 12;   // Offset du central sur le disque de dpart
const UINT finCom        = 16;   // Longueur des commentaires du Zip


// Gestion du champ extra
const UINT ebLenDeb    =     4;  // Longueur de l'en-tte
const UINT ebID        =     0;  // Offset de l'ID du bloc dans l'en-tte
const UINT ebLen       =     2;  // Offset de la longueur des donnes dans l'en-tte

const UINT ebUXMin     =    8;   // Champ "UX" minimal (dtA, dtM)
const UINT ebUXdtA     =    0;   // Offset de atime
const UINT ebUXdtM     =    4;   // Offset de mtime

const UINT ebUXMax     =   12;   // Champ "UX" complet (dtA, dtM, uid, gid)
const UINT ebUXUID     =    8;   // Offset de UID
const UINT ebUXGID     =   10;   // Offset de GID

const UINT ebUTMin     =    1;   // Champ UT minimal
const UINT ebUTFlags   =    0;   // Offset de Flags
const UINT ebUTdt1     =    1;   // Offset de la premire valeur de temps
const UINT ebUTFLdtM   =  1<<0;  // dtM prsent
const UINT ebUTFLdtA   =  1<<1;  // dtA prsent
const UINT ebUTFLdtC   =  1<<2;  // dtC prsent
#define    ebUTLen(n)     (ebUTMin + 4 * (n))

const UINT ebUX2Min    =   4;    // Champ Ux minimal (UID/GID)
const UINT ebUX2UID    =   0;    // Offset de UID
const UINT ebUX2GID    =   2;    // Offset de GID
const UINT ebUX2Valide =   1<<8; // UID/GID prsent


// Valeurs d'erreur
// Les valeurs 0-4 et 12-18 respectent les conventions de PKZIP
// Les valeurs 4-10 sont toutes assignes  "mmoire insuffisante"
// par PKZIP, les codes 5-10 sont donc utiliss  autre chose
enum ZIPERREUR
{
	zeEchec        =  -1,   // Echec
	zeOK           =   0,   // Succs
	zeEOF          =   2,   // Fin de fichier inattendue
	zeStructure    =   3,   // Erreur dans la structure du Zip
	zeMem          =   4,   // Mmoire insuffisante
	zeLogique      =   5,   // Erreur dans le programme
	zeGrand        =   6,   // Entre trop grande pour tre coupe
	zeCom          =   7,   // Format de commentaire invalide
	zeTest         =   8,   // Erreur lors du test du Zip
	zeAnnule       =   9,   // L'utilisateur a annul le processus
	zeTemp         =  10,   // Erreur  l'utilisation de fichiers temporaires
	zeRead         =  11,   // Erreur de lecture ou de parcours
	zeRien         =  12,   // Il n'y a rien  faire
	zeNom          =  13,   // Fichier Zip vide ou manquant
	zeWrite        =  14,   // Erreur d'criture sur disque
	zeCreate       =  15,   // Erreur  la cration d'un fichier
	zeParam        =  16,   // Ligne de commande incorrecte
	zeOpen         =  18,   // Erreur  l'ouverture d'un fichier
};


// Codes d'OS et version
const UINT codeOS  = 0xB00;
const UINT codeVer = 2*10 + 2;


#endif
