// Zip/ZipArc.h


#ifndef _ZIP_ZIPARC_H_
#define _ZIP_ZIPARC_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "../Z/ZArc.h"

class CMuzipException;
class CArchivePlus;
class CFileWrite;
class CZipFichier;


struct CTDATA;


typedef CListePtr2<CZipFichier*> CLstZipFichier;


class CZipArc : public CZArc
{
	friend class CZipFichier;
	
public:  // Fonctions
	
	CZipArc(CInterf* pi);
	
	CMuzipException* OuvrirNormal (CLstZipFichier& lstTrouve);
	CMuzipException* OuvrirReparer(CLstZipFichier& lstTrouve);
	
	bool Compresser(CPlusItem* ppi, CZipFichier* pzf, CFileWrite& fw, LPCTSTR pszFichier);
	
	
public:  // Hritage
	
	int  GetCap()   const;
	UINT GetSfxID() const;
	
	bool OpenDocument();
	void CloseDocument();
	
	void Reconstruire();
	
	bool OpenArchiveTemp (CFileWrite& fw, LPTSTR  pszTemp);
	bool CloseArchiveTemp(CFileWrite& fw, LPCTSTR pszTemp);
	
	CFichier* NewFichier (LPCTSTR pszFichier, const WIN32_FIND_DATA& wfd);
	
	void SetComment(LPCTSTR psz);
	LPCTSTR GetComment() const;
	
	
protected:  // Interne
	
	bool ArchivePlus();
	
	void IgnorerFichier(DWORD offOld, CFichier* pFichier);
	
	
	DWORD  m_offDebut;     // Offset de dpart des structures Zip
	DWORD  m_offCen;       // Offset de dpart du rpertoire central
	
	WORD   m_lenCom;       // Longueur des commentaires
	LPTSTR m_pszCom;       // Commentaires
};


#endif
