// Zip/ZipFichier.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "ZipFichier.h"
#include "Zip.h"

#include "../Z/UnZ.h"

#include "../PlusItem.h"


// Constructeur
CZipFichier::CZipFichier()
{
	m_pszNomI  = NULL;
	m_pszCom   = NULL;
	m_pbExtra  =
	m_pbExtraC = NULL;
}


// Destructeur
CZipFichier::~CZipFichier()
{
	delete [] m_pszNomI;
	delete [] m_pszCom;
	delete [] m_pbExtra;
	delete [] m_pbExtraC;
}


// Fichier crypt ?
bool CZipFichier::IsCrypte() const
{
	return ToBool(m_nFlags & locfCrypte);
}

// Remplir une classe CPlusItem avec les donnes permettant
// de recompresser le fichier  l'identique
void CZipFichier::ToPlusItem(CPlusItem& pi) const
{
	CFichier::ToPlusItem(pi);
	pi.CO_nNiveau = m_nMethode;
}


// Extraire le fichier (spcifique  l'extraction de dossiers)
bool CZipFichier::ExtraireInterne(LPCTSTR pszDest)
{
	return UNZ::ExtraireZip(this, pszDest);
}


// Dfinir les proprits
void CZipFichier::SetProp(DWORD dwAttr, CTempsDHS& dtModif)
{
	// Attributs
	m_nAttrE = dwAttr;
	
	// Date de modification
	SYSTEMTIME st = dtModif;
	FILETIME ft;
	SystemTimeToFileTime(&st, &ft);
	FileTimeToDosDateTime(&ft, ((WORD*)&m_dt)+1, (WORD*)&m_dt);
	
	CFichier::SetProp(dwAttr, dtModif);
}


// Modification des proprits
bool CZipFichier::OnModifProp()
{
	// L'offset du central peut tre indfini,
	// notamment si on a ouvert l'archive en mode rparation
	VERIF(m_offCentral!=0);
	
	// crire l'en-tte local
	VERIF(s_fw.Seek(m_off, FILE_BEGIN) && PutLocal(s_fw));
	
	// crire l'en-tte central
	VERIF(s_fw.Seek(m_offCentral, FILE_BEGIN) && PutCentral(s_fw));
	
	return true;
}
