// Zip/ZipFichier.h


#ifndef _ZIP_ZIPFICHIER_H_
#define _ZIP_ZIPFICHIER_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "../Dossier.h"
#include "../Fichier.h"

#include "../Z/UnZ.h"


#pragma pack(push,1)

class CZipFichier : public CFichier
{
	friend class CZipArc;
	friend bool UNZ::TesterMDP(const BYTE* pbEnTete, CZipFichier* pzf);
	friend bool UNZ::ExtraireZip(CZipFichier* pzf, LPCTSTR pszFichierOut);
	friend bool CDossier::ZipPutCentral(CFileWrite& fw);
	
public:  // Fonctions
	
	CZipFichier();
	~CZipFichier();
	
	
public:  // Hritage
	
	bool IsCrypte() const;
	void ToPlusItem(CPlusItem& pi) const;
	
	bool FichierCopier(CFileRead& fr, CFileWrite& fw);
	
	void SetProp(DWORD dwAttr, CTempsDHS& dtModif);
	bool OnModifProp();
	
	
protected:  // Interne
	
	bool ExtraireInterne(LPCTSTR pszDest);
	
	bool PutLocal  (CFileWrite& fw);
	void PutEtendu (CFileWrite& fw) const;
	bool PutCentral(CFileWrite& fw);
	
	void PreparerNom();
	
	
	WORD   m_nVerC;       // Version du crateur
	WORD   m_nVerE;       // Version ncessaire pour l'extraction
	WORD   m_nFlags2;     // (m_nFlags est aprs)
	WORD   m_nMethode;    // Mthode de compression
	DWORD  m_dt;          // Date de modification
	DWORD  m_nCRC;        // CRC
	DWORD  m_nTailleC;    // Taille compresse (utilis que pour les E/S)
	DWORD  m_nTailleN;    // Taille dcompresse (utilis que pour les E/S)
	WORD   m_lenNom;      // Longueur du nom
	WORD   m_lenExtraC;   // Longueur du champ extra central
	WORD   m_lenCom;      // Longueur des commentaires
	WORD   m_nDisque;     // N du disque (si Zip multi-volumes)
	WORD   m_nAttrI;      // Attributs internes du fichier
	DWORD  m_nAttrE;      // Attributs externes du fichier
	DWORD  m_off;         // Offset du rpertoire local
	
	WORD   m_nFlags;      // Flags gnraux
	WORD   m_lenExtra;    // Longueur du champ extra
	
	BYTE  *m_pbExtra;     // Champ supplmentaire (si m_lenExtra>0)
	BYTE  *m_pbExtraC;    // Champ supplmentaire central (si m_lenExtraC>0)
	LPSTR  m_pszNomI;     // Nom interne du fichier (sparateur '/', toujours ASCII, pas nul final)
	LPTSTR m_pszCom;      // Commentaires (si m_lenCom>0)
	bool   m_fDOS;        // Forcer les attributs MSDOS
	
	DWORD  m_offCentral;  // Offset du rpertoire central
};

#pragma pack(pop)


#endif
