// dlgAssoc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "dlgAssoc.h"

#include "Reg.h"
#include "Options.h"
#include "IOFichier.h"


#if 0
BEGIN_MESSAGE_MAP(CDlgAssoc, CDialog)
	//{{AFX_MSG_MAP(CDlgAssoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgAssoc::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgAssoc)
	DDX_Control(pDX, IDCLST, m_lst);
	//}}AFX_DATA_MAP
}



// Initialisation
BOOL CDlgAssoc::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Crer la liste des filtres
	CString sFilterTous, sFilterAutre, sDefault;
	
	TCHAR pszFichier[MAX_PATH], pszFichierOld[MAX_PATH], pszProg[MAX_PATH];
	CString s, sFilterExt;
	
	
	if (!e_opt.GetDossierTemp(pszFichier))  return TRUE;
	PathAppend(pszFichier, _T("Assoc"));
	TCHAR *pcFichier = &pszFichier[lstrlen(pszFichier)];
	lstrcpy(pszFichierOld, pszFichier);
	TCHAR *pcFichierOld = pszFichierOld + (pcFichier-pszFichier);
	TCHAR pszExt[16];
	
	for (ASSOC *pAssoc=oApp.s_aAssoc; pAssoc->pszAssoc[0]; pAssoc++) {
		
		lstrcpy(pszExt, pAssoc->pszAssoc);
		CharUpper(pszExt);
		lstrcpy(pcFichier, pszExt);
		
		// Pour que FindExecutable fonctionne,
		// il faut que le fichier existe
		if (pAssoc==oApp.s_aAssoc)
			FichierCreer(pszFichier);
		else
			MoveFile(pszFichierOld, pszFichier);
		lstrcpy(pcFichierOld, pcFichier);
		
		if (FindExecutable(pszFichier, NULL, pszProg)>(HINSTANCE)32) {
			// L'extension est associe  un programme
			// Traiter spcialement certains fichiers .exe correspondant 
			// Muzip, CabView, WinZip, WinRar, TurboZip, ZipMagic...
			// en affichant le nom du compresseur au lieu de l'excutable
			
			PathStripPath      (pszProg);
			PathRemoveExtension(pszProg);
			CharUpper(pszProg);
			
			struct PROG
			{
				LPCTSTR pszExe;
				LPCTSTR pszNom;
			};
			const PROG aProg[] =
			{
				{ _T("WINZIP32"), _T("WinZip") },
				{ _T("MUZIP"),    _T("Muzip") },
				{ _T("TURBOZIP"), _T("TurboZIP") },
				{ _T("WINRAR"),   _T("WinRAR") },
				{ _T("ZMOPEN"),   _T("ZipMagic") },
				{ _T("CABVIEW"),  _T("CabView") },
			};
			
			LPCTSTR psz = pszProg;
			for (int iProg=0; iProg<nbArray(aProg); iProg++) {
				if (!lstrcmp(pszProg, aProg[iProg].pszExe)) {
					// Trouv: utiliser le joli nom
					psz = aProg[iProg].pszNom;
					break;
				}
			}
			// Formatter et ajouter l'item  la liste
			s.Format(_T(" %s (%s)"), pszExt, psz);
		}else{
			// L'extension n'est associe  aucun programme
			// L'afficher simplement
			*pszProg = 0;
			s.Format(_T(" %s"), pszExt);
		}
		
		// Ajouter l'item, dfinir les donnes (la structure ASSOC)
		// et cocher l'item si l'extension est associe  Muzip
		const int nItem = m_lst.AddString(s);
		m_lst.SetItemDataPtr(nItem, pAssoc);
		if (!lstrcmpi(pszProg, _T("MUZIP")))  m_lst.SetCheck(nItem, TRUE);
	}
	DeleteFile(pszFichierOld);
	
	
	return TRUE;
}


// OK
void CDlgAssoc::OnOK()
{
	bool fNotify = false;
	
	int nItem = m_lst.GetCount();
	while (nItem) {
		nItem--;
		
		// Rcuprer l'association et l'tat de la case
		ASSOC *const pAssoc = (ASSOC*)m_lst.GetItemDataPtr(nItem);
		const bool fMuzip = ToBool(m_lst.GetCheck(nItem));
		
		// Ouvrir la cl correspondant  l'association
		// et lire l'association courante
		HKEY hKey;
		TCHAR pszValeur[MAX_PATH];
		
		// Regarder si la valeur trouve correspond  l'tat de la case
		// (pszClasseMuzipArchive pour case coche)
		if (pAssoc->GetAssocCur(hKey, pszValeur)!=fMuzip) {
			// Cela ne correspond pas: il faut changer quelque chose
			// (la sauvegarde ou le registre)
			pAssoc->Affecter(fMuzip, hKey, pszValeur);
			fNotify = true;
		}
		
		if (hKey)  RegCloseKey(hKey);
	}
	
	if (fNotify)  ASSOC::NotifyChange();
	
	CDialog::OnOK();
}
