// dlgConfirm.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgConfirm.h"


#if 0
BEGIN_MESSAGE_MAP(CDlgConfirm, CDialog)
	//{{AFX_MSG_MAP(CDlgConfirm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgConfirm::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgConfirm)
	DDX_Check(pDX, IDCCHK_PASCONFIRM, m_fPasConfirm);
	//}}AFX_DATA_MAP
}


// Initialisation
BOOL CDlgConfirm::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Dfinir l'icne
	((CStatic*)GetDlgItem(IDCLBL_QUESTION))->SetIcon(
		oApp.LoadStandardIcon(IDI_QUESTION));
	
	// Dfinir le texte
	SetDlgItemText(IDCLBL, m_pszTexte);
	
	// Dfinir le bouton par dfaut
	CWnd *const pWnd = GetDlgItem((m_fNonDefaut) ? IDCANCEL : IDOK);
	pWnd->ModifyStyle(0, BS_DEFPUSHBUTTON);
	pWnd->SetFocus();
	return FALSE;
}


// Non
void CDlgConfirm::OnCancel()
{
	UpdateData();
	EndDialog(IDCANCEL);
}


// Afficher une bote de dialogue de confirmation
// Passer 0 pour nIDS afin d'utiliser e_sMsg
// Retourner TRUE si l'utilisateur a cliqu sur Oui
bool CDlgConfirm::GetReponse(BOOL& rbConfirm, UINT nIDS, int cfm)
{
	// Si la confirmation est dsactive,
	// faire comme si on avait rpondu oui
	if (oApp.s_nConfirm<=0 || !rbConfirm)  return true;
	
	// Dsactiver les fentres
	HWND hWndTop;
	CWnd::GetSafeOwner_(NULL, &hWndTop);
	oApp.EnableModeless(FALSE);
	
	// Afficher la bote de dialogue
	CDlgConfirm dlgConfirm;
	if (nIDS)  e_sMsg.LoadString(nIDS);
	dlgConfirm.m_pszTexte    = e_sMsg;
	dlgConfirm.m_fNonDefaut  = ToBool(cfm & cfmNonDefaut);
	dlgConfirm.m_fPasConfirm = ToBool(cfm & cfmPlusDemander);
	const bool fOui = (dlgConfirm.DoModal()==IDOK);
	rbConfirm = !dlgConfirm.m_fPasConfirm;
	
	// Ractiver les fentres
	if (hWndTop)  ::EnableWindow(hWndTop, TRUE);
	oApp.EnableModeless(TRUE);
	
	return fOui;
}
