// dlgExtraire.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgExtraire.h"
#include <TrvExplore.h>

#include "MuzipArc.h"
#include "Fichier.h"

#include "Options.h"


BEGIN_MESSAGE_MAP(CDlgExtraire, CDialog)
	//{{AFX_MSG_MAP(CDlgExtraire)
	ON_NOTIFY(TVN_SELCHANGED, IDCTRE_DEST, OnTreDestSelChanged)
	ON_BN_CLICKED(IDCOPT_ACTION_0, OnAction)
	ON_BN_CLICKED(IDCOPT_ACTION_1, OnAction)
	ON_BN_CLICKED(IDCOPT_ACTION_2, OnAction)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgExtraire::CDlgExtraire(const CMuzipArc* pArc, CWnd* pParent)
	: CDialog(IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgExtraire)
	//}}AFX_DATA_INIT
	
	m_ext = oApp.s_ext;
	if (e_opt.m_nDossiersExtract==opdArchive) {
		m_sDest = pArc->m_sPath;
		PathRemoveFileSpec(m_sDest.GetBuffer(MAX_PATH));
		m_sDest.ReleaseBuffer();
	}else
		e_opt.m_sDossiersExtract;
}


// Contrles
void CDlgExtraire::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgExtraire)
	DDX_TrvExplore(pDX, IDCTRE_DEST,         m_treDest, m_sDest);
	DDX_Text      (pDX, IDCTXT_DEST,         m_sDest);
	DDV_MaxChars  (pDX,                      m_sDest, MAX_PATH);
	//}}AFX_DATA_MAP
	DDX_Radio     (pDX, IDCOPT_ACTION_0,     m_ext.m_nAction);
	DDX_Check     (pDX, IDCCHK_ARBO,         m_ext.m_fArbo);
	DDX_Check     (pDX, IDCCHK_ECRASEDEM,    m_ext.m_fEcraseDem);
	DDX_Check     (pDX, IDCCHK_ECRASEDATE,   m_ext.m_fEcraseDate);
	DDX_Check     (pDX, IDCCHK_GARDERERREUR, m_ext.m_fGardeErreur);
	
	if (!pDX->m_bSaveAndValidate)  OnAction();
}


// Arborescence - Slection modifie
void CDlgExtraire::OnTreDestSelChanged(NMTREEVIEW*, LRESULT*)
{
	SetDlgItemText(IDCTXT_DEST, m_treDest.GetPath());
}


// Action
void CDlgExtraire::OnAction()
{
	const BOOL fActive = !IsDlgButtonChecked(IDCOPT_ACTION_1);
	::EnableWindow(::GetDlgItem(*this, IDCCHK_ECRASEDEM),  fActive);
	::EnableWindow(::GetDlgItem(*this, IDCCHK_ECRASEDATE), fActive);
}


// OK
void CDlgExtraire::OnOK()
{
	if (!UpdateData())  return;
	
	// Garder les options,
	// et mmoriser le dernier chemin d'accs si ncessaire
	oApp.s_ext = m_ext;
	if (e_opt.m_nDossiersExtract==opdDernier)
		e_opt.m_sDossiersExtract = m_sDest;
	
	EndDialog(IDOK);
}
