// dlgLister.h


#ifndef _DLGLISTER_H_
#define _DLGLISTER_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <FileBuf.h>

class CMuzipArc;
class CFichier;
class CDossier;

enum
{
	ltHTMLArbo,
	ltHTMLTableau,
	ltHTMLListe,
	ltTexteArbo,
	ltTexteFixe,
	ltTexteTab,
	ltCSV,
	
	ltTexteFixeInit,
};


class CDlgLister : public CDialog
{
public:  // Fonctions
	
	CDlgLister(CMuzipArc* pArc, CWnd* pParent=NULL);
	
	void MajChk(int idChkClic, int idChkAutre);
	
	bool AddDeb(int nProf);
	bool AddFin();
	bool Lister(const CFichier* pFichier);
	bool Lister(const CDossier* pDossier);
	
	
protected:  // Interne
	
	static bool GetQueUneSeuleColonne(int nType)
	{
		return (nType==ltHTMLArbo || nType==ltHTMLListe || nType==ltTexteArbo);
	}
	
	
	CMuzipArc* m_pArc;
	
	CFileWrite m_fw;
	int        m_alenCol[8];
	int        m_nbColF, m_nbColD;   // Pour fichiers et dossiers
	TCHAR      m_cSep;
	
	bool AddSep(int iCol, int nCol, int nbCol, LPCTSTR psz);
	
	
public:  // Donnes
	
	//{{AFX_DATA(CDlgLister)
	enum { IDD = IDD_LISTER };
	int  m_nType;
	BOOL m_fColonne;
	BOOL m_fNom;
	BOOL m_fPath;
	BOOL m_fType;
	BOOL m_fTailleN;
	BOOL m_fTailleC;
	BOOL m_fPC;
	BOOL m_fDtModif;
	BOOL m_fAttr;
	//}}AFX_DATA
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CDlgLister)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CDlgLister)
	afx_msg void OnTypeSelChange();
	virtual void OnOK();
	afx_msg void OnChkNom();
	afx_msg void OnChkPath();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
