// dlgNouveau.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "dlgNouveau.h"

#include "Reg.h"

#include <GUnicode.h>


const LPCTSTR eszGeneralNouveauAjouter = _T("Nouveau ajouter");


BEGIN_MESSAGE_MAP(CDlgNouveau, CFileDialog)
	//{{AFX_MSG_MAP(CDlgNouveau)
	ON_BN_CLICKED(IDCCHK_AJOUTER, OnChkAjouter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
#pragma warning(disable:4706)
CDlgNouveau::CDlgNouveau()
	: CFileDialog(FALSE, pszExtDefaut, NULL,
		OFN_ENABLETEMPLATE | OFN_HIDEREADONLY |
		OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT)
{
	// Crer la liste des filtres
	CString sDefault;
	bool fPrem = true;
	POSITION pos = oApp.GetFirstDocTemplatePosition();
	while (pos) {
		CDocTemplate *const pTemplate = oApp.GetNextDocTemplate(pos);
		if (pTemplate==oApp.s_pmdtScript)  continue;
		
		CString sFilterExt, sFilterName;
		pTemplate->GetDocString(sFilterExt,  CDocTemplate::filterExt);
		pTemplate->GetDocString(sFilterName, CDocTemplate::filterName);
		
		if (fPrem) {
			// Dfinir l'extension par dfaut (sauter le point)
			fPrem = false;
			m_ofn.lpstrDefExt  = ((STRING)sFilterExt)+1;
		}
		
		// Dfinir le filtre
		m_sFilter += sFilterName;
		m_sFilter += '|';
		TCHAR *pc = (TCHAR*)(const TCHAR*)sFilterExt;
		for (;;) {
			m_sFilter += '*';
			
			TCHAR *pcFin = _tcschr(pc, ';');
			if (pcFin)  *pcFin = 0;
			
			m_sFilter += pc;
			
			if (!pcFin)  break;
			m_sFilter += ';';
			*pcFin = ';';
			pc = pcFin+1;
		}
		m_sFilter += '|';
		m_ofn.nMaxCustFilter++;
	}
	
	// Affecter le filtre  la bote de dialogue
	TCHAR *pc = (STRING)m_sFilter;
	while ((pc = _tcschr(pc, '|')))  *pc++ = '\0';
	m_ofn.lpstrFilter = m_sFilter;
	
	// Dfinir le titre et le template
	const int bufTitle = 128;
	m_ofn.lpstrTitle = new TCHAR[bufTitle];
	::LoadString(AfxGetResourceHandle(), IDS_NOUVEAU, (LPTSTR)m_ofn.lpstrTitle, bufTitle);
	SetTemplate(0, IDD_NOUVEAU);
}
#pragma warning(default:4706)


// Initialisation
BOOL CDlgNouveau::OnInitDialog()
{
	CFileDialog::OnInitDialog();
	
	m_fAjouter = ToBool(oApp.GetProfileInt(kszGeneral, eszGeneralNouveauAjouter, true));
	CheckDlgButton(IDCCHK_AJOUTER, m_fAjouter);
	
	// Redfinir le label du bouton OK en Crer
#ifdef UNICODE
	inittoA(pszNouveau, (LPCTSTR)CStringRes(IDS_CMDNOUVEAU), 32);
	SetControlText(IDOK, pszNouveau);
#else
	SetControlText(IDOK, CStringRes(IDS_CMDNOUVEAU));
#endif
	
	return TRUE;
}


// Ajouter - modifi
void CDlgNouveau::OnChkAjouter()
{
	m_fAjouter = ToBool(IsDlgButtonChecked(IDCCHK_AJOUTER));
	oApp.WriteProfileInt(kszGeneral, eszGeneralNouveauAjouter, m_fAjouter);
}
