// dlgPlusItem.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgPlusItem.h"

#include "dlgRech.h"
#include "dlgMdp.h"

#include "MuzipArc.h"
#include "Fichier.h"


BEGIN_MESSAGE_MAP(CDlgPlusItem, CDialog)
	//{{AFX_MSG_MAP(CDlgPlusItem)
	ON_CBN_SELCHANGE(IDCCBO_ACTION, OnActionSelChange)
	ON_BN_CLICKED   (IDCCMD_DEFAUT, OnDefaut)
	ON_BN_CLICKED   (IDCCMD_SPEC,   OnSpec)
	ON_BN_CLICKED   (IDCCMD_FILTRE, OnFiltre)
	ON_BN_CLICKED   (IDCCMD_MDP,    OnMdp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgPlusItem::CDlgPlusItem(CMuzipArc* pArc, CPlusItem& pi, CString& sMdp, bool fPeutSpec, CWnd* pParent)
	: CDialog(IDD, pParent),
	  m_pArc     (pArc),
	  m_pi       (pi),
	  m_sMdp     (sMdp),
	  m_fPeutSpec(fPeutSpec)
{
	*(CPlusItem*)this = m_pi;
	
	//{{AFX_DATA_INIT(CDlgPlusItem)
	//}}AFX_DATA_INIT
}


// Contrles
void CDlgPlusItem::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgPlusItem)
	DDX_CBIndex(pDX, IDCCBO_ACTION,          CO_nAction);
	DDX_CBIndex(pDX, IDCCBO_NIVEAU,          CO_nNiveau);
	DDX_Check  (pDX, IDCCHK_SOUS,            OP_fSous);
	DDX_Check  (pDX, IDCCHK_FILTRE_CACHE,    OP_fCache);
	DDX_Check  (pDX, IDCCHK_ACTION_DEPLACER, CO_fActionDeplacer);
	DDX_Check  (pDX, IDCCHK_ACTION_NOMCOURT, CO_fActionNomCourt);
	DDX_Check  (pDX, IDCCHK_ARCHIVE_MOINS,   CO_fArchiveMoins);
	DDX_Check  (pDX, IDCCHK_ARCHIVE_QUE,     CO_fArchiveQue);
	DDX_Radio  (pDX, IDCOPT_ARBO0,           CO_nArbo);
	//}}AFX_DATA_MAP
}


// Initialisation
BOOL CDlgPlusItem::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	OnActionSelChange();
	
	// Interdir ventuellement:
	// - modification de spcification
	// - slection du niveau de compression
	// - mot de passe
	if (!m_fPeutSpec)    GetDlgItem(IDCCMD_SPEC)->ShowWindow(SW_HIDE);
	if (m_pArc) {
		// Faire attention car m_pArc est nul si c'est pour un script
		const int cap = m_pArc->GetCap();
		if (!(cap & capNiveau))  GetDlgItem(IDCCBO_NIVEAU)->EnableWindow(FALSE);
		if (!(cap & capCrypte))  GetDlgItem(IDCCMD_MDP)   ->EnableWindow(FALSE);
	}
	
	return TRUE;
}


// Action - slection
void CDlgPlusItem::OnActionSelChange()
{
	const BOOL fEnabled = ((CComboBox*)GetDlgItem(IDCCBO_ACTION))->GetCurSel()<coaPasComp;
	const UINT aid[] = {
		IDCCHK_ACTION_DEPLACER,
		IDCCHK_ACTION_NOMCOURT,
		IDCOPT_ARBO0,
		IDCOPT_ARBO1,
		IDCOPT_ARBO2,
		IDCCBO_NIVEAU,
		0
	};
	for (UINT i=0; aid[i]; i++)
		::EnableWindow(::GetDlgItem(*this, aid[i]), fEnabled);
}


// Dfinir par dfaut
void CDlgPlusItem::OnDefaut()
{
	if (UpdateData()) {
		(FILTREOPTIONS&)oApp.s_pi = *(FILTREOPTIONS*)this;
		(PLUSOPTIONS&)  oApp.s_pi = *(PLUSOPTIONS*)  this;
	}
}


// Retoucher la slection de fichiers
void CDlgPlusItem::OnSpec()
{
	m_pi.DemanderSpec();
}

// Filtre avanc
void CDlgPlusItem::OnFiltre()
{
	CDlgRech(false, *this, this).DoModal();
}


// Mot de passe
void CDlgPlusItem::OnMdp()
{
	CDlgMdp(m_sMdp, false, this).DoModal();
}



// OK
void CDlgPlusItem::OnOK()
{
	if (UpdateData()) {
		m_pi = *this;
		EndDialog(IDOK);
	}
}
