// dlgProprietes.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgProprietes.h"

#include "MuzipArc.h"
#include "Dossier.h"
#include "Fichier.h"


#if 0
BEGIN_MESSAGE_MAP(CDlgProprietes, CDialog)
	//{{AFX_MSG_MAP(CDlgProprietes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgProprietes::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	if (m_pFichier) {
		DDX_TempsDHS(pDX, IDCTXT_MODIFJ, m_dtModif);
		DDV_TempsDHS(pDX, IDCTXT_MODIFJ, m_dtModif);
	}
	//{{AFX_DATA_MAP(CDlgProprietes)
	DDX_Check   (pDX, IDCCHK_ATTR_R, m_fAttrR);
	DDX_Check   (pDX, IDCCHK_ATTR_H, m_fAttrH);
	DDX_Check   (pDX, IDCCHK_ATTR_S, m_fAttrS);
	DDX_Check   (pDX, IDCCHK_ATTR_A, m_fAttrA);
	//}}AFX_DATA_MAP
}


// Affichage
int CDlgProprietes::DoModal()
{
	if (m_pDossier)  m_pDossier->ListerFichier(m_lstFichier);
	
	m_pFichier = (!m_pDossier && m_lstFichier.GetNb()==1)
		? m_lstFichier.GetDeb() : NULL;
	
	const DWORD dwAttr = (m_pFichier) ? m_pFichier->m_dwAttr : 0;
	m_fAttrR = ToBool(dwAttr & FILE_ATTRIBUTE_READONLY);
	m_fAttrH = ToBool(dwAttr & FILE_ATTRIBUTE_HIDDEN);
	m_fAttrA = ToBool(dwAttr & FILE_ATTRIBUTE_ARCHIVE);
	m_fAttrS = ToBool(dwAttr & FILE_ATTRIBUTE_SYSTEM);
	if (m_pFichier)  m_dtModif = m_pFichier->m_dtM;
	
	return CDialog::DoModal();
}


// Initialisation
BOOL CDlgProprietes::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	const UINT buf = 128;
	TCHAR psz[buf];
	
	LPCTSTR pszSel;
	
	const CFichier *const pFichier = (m_pDossier) ? NULL : m_lstFichier.GetDeb();
	
	if (m_pFichier) {
		// Un seul fichier slectionn
		
		// Nom
		SetDlgItemText(IDCLBL_NOM, m_pFichier->m_pszNom);
		
		// Type
		SHFILEINFO shfi;
		SHGetFileInfo(m_pFichier->m_pszNom, FILE_ATTRIBUTE_NORMAL,
			&shfi, sizeof(shfi), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
		SetDlgItemText(IDCLBL_TYPE, shfi.szTypeName);
		
	}else{
		// Plusieurs fichiers slectionns
		
		CString s;
		if (m_pDossier) {
			// Dossier
			
			SetDlgItemText(IDCLBL_NOM,   m_pDossier->m_pszNom);
			
			s.Format(IDS_FMTDOSSIER, m_pDossier->GetNbDossier(), m_lstFichier.GetNb());
			SetDlgItemText(IDCLBL_TYPE,  s);
			
			GetDlgItem(IDCLBL_LBLTYPE) ->ShowWindow(SW_HIDE);
			
		}else{
			// Fichiers
			
			s.Format(IDS_FMTFICHIER, m_lstFichier.GetNb());
			
			SetDlgItemText(IDCLBL_NOM,   s);
			GetDlgItem(IDCLBL_LBLNOM)  ->ShowWindow(SW_HIDE);
			
			GetDlgItem(IDCLBL_TYPE)    ->ShowWindow(SW_HIDE);
		}
		
		// Dsactiver le bouton OK
		GetDlgItem(IDOK)->EnableWindow(FALSE);
	}
	
	if (!m_pFichier) {
		// Masquer la date de modification
		GetDlgItem(IDCLBL_LBLDTMODIF)->ShowWindow(SW_HIDE);
		for (int i=IDCTXT_MODIFJ; i<=IDCLBL_MODIFMS; i++)
			GetDlgItem(i)->ShowWindow(SW_HIDE);
	}
	
	if (!m_pFichier || !(m_pFichier->m_pArc->GetCap() & capAttribut)) {
		// Masquer les attributs
		GetDlgItem(IDCLBL_LBLATTR)->ShowWindow(SW_HIDE);
		for (int i=IDCCHK_ATTR_R; i<=IDCCHK_ATTR_S; i++)
			GetDlgItem(i)->ShowWindow(SW_HIDE);
	}
	
	pszSel = (pFichier)
		? pFichier->m_pDossier->m_pszPath
		:           m_pDossier->m_pszPath;
	if (!*pszSel) {
		::LoadString(AfxGetResourceHandle(), IDS_RACINE, psz, buf);
		pszSel = psz;
	}
	SetDlgItemText(IDCLBL_PATH, pszSel);
	
	// Faire la moyenne ou la somme des proprits de chaque fichier
	LONGLONG ddwTailleC = 0;
	LONGLONG ddwTailleN = 0;
	POS pos = m_lstFichier.GetPosDeb();
	while (pos) {
		const CFichier *const pFichier = m_lstFichier.GetSuiv(pos);
		ddwTailleC += pFichier->m_dwTailleC;
		ddwTailleN += pFichier->m_dwTailleN;
	}
	
#ifdef UNICODE
	#define osz  psz
#else
	WCHAR osz[buf];
#endif
	
	// Taille
	StrFormatByteSizeW(ddwTailleN, osz, buf);
#ifndef UNICODE
	WideCharToMultiByte(CP_ACP,0, osz,-1, psz,buf, NULL,NULL);
#endif
	SetDlgItemText(IDCLBL_TAILLE, psz);
	
	// Compress
	StrFormatByteSizeW(ddwTailleC, osz, buf);
#ifndef UNICODE
	WideCharToMultiByte(CP_ACP,0, osz,-1, psz,buf, NULL,NULL);
#endif
	SetDlgItemText(IDCLBL_COMP, psz);
	
#ifdef UNICODE
	#undef osz
#endif
	
	// %
	int nPC = 100;
	if (ddwTailleN)  nPC -= (int)(ddwTailleC*100/ddwTailleN);
	wsprintf(psz, _T("%d %%"), nPC);
	SetDlgItemText(IDCLBL_PC, psz);
	
	return TRUE;
}


// OK
void CDlgProprietes::OnOK()
{
	if (!UpdateData())  return;
	
	ASSERT(ToBool(m_pFichier));
	
	// Modifier le fichier
	// Convertir les attributs
	DWORD dwAttr = 0;
	if (m_fAttrR)  dwAttr |= FILE_ATTRIBUTE_READONLY;
	if (m_fAttrH)  dwAttr |= FILE_ATTRIBUTE_HIDDEN;
	if (m_fAttrA)  dwAttr |= FILE_ATTRIBUTE_ARCHIVE;
	if (m_fAttrS)  dwAttr |= FILE_ATTRIBUTE_SYSTEM;
	
	m_pFichier->SetProp(dwAttr, m_dtModif);
	
	EndDialog(IDOK);
}
