// pgOptionsShell.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "Muzip.h"
#include "pgOptionsShell.h"

#include "Reg.h"
#include "dlgOptions.h"
#include "dlgAssoc.h"


BEGIN_MESSAGE_MAP(CPgOptionsShell, CPropertyPage)
	//{{AFX_MSG_MAP(CPgOptionsShell)
	ON_BN_CLICKED(IDCCHK_MENU,     OnChkMenu)
	ON_BN_CLICKED(IDCCMD_ASSOC,    OnAssoc)
	ON_BN_CLICKED(IDCCMD_DESENREG, OnDesenreg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CPgOptionsShell::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	
#define LISTER(mac) \
	mac(Menu,      MENU) \
	mac(MenuIcone, MENUICONE) \
	mac(MenuSous,  MENUSOUS) \
	mac(Drop,      DROP) \
	mac(InfoBulle, INFOBULLE) \
	
	#define DCL(nom,maj)  BOOL f##nom;
	LISTER(DCL)
	#undef DCL
	
	if (!pDX->m_bSaveAndValidate) {
		// Rcuprer les flags dans le registre
		const UINT nMenu = oApp.GetProfileInt(kszGeneral, eszGeneralShell, gsDefaut);
		#define GET(nom,maj)  f##nom = ToBool(nMenu & gs##nom);
		LISTER(GET)
		#undef GET
	}
	
	#define DX(nom,maj)  DDX_Check(pDX, IDCCHK_##maj, f##nom);
	LISTER(DX)
	#undef DX
	//{{AFX_DATA_MAP(CPgOptionsShell)
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate)
		OnChkMenu();
	else{
		// Enregistrer les flags dans le registre
		int nMenu = 0;
		#define SET(nom,maj)  if (f##nom)  nMenu |= gs##nom;
		LISTER(SET)
		#undef SET
		oApp.WriteProfileInt(kszGeneral, eszGeneralShell, nMenu);
	}
	
#undef LISTER
}


// Menu
void CPgOptionsShell::OnChkMenu()
{
	SetEnabled(this, IDCCHK_MENUICONE,IDCCHK_MENUSOUS, IDCCHK_MENU);
}


// Associations
void CPgOptionsShell::OnAssoc()
{
	bool &fRegister = ((CDlgOptions*)GetParent())->m_fRegister;
	
	if (!fRegister) {
		// Renregistrer Muzip pour que si on modifie les associations
		// les icnes soient visibles sans avoir besoin de fermer
		// la bote de dialogue Options
		// (pas la DLL, cela peut se faire plus tard)
		oApp.Register();
	}
	
	if (CDlgAssoc().DoModal()==IDOK)
		fRegister = true;
	else if (!fRegister)
		// Dsenregistrer Muzip si on a cliqu sur Annuler
		// et qu'il tait dj dsenregistr
		oApp.Unregister();
}


// Dsenregistrer Muzip
void CPgOptionsShell::OnDesenreg()
{
	// Demander confirmation
	if (AfxMessageBox(DEM_UNREGISTER, MB_YESNO | MB_DEFBUTTON2)==IDNO)  return;
	
	oApp.Unregister();
	
	((CDlgOptions*)GetParent())->m_fRegister = false;
	
	AfxMessageBox(WAR_UNREGISTER, MB_ICONINFORMATION);
}
