// ControlBarEx.h
//
// ControlBarEx - classe de base pour les barres d'outils avec effets 3D
//
// REQUIERT
// - ControlBarEx.cpp
// - Application MFC


#ifndef _CONTROLBAREX_H_
#define _CONTROLBAREX_H_
#if _MSC_VER>1000
#pragma once
#endif


// Classe de base
class CBaseBarEx
{
protected:  // Construction/destruction
	
#ifdef TOOLBAREX_LISTE
	CBaseBarEx()
		{
			e_lstBaseBarEx.Add(this);
		}
	
	virtual ~CBaseBarEx()
		{
			e_lstBaseBarEx.Del(this);
		}
#endif
	
	
public:  // Fonctions
	
#ifdef TOOLBAREX_REG
	
	// Entres/sorties avec le registre
	virtual void ToReg  (LPCTSTR pszKey) const = 0;
	virtual void FromReg(LPCTSTR pszKey)       = 0;
	
#endif
};


#ifdef TOOLBAREX_LISTE

class CListeBaseBarEx
{
public:  // Fonctions
	
	CListeBaseBarEx() : m_nb(0), m_a(NULL) {}
	~CListeBaseBarEx() { ASSERT(!m_nb); delete [] m_a; }
	
	void Add(const CControlBar* pBar);
	void Del(const CControlBar* pBar);
	
	bool IsBaseBarEx(const CControlBar* pBar) const;
	
	
protected:  // Interne
	
	int m_nb;
	const CControlBar* *m_a;
};


extern CListeBaseBarEx e_lstBaseBarEx;

#define ISKINDOF_BASEBAREX(p)  e_lstBaseBarEx.IsBaseBarEx((CControlBar*)(p))

#endif


#ifdef TOOLBAREX_REG

// On ne peut pas mettre ces fonctions dans la classe
//  cause de l'hritage virtuel impossible  mettre en oeuvre
// dans CToolBarEx (classe drive de CToolBar elle-mme drive
// de CControlBar)
void ToReg  (const CControlBar* pBar, LPCTSTR pszKey);
void FromReg(      CControlBar* pBar, LPCTSTR pszKey);

#endif


#ifdef TOOLBAREX_MENU
void OnToolBarMenu(CFrameWnd* pFrame);
#endif

#endif
