// Gnew.h
//
// Les fonctions de Gnew quivalent  realloc, mais en utilisant
// exclusivement les oprateurs new et delete
// Elles retournent NULL en cas d'chec
// Si la nouvelle longueur est infrieure  l'ancienne,
// NULL est retourn
//
// REQUIERT
// - Gnew.cpp
// - Application Windows
// - Dans StdAfx.h:
//   #include <string.h>


#ifndef _GNEW_H_
#define _GNEW_H_
#if _MSC_VER>1000
#pragma once
#endif


LPSTR  renew(LPSTR  psz, size_t newlen);
LPWSTR renew(LPWSTR psz, size_t newlen);
template <class T>
T* renew(T* pt, size_t newlen, size_t oldlen);

LPSTR  newDup(LPCSTR  psz);
LPWSTR newDup(LPCWSTR psz);
template <class T>
T* newDup(const T* pt, size_t len);


// Equivalent de realloc avec new et pour tous les types de donnes
template <class T>
T* renew(T* pt, size_t newlen, size_t oldlen)
{
	// Vrifer la validit des longueurs
	if (newlen<oldlen)  return pt;
	
	// Crer le nouveau tampon
	T *const ptTemp = new T[newlen];
	memcpy(ptTemp, pt, oldlen*sizeof(T));
	
	// Y copier le tableau puis dtruire l'ancien
	delete [] pt;
	
	return ptTemp;
}


// Equivalent de strdup mais avec new et pour tous les types
template <class T>
T* newDup(const T* pt, size_t len)
{
	T *const ptNew = new T[len];
	memcpy(ptNew, pt, len*sizeof(T));
	return ptNew;
}


#endif
