// Pidl.h
//
// CPidlManager - aide  la gestion des PIDL et des interfaces IShellFolder
//
// Une seule instance suffit pour cette classe,
// elle est dj cre sous le nom de e_pidlManager


#ifndef _PIDL_H_
#define _PIDL_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <ShlObj.h>


class CPidlManager
{
public:  // Fonctions
	
	CPidlManager()
		{
			SHGetMalloc       (&m_pMalloc);
			SHGetDesktopFolder(&m_psfDesktop);
		}
	
	~CPidlManager()
		{
			m_pMalloc   ->Release();
			m_psfDesktop->Release();
		}
	
	
	void         Free   (void*         pv) { m_pMalloc->Free(pv); }
	ULONG        GetLen (LPCITEMIDLIST pidl);
	LPITEMIDLIST GetLast(LPCITEMIDLIST pidl);
	LPITEMIDLIST Concat (LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
	
	LPITEMIDLIST  GetFile  (LPCTSTR pszFichier);
	LPITEMIDLIST  GetFile  (IShellFolder* psf, LPCTSTR pszFichier);
	IShellFolder* GetFolder(LPCTSTR pszDossier);
	
	operator IMalloc* () { return m_pMalloc; }
	
	IShellFolder* GetDesktop() { return m_psfDesktop; }
	
	
protected:  // Donnes
	
	IMalloc      *m_pMalloc;
	IShellFolder *m_psfDesktop;
};


extern CPidlManager e_pidlManager;


//{{AFX_INSERT_LOCATION}}
#endif
