// ShellMenu.h
//
// CShellMenu - permet de crer des menus ayant le mme contenu
// que le menu contextuel affich par le shell lorsqu'on clique
// droit sur un/des fichier(s) ou un dossier
//
// REQUIERT
// - ShellMenu.cpp
// - Application MFC


#ifndef _SHELLMENU_H_
#define _SHELLMENU_H_
#if _MSC_VER>1000
#pragma once
#endif


const UINT idVerbeMin = 0x0001;
const UINT idVerbeMax = 0x1000;


interface IContextMenu3;


class CShellMenu
{
public:  // Fonctions
	
	CShellMenu() : m_pMenu(NULL), m_pcm(NULL) {}
	~CShellMenu() { Nettoyer(); }
	
	void Nettoyer();
	
	void  SetWnd(CWnd* pWnd) { m_pWnd = pWnd; }
	CWnd* GetWnd() { return m_pWnd; }
	
	void   SetMenu(CMenu* pMenu) { m_pMenu = pMenu; }
	CMenu* GetMenu() { return m_pMenu; }
	
	void InitFolder(IShellFolder* psf);
	void InitFiles(IShellFolder* psf, int nb, const LPCITEMIDLIST* apidl);
	
	bool WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* plResult);
	
	
protected:  // Interne
	
	CWnd          *m_pWnd;      // Fentre grant le menu
	
	int            m_ncm;       // Numro de version (1, 2, ou 3)
	IContextMenu3 *m_pcm;       // Interface du menu courant
	CMenu         *m_pMenu;     // Menu
};


#endif
