// SysObject.h
//
// CSysObject - maintenance des couleurs systmes
//
// Cette classe partage les objets GDI et les couleurs systmes
// entre toutes les barres d'outils, afin d'viter de les stocker
// pour chaque contrle qui les utilise.
//  la rception de WM_SYSCOLORCHANGE, la fonction MAJ()
// doit tre appele
//
// REQUIERT
// - SysObject.cpp
// - Application MFC


#ifndef _SYSOBJECT_H_
#define _SYSOBJECT_H_
#if _MSC_VER>1000
#pragma once
#endif


class CSysObject
{
public:  // Public
	
	static void MAJ();
	
	static CFont    fntGui;
	static COLORREF clBtnFace;
	static COLORREF clBtnHilight;
	static COLORREF clBtnShadow;
	static COLORREF clBtnLight;
	static CBrush   brBtnFace;
	static CBrush   brBtnHilight;
	static CBrush   brBtnShadow;
	static CBrush   brBtnLight;
	
	
private:  // Priv
	
	CSysObject() { MAJ(); }
	static CSysObject s_sysObject;
};


#endif
