// Gnew.cpp
//
// Les fonctions de Gnew quivalent  realloc, mais en utilisant
// exclusivement les oprateurs new et delete
// Elles retournent NULL en cas d'chec
// Si la nouvelle longueur est infrieure  l'ancienne,
// NULL est retourn
//
// REQUIERT
// - Application Windows
// - Dans StdAfx.h:
//   #include <string.h>


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Gnew.h"


// Equivalent de realloc avec new et pour les chanes
LPSTR renew(LPSTR asz, size_t newlen)
{
	// Vrifer la validit des longueurs
	if (strlen(asz)+1>newlen)  return asz;
	
	// Crer le nouveau tampon
	LPSTR aszTemp = new char[newlen];
	if (!aszTemp)  return NULL;
	
	// Y copier la chane puis dtruire l'ancienne
	strcpy(aszTemp, asz);
	delete [] asz;
	return aszTemp;
}
LPWSTR renew(LPWSTR wsz, size_t newlen)
{
	// Vrifer la validit des longueurs
	if (wcslen(wsz)+1>newlen)  return wsz;
	
	// Crer le nouveau tampon
	LPWSTR wszTemp = new WCHAR[newlen];
	if (!wszTemp)  return NULL;
	
	// Y copier la chane puis dtruire l'ancienne
	wcscpy(wszTemp, wsz);
	delete [] wsz;
	return wszTemp;
}


// Equivalent de strdup mais avec new
LPSTR newDup(LPCSTR asz)
{
	const LPSTR aszNew = new char[strlen(asz)+1];
	if (aszNew)  strcpy(aszNew, asz);
	return aszNew;
}
LPWSTR newDup(LPCWSTR wsz)
{
	const LPWSTR wszNew = new WCHAR[wcslen(wsz)+1];
	if (wszNew)  wcscpy(wszNew, wsz);
	return wszNew;
}
