// SysObject.cpp
//
// CSysObject - maintenance des couleurs systmes
//
// Cette classe partage les objets GDI et les couleurs systmes
// entre toutes les barres d'outils, afin d'viter de les stocker
// pour chaque contrle qui les utilise.
//  la rception de WM_SYSCOLORCHANGE, la fonction MAJ()
// doit tre appele
//
// REQUIERT
// - Application MFC


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIFILE
static char THIFILE[] = __FILE__;
#endif
#include "SysObject.h"


CSysObject CSysObject::s_sysObject;
CFont      CSysObject::fntGui;
COLORREF   CSysObject::clBtnFace;
COLORREF   CSysObject::clBtnHilight;
COLORREF   CSysObject::clBtnShadow;
COLORREF   CSysObject::clBtnLight;
CBrush     CSysObject::brBtnFace;
CBrush     CSysObject::brBtnHilight;
CBrush     CSysObject::brBtnShadow;
CBrush     CSysObject::brBtnLight;


// Rcuprer les couleurs systmes
void CSysObject::MAJ()
{
	// Crer la police utilise pour les boutons  texte
	CFont fnt;
	bool fAncien = false;
	if (!fnt.CreateStockObject(DEFAULT_GUI_FONT)) {
		// Les anciennes versions de Windows (NT 3.51 par exemple)
		// n'acceptent pas DEFAULT_GUI_FONT
		VERIFY(fnt.CreateStockObject(SYSTEM_FONT));
		fAncien = true;
	}
	
	LOGFONT lf;
	fnt.GetLogFont(&lf);
	if (fAncien) {
		lf.lfWeight = 400;
		lstrcpy(lf.lfFaceName, _T("MS Sans Serif"));
	}
	lf.lfHeight = 6;
	lf.lfWidth  = 0;  // Laisser Windows calculer
	fntGui.DeleteObject();
	VERIFY(fntGui.CreateFontIndirect(&lf));
	
	clBtnFace    = ::GetSysColor(COLOR_BTNFACE);
	clBtnHilight = ::GetSysColor(COLOR_BTNHILIGHT);
	clBtnShadow  = ::GetSysColor(COLOR_BTNSHADOW);
	clBtnLight   = ::GetSysColor(COLOR_3DLIGHT);
	brBtnFace   .DeleteObject();
	brBtnHilight.DeleteObject();
	brBtnShadow .DeleteObject();
	brBtnFace   .CreateSysColorBrush(COLOR_BTNFACE);
	brBtnHilight.CreateSysColorBrush(COLOR_BTNHILIGHT);
	brBtnShadow .CreateSysColorBrush(COLOR_BTNSHADOW);
	
	// Certains systmes ne font pas la diffrence
	// entre COLOR_BTNFACE et COLOR_3DLIGHT
	brBtnLight.DeleteObject();
	if (clBtnFace==clBtnLight) {
		clBtnLight = clBtnHilight;
		brBtnLight.CreateSysColorBrush(COLOR_BTNHILIGHT);
	}else
		brBtnLight.CreateSysColorBrush(COLOR_3DLIGHT);
}
