// TrvExplore.cpp
//
// CTrvExplore - arborescence
//
// Cette classe gre entirement une arborescence comme celle
// affiche par SHBrowseForFolder()
//
// REQUIERT
// - ShellMenu.cpp, Pidl.cpp
// - Application MFC
// - Dans StdAfx.h:
//   #pragma include_alias("AppResource.h", "../RpertoireProjet/Resource.h")


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include <App.h>
#include "AppResource.h"
#include "TrvExplore.h"

#include <Pidl.h>
#include <GUnicode.h>


BEGIN_MESSAGE_MAP(CTrvExplore, CTreeCtrl)
	//{{AFX_MSG_MAP(CTrvExplore)
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_NOTIFY_REFLECT(NM_RCLICK,         OnRClick)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemExpanding)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT,  OnEndLabelEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Rcuprer le nom du dossier slectionn
CString CTrvExplore::GetPath() const
{
	CString s;
	const HTREEITEM hti = GetSelectedItem();
	if (hti) {
		const LPTSTR pszPath = s.GetBuffer(MAX_PATH);
		if (SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl, pszPath))
			s.ReleaseBuffer();
		else
			s.Empty();
	}
	return s;
}
void CTrvExplore::GetPath(LPTSTR pszPath) const
{
	*pszPath = 0;
	const HTREEITEM hti = GetSelectedItem();
	if (hti)  SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl, pszPath);
}


// Slectionner un dossier
void CTrvExplore::SetPath(LPCTSTR pszPath)
{
	const HTREEITEM hti = PathToItem(pszPath);
	if (hti)  Select(hti, TVGN_CARET);
}


// Retourner l'identificateur de l'item correspondant  un chemin d'accs
HTREEITEM CTrvExplore::PathToItem(LPCTSTR pszPath)
{
	TVITEM tvi;
	tvi.mask  = TVIF_PARAM;
	LPITEMIDLIST pidl;
	LPITEMIDLIST pidlParent = m_pidlMyComputer;
	ULONG len;
	
	// Convertir le chemin d'accs en OLECHAR,
	// et isoler la lettre de lecteur, avec ':' et '\'
	OLECHAR oszPath[MAX_PATH];
	strtoW(oszPath, pszPath, MAX_PATH);
	OLECHAR *pc    = oszPath;
	OLECHAR *pcSep = oszPath;
	while (*pcSep && *pcSep!=':')  pcSep++;
	pcSep++;
	*pcSep++ = '\\';
	
	HTREEITEM htiRetour = NULL;
	
	// Partir du poste de travail et rechercher le lecteur
	IShellFolder *psf = m_psfMyComputer;
	tvi.hItem = m_htiMyComputer;
	for (;;) {
		const OLECHAR cOld = *pcSep;
		*pcSep = 0;
		
		// Rcuprer le PIDL de la partie
		if (psf->ParseDisplayName(NULL, 0, pc,
			&len, &pidl, NULL)!=S_OK)  return NULL;
		// Le concatner avec celui du parent
		// pour rcuprer un PIDL absolu
		const LPITEMIDLIST pidlTemp = e_pidlManager.Concat(pidlParent, pidl);
		e_pidlManager.Free(pidl);
		pidl = pidlTemp;
		
		const HTREEITEM hti = GetChildItem(tvi.hItem);
		if (!hti) {
			Expand(tvi.hItem, TVE_EXPAND);
			tvi.hItem = GetChildItem(tvi.hItem);
		}else
			tvi.hItem = hti;
		while (tvi.hItem) {
			if (!GetItem(&tvi))  continue;
			if (!e_pidlManager.GetDesktop()->CompareIDs(0, pidl, ((ITEMDATA*)tvi.lParam)->pidl)) {
				// Trouv
				
				htiRetour = tvi.hItem;
				
				// Prendre l'item trouv comme item parent
				if (pidlParent!=m_pidlMyComputer)  e_pidlManager.Free(pidlParent);
				pidlParent = pidl;
				psf = ((ITEMDATA*)tvi.lParam)->psf;
				
				break;
			}
			tvi.hItem = GetNextSiblingItem(tvi.hItem);
		}
		
		if (!cOld)  break;
		
		*pcSep = cOld;
		pc = pcSep++;
		while (*pcSep && *pcSep!='\\')  pcSep++;
		if (*pcSep)  pcSep++;
	}
	
	// Nettoyer et retourner
	e_pidlManager.Free(pidlParent);
	return htiRetour;
}


// Cre un nouveau dossier et demande son nom  l'utilisateur
// en ditant l'item du nouveau dossier
void CTrvExplore::NouveauDossier()
{
	Expand(GetFirstVisibleItem(), TVE_EXPAND);
	return;
	
	// Rcuprer le chemin d'accs du dossier slectionn
	HTREEITEM hti = GetSelectedItem();
	if (!hti)  return;
	TCHAR pszDossier[MAX_PATH];
	if (!SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl, pszDossier))  return;
	
	// Y rajouter un nom de dossier jusqu' en trouver un inexistant
	PathAddBackslash(pszDossier);
	TCHAR *pcFin = pszDossier+lstrlen(pszDossier);
	::LoadString(AfxGetResourceHandle(), IDS_NOUVEAUDOSSIER, pcFin, MAX_PATH);
	pcFin += lstrlen(pcFin);
	int nDossier = 1;
	
	for (;;) {
		// Crer le dossier existe dj
Debut:
		if (CreateDirectory(pszDossier, NULL))  break;
		if (GetLastError()!=ERROR_ALREADY_EXISTS) {
			CString sMsg;
			AfxFormatString1(sMsg, ERR_DOSSIERCREER, pszDossier);
			if (AfxMessageBox(sMsg, MB_RETRYCANCEL | MB_ICONEXCLAMATION)==IDCANCEL)
				return;
			goto Debut;
		}
		
		// Le dossier existe dj: passer au suivant
		_stprintf(pcFin, _T(" %d"), ++nDossier);
	}
	
	// Mettre  jour et drouler le dossier parent
	UpdateItem(hti);
	Expand(hti, TVE_EXPAND);
	
	// Rechercher et diter le nouveau dossier
	hti = GetChildItem(hti);
	TCHAR pszTemp[MAX_PATH];
	while (hti) {
		if (!SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl, pszTemp))
			continue;
		if (!lstrcmpi(pszDossier, pszTemp)) {
			// diter le label de l'item
			
			// Donner le style LVS_EDITLABELS  l'arborescence
			const DWORD dwStyle = GetStyle();
			if (!(dwStyle & LVS_EDITLABELS)) {
				::SetWindowLong(m_hWnd, GWL_STYLE, dwStyle | TVS_EDITLABELS);
				m_fFautPasEditLabel = true;
			}
			
			// Donner le focus au label puis l'diter
			SetFocus();
			if (!EditLabel(hti)) {
				// Annulation
				RemoveDirectory(pszDossier);
				DeleteItem(hti);
				if (m_fFautPasEditLabel) {
					m_fFautPasEditLabel = false;
					::SetWindowLong(m_hWnd, GWL_STYLE, dwStyle);
				}
			}
			break;
		}
		hti = GetNextSiblingItem(hti);
	}
}


// Lister un dossier dans l'arborescence
// Retourner TRUE si au moins un item enfant a t ajout
// Ne pas insrer les items petits-enfants si fStop==TRUE
void CTrvExplore::Lister(ITEMDATA* pidParent, HTREEITEM htiParent)
{
	IEnumIDList *peidl;
	if (pidParent->psf->EnumObjects(NULL, SHCONTF_FOLDERS | SHCONTF_INCLUDEHIDDEN, &peidl)!=S_OK)
		return;
	
	SHFILEINFO shfi;
	
	TVINSERTSTRUCT tvis;
	tvis.hParent      = htiParent;
	tvis.hInsertAfter = NULL;
	tvis.item.mask    = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM | TVIF_CHILDREN;
	tvis.item.pszText = shfi.szDisplayName;
	
	bool fAucunAjoute = true;
	ITEMDATA    *pid;
	LPITEMIDLIST pidl;
	while (peidl->Next(1, &pidl, NULL)==S_OK) {
		
		// Rcuprer les attributs du sous-dossier
		ULONG ulAttr = SFGAO_HASSUBFOLDER | SFGAO_FILESYSTEM | SFGAO_FILESYSANCESTOR;
		if (pidParent->psf->GetAttributesOf(1, (LPCITEMIDLIST*)&pidl, &ulAttr)!=S_OK)
			goto Erreur1;
		// Ne prendre que les lments de la FAT ou ceux en contenant
		if (!(ulAttr & SFGAO_FILESYSTEM) && !(ulAttr & SFGAO_FILESYSANCESTOR))
			goto Erreur1;
		
		{
			pid = new ITEMDATA;
			
			// Rcuprer l'interface IShellFolder du sous-dossier
			if (pidParent->psf->BindToObject(pidl, 0, IID_IShellFolder, (void**)&pid->psf)!=S_OK)
				goto Erreur2;
			
			// Concatner les deux PIDL
			if (pidParent->psf!=e_pidlManager.GetDesktop()) {
				pid->pidl = e_pidlManager.Concat(pidParent->pidl, pidl);
				e_pidlManager.Free(pidl);
			}else
				// Le parent est le bureau: pas besoin de concatner
				pid->pidl = pidl;
			
			// Rcuprer les index des icnes et le nom du sous-dossier
			SHGetFileInfo((LPCTSTR)pid->pidl, 0, &shfi, sizeof(shfi),
				SHGFI_PIDL | SHGFI_OPENICON | SHGFI_SYSICONINDEX);
			const int nOpenIcon = shfi.iIcon;
			SHGetFileInfo((LPCTSTR)pid->pidl, 0, &shfi, sizeof(shfi),
				SHGFI_PIDL | SHGFI_DISPLAYNAME | SHGFI_SMALLICON | SHGFI_SYSICONINDEX);
			
			tvis.item.iImage         = shfi.iIcon;
			tvis.item.iSelectedImage = nOpenIcon;
			tvis.item.cChildren      = ToBool(ulAttr & SFGAO_HASSUBFOLDER);
			tvis.item.lParam         = (LPARAM)pid;
			
			// Insrer l'item dans l'arborescence
			InsertItem(&tvis);
			fAucunAjoute = false;
			continue;
		}
		
Erreur2:
		delete pid;
Erreur1:
		e_pidlManager.Free(pidl);
	}
	
	peidl->Release();
	
	if (fAucunAjoute) {
		// Aucun item n'a t ajout:
		// enlever la case +/- de l'item parent
		tvis.item.hItem     = htiParent;
		tvis.item.mask      = TVIF_CHILDREN;
		tvis.item.cChildren = false;
		SetItem(&tvis.item);
	}
}


// Cration
void CTrvExplore::Init()
{
	ASSERT(m_hWnd);
	if (m_pidlMyComputer)  return;
	
	SHFILEINFO shfi;
	
	// Affecter les listes d'images  l'arborescence
	CImageList iml;
	const HIMAGELIST himl = (HIMAGELIST)SHGetFileInfo(_T(""), FILE_ATTRIBUTE_NORMAL,
		&shfi, sizeof(shfi),
		SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	iml.Attach(himl);
	SetImageList(&iml, TVSIL_NORMAL);
	SetImageList(&iml, TVSIL_STATE);
	iml.Detach();
	
	// Crer l'item du bureau
	ITEMDATA *const pid = new ITEMDATA;
	pid->psf = e_pidlManager.GetDesktop();
	
	// Rcuprer les informations sur le bureau
	SHGetSpecialFolderLocation(NULL, CSIDL_DESKTOP, &pid->pidl);
	SHGetFileInfo((LPCTSTR)pid->pidl, 0, &shfi, sizeof(shfi),
		SHGFI_PIDL | SHGFI_OPENICON | SHGFI_SYSICONINDEX);
	const int nOpenIcon = shfi.iIcon;
	SHGetFileInfo((LPCTSTR)pid->pidl, 0, &shfi, sizeof(shfi),
		SHGFI_PIDL | SHGFI_DISPLAYNAME | SHGFI_SMALLICON | SHGFI_SYSICONINDEX);
	
	TVITEM tvi;
	
	// Insrer le bureau dans la liste
	TVINSERTSTRUCT tvis;
	tvis.hParent             = TVI_ROOT;
	tvis.hInsertAfter        = NULL;
	tvis.item.mask           = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM | TVIF_CHILDREN;
	tvis.item.pszText        = shfi.szDisplayName;
	tvis.item.iImage         = shfi.iIcon;
	tvis.item.iSelectedImage = nOpenIcon;
	tvis.item.cChildren      = TRUE;
	tvis.item.lParam         = (LPARAM)pid;
	Lister(pid, tvi.hItem = InsertItem(&tvis));
	
	// Afficher les enfants du bureau
	Expand(GetFirstVisibleItem(), TVE_EXPAND);
	
	// Rcuprer l'item et l'interface du poste de travail
	SHGetSpecialFolderLocation(NULL, CSIDL_DRIVES, &m_pidlMyComputer);
	tvi.hItem = GetChildItem(tvi.hItem);
	tvi.mask  = TVIF_PARAM;
	while (tvi.hItem) {
		GetItem(&tvi);
		if (!e_pidlManager.GetDesktop()->CompareIDs(0, m_pidlMyComputer, ((ITEMDATA*)tvi.lParam)->pidl)) {
			// Trouv
			m_htiMyComputer = tvi.hItem;
			m_psfMyComputer = ((ITEMDATA*)tvi.lParam)->psf;
			break;
		}
		tvi.hItem = GetNextSiblingItem(tvi.hItem);
	}
}

// Destruction
void CTrvExplore::OnDestroy()
{
	// Librer les PIDL et les interfaces
	CleanChildItem(TVI_ROOT);
	e_pidlManager.Free(m_pidlMyComputer);
	m_pidlMyComputer = NULL;
	
	// Dtacher la liste d'images systme de l'arborescence
	SetImageList(NULL, TVSIL_NORMAL)->Detach();
	
	CTreeCtrl::OnDestroy();
}


// Expansion d'item
void CTrvExplore::OnItemExpanding(NMTREEVIEW* pNMTRV, LRESULT* pResult)
{
	*pResult = FALSE;   // Ne pas annuler
	
	// Lister les sous-items si ncessaire
	if (pNMTRV->action==TVE_EXPAND &&
	    !GetChildItem(pNMTRV->itemNew.hItem))
		Lister((ITEMDATA*)pNMTRV->itemNew.lParam, pNMTRV->itemNew.hItem);
}


// Librer la mmoire attache  aux enfants d'un item et  ses enfants
void CTrvExplore::CleanChildItem(HTREEITEM hti)
{
	TVITEM tvi;
	
	hti = GetChildItem(hti);
	while (hti) {
		
		// Rcuprer la structure ITEMDATA de l'item,
		// et regarder s'il a des enfants
		tvi.hItem = hti;
		tvi.mask  = TVIF_PARAM | TVIF_CHILDREN;
		GetItem(&tvi);
		
		// Nettoyer le paramtre de l'item
		if (tvi.lParam) {
			// Librer l'interface, le PID, et la structure
			
			IShellFolder *const psf = ((ITEMDATA*)tvi.lParam)->psf;
			if (psf!=e_pidlManager.GetDesktop())  psf->Release();
			if (psf==m_psfMyComputer)  m_pidlMyComputer = NULL;
			e_pidlManager.Free(((ITEMDATA*)tvi.lParam)->pidl);
			delete (ITEMDATA*)tvi.lParam;
		}
		
		// Nettoyer les enfants si l'item en a
		if (tvi.cChildren)  CleanChildItem(hti);
		
		// Passer  l'item suivant
		hti = GetNextSiblingItem(hti);
	}
}

// Librer les interfaces de l'item et de ses enfants
void CTrvExplore::CleanItem(HTREEITEM hti)
{
	// Rcuprer la structure ITEMDATA de l'item,
	// et regarder s'il a des enfants
	TVITEM tvi;
	tvi.hItem = hti;
	tvi.mask  = TVIF_PARAM | TVIF_CHILDREN;
	GetItem(&tvi);
	
	// Nettoyer le paramtre de l'item
	if (tvi.lParam) {
		// Librer l'interface, le PID, et la structure
		((ITEMDATA*)tvi.lParam)->psf->Release();
		e_pidlManager.Free(((ITEMDATA*)tvi.lParam)->pidl);
		delete (ITEMDATA*)tvi.lParam;
	}
	
	// Nettoyer les enfants si l'item en a
	if (tvi.cChildren)  CleanChildItem(hti);
}

// Mettre  jour le contenu d'un item
void CTrvExplore::UpdateItem(HTREEITEM hti)
{
	// Rcuprer les donnes concernant l'item
	if (!hti)  return;
	ITEMDATA *const pid = (ITEMDATA*)GetItemData(hti);
	if (!pid)  return;
	
	// Dtruire les enfants de l'item en librant les interfaces
	
	// Dtruire puis recrer les enfants de l'item
	HTREEITEM htiChild = GetChildItem(hti);
	while (htiChild) {
		
		// Nettoyer les enfants de l'item
		CleanItem(htiChild);
		
		// Passer  l'item suivant puis dtruire l'item
		const HTREEITEM htiTemp = htiChild;
		htiChild = GetNextSiblingItem(htiChild);
		CTreeCtrl::DeleteItem(htiTemp);
	}
	
	Lister(pid, hti);
}


// Touche enfonce
void CTrvExplore::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar==VK_F5)
		// Mettre  jour l'item slectionn
		UpdateItem(GetSelectedItem());
	else
		CTreeCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
}


// Clic droit
void CTrvExplore::OnRClick(NMHDR*, LRESULT*)
{
	delete m_sm.GetMenu();
	m_sm.Nettoyer();
	
	// Rcuprer l'item cliqu
	CPoint pt;
	GetCursorPos(&pt);
	CPoint ptTemp = pt;
	ScreenToClient(&ptTemp);
	const HTREEITEM hti = HitTest(ptTemp);
	if (!hti)  return;
	
	// Crer le menu lui-mme ds le dbut
	// pour quitter direct en cas d'erreur
	CMenu *const pMenu = new CMenu;
	m_sm.SetMenu(pMenu);
	if (!pMenu->CreatePopupMenu())  return;
	
	// Rcuprer l'interface IContextMenu
	ITEMDATA *const pid = (ITEMDATA*)GetItemData(hti);
	const LPCITEMIDLIST pidl = e_pidlManager.GetLast(pid->pidl);
	m_sm.InitFiles(pid->psf, 1, &pidl);
	m_sm.GetMenu()->TrackPopupMenu(
		TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x,pt.y, this);
}


// Renommage termin
void CTrvExplore::OnEndLabelEdit(NMTVDISPINFO* pNMDI, LRESULT* pResult) 
{
	*pResult = FALSE;
	
	if (m_fFautPasEditLabel) {
		// Enlever le style de renommage
		m_fFautPasEditLabel = false;
		ModifyStyle(TVS_EDITLABELS, 0);
	}
	
	if (pNMDI->item.pszText) {
		// Vrifier la validit du nom propos
		
		HTREEITEM hti = GetParentItem(pNMDI->item.hItem);
		
		// Renommer le rpertoire
		TCHAR pszPath1[MAX_PATH], pszPath2[MAX_PATH];
		if (!SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl,
		     pszPath1))  return;
		lstrcpy(pszPath2, pszPath1);
		PathAppend(pszPath1, GetItemText(pNMDI->item.hItem));
		PathAppend(pszPath2, pNMDI->item.pszText);
		if (!MoveFile(pszPath1, pszPath2))  return;
		
		// Mettre  jour
		UpdateItem(hti);
		hti = GetChildItem(hti);
		while (hti) {
			if (!SHGetPathFromIDList(((ITEMDATA*)GetItemData(hti))->pidl, pszPath1))
				continue;
			if (!lstrcmpi(pszPath1, pszPath2)) {
				// Slectionner l'item
				Select(hti, TVGN_CARET);
				break;
			}
			
			hti = GetNextSiblingItem(hti);
		}
	}
	
	// Renommage effectu
	*pResult = TRUE;
}


// Messages
LPARAM CTrvExplore::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult;
	return (m_sm.WindowProc(uMsg, wParam, lParam, &lResult))
		? lResult
		: CTreeCtrl::WindowProc(uMsg, wParam, lParam);
}


// DDX
void AFXAPI DDX_TrvExplore(CDataExchange* pDX, int nIDC, CTrvExplore& rtre)
{
	if (!pDX->m_bSaveAndValidate) {
		DDX_Control(pDX, nIDC, rtre);
		
		// Autoriser les messages de notification
		_AFX_THREAD_STATE *const pts = AfxGetThreadState();
		const HWND hwndLockoutNotify = pts->m_hLockoutNotifyWindow;
		pts->m_hLockoutNotifyWindow = NULL;
		
		rtre.Init();
		
		// Restaurer comme avant
		pts->m_hLockoutNotifyWindow = hwndLockoutNotify;
	}
}
void AFXAPI DDX_TrvExplore(CDataExchange* pDX, int nIDC, CTrvExplore& rtre, LPCTSTR pszPathInit)
{
	if (!pDX->m_bSaveAndValidate) {
		DDX_Control(pDX, nIDC, rtre);
		
		// Autoriser les messages de notification
		_AFX_THREAD_STATE *const pts = AfxGetThreadState();
		const HWND hwndLockoutNotify = pts->m_hLockoutNotifyWindow;
		pts->m_hLockoutNotifyWindow = NULL;
		
		rtre.Init();
		rtre.SetPath(pszPathInit);
		
		// Restaurer comme avant
		pts->m_hLockoutNotifyWindow = hwndLockoutNotify;
	}
}
